
; / / / / / / / / / / / / / / / / / / / / / / / / / / / / / / / / / / / / / / / / / / /
; / / / / / / / / / / / / / / / / / / / / / / / / / / / / / / / / / / / / / / / / / / /
; / /                                                                               / /
; / /                Copyright 2020 (c) UASM macro assembly library                 / /
; / /                                                                               / /
; / /    Licensed under the Apache License, Version 2.0 (the "License");            / /
; / /    you may not use this file except in compliance with the License.           / /
; / /    You may obtain a copy of the License at                                    / /
; / /                                                                               / /
; / /        http://www.apache.org/licenses/LICENSE-2.0                             / /
; / /                                                                               / /
; / /    Unless required by applicable law or agreed to in writing, software        / /
; / /    distributed under the License is distributed on an "AS IS" BASIS,          / /
; / /    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.   / /
; / /    See the License for the specific language governing permissions and        / /
; / /    limitations under the License.                                             / /
; / /                                                                               / /
; / / / / / / / / / / / / / / / / / / / / / / / / / / / / / / / / / / / / / / / / / / /
; / / / / / / / / / / / / / / / / / / / / / / / / / / / / / / / / / / / / / / / / / / /

    IFNDEF LIMITS_INC
    LIMITS_INC EQU 1
    
    ENDIF
    IFDEF WITHMACROLIB

    IFNDEF MACROLIB_INC
    .ERR <"LIMITS_INC must be included by MACROLIB_INC">
    ENDIF
    
    IFNDEF DEFINES_INC
    .ERR <"LIMITS_INC requires DEFINES_INC">
    ENDIF
    
    IFNDEF X86ORX64
    .ERR <"LIMITS_INC requires one x86 or x64 platform type">
    ENDIF

    IFNDEF BYTE_SIZE
    BYTE_SIZE EQU 1
    ENDIF
    IFNDEF UBYTE_SIZE
    UBYTE_SIZE EQU 1
    ENDIF
    IFNDEF SBYTE_SIZE
    SBYTE_SIZE EQU 1
    ENDIF
    IFNDEF CHAR_SIZE
    CHAR_SIZE EQU 1
    ENDIF
    IFNDEF UCHAR_SIZE
    UCHAR_SIZE EQU 1
    ENDIF
    IFNDEF SCHAR_SIZE
    SCHAR_SIZE EQU 1
    ENDIF
    IFNDEF INT8_SIZE
    INT8_SIZE EQU 1
    ENDIF
    IFNDEF I8_SIZE
    I8_SIZE EQU 1
    ENDIF
    IFNDEF UINT8_SIZE
    UINT8_SIZE EQU 1
    ENDIF
    IFNDEF UI8_SIZE
    UI8_SIZE EQU 1
    ENDIF
    IFNDEF SINT8_SIZE
    SINT8_SIZE EQU 1
    ENDIF
    IFNDEF SI8_SIZE
    SI8_SIZE EQU 1
    ENDIF
    IFNDEF WORD_SIZE
    WORD_SIZE EQU 2
    ENDIF
    IFNDEF UWORD_SIZE
    UWORD_SIZE EQU 2
    ENDIF
    IFNDEF SWORD_SIZE
    SWORD_SIZE EQU 2
    ENDIF
    IFNDEF SHORT_SIZE
    SHORT_SIZE EQU 2
    ENDIF
    IFNDEF USHORT_SIZE
    USHORT_SIZE EQU 2
    ENDIF
    IFNDEF SSHORT_SIZE
    SSHORT_SIZE EQU 2
    ENDIF
    IFNDEF INT16_SIZE
    INT16_SIZE EQU 2
    ENDIF
    IFNDEF I16_SIZE
    I16_SIZE EQU 2
    ENDIF
    IFNDEF UINT16_SIZE
    UINT16_SIZE EQU 2
    ENDIF
    IFNDEF UI16_SIZE
    UI16_SIZE EQU 2
    ENDIF
    IFNDEF SINT16_SIZE
    SINT16_SIZE EQU 2
    ENDIF
    IFNDEF SI16_SIZE
    SI16_SIZE EQU 2
    ENDIF
    IFNDEF DWORD_SIZE
    DWORD_SIZE EQU 4
    ENDIF
    IFNDEF UDWORD_SIZE
    UDWORD_SIZE EQU 4
    ENDIF
    IFNDEF SDWORD_SIZE
    SDWORD_SIZE EQU 4
    ENDIF
    IFNDEF LONG_SIZE
    LONG_SIZE EQU 4
    ENDIF
    IFNDEF ULONG_SIZE
    ULONG_SIZE EQU 4
    ENDIF
    IFNDEF SLONG_SIZE
    SLONG_SIZE EQU 4
    ENDIF
    IFNDEF BOOL_SIZE
    BOOL_SIZE EQU 4
    ENDIF
    IFNDEF INT_SIZE
    INT_SIZE EQU 4
    ENDIF
    IFNDEF UINT_SIZE
    UINT_SIZE EQU 4
    ENDIF
    IFNDEF SINT_SIZE
    SINT_SIZE EQU 4
    ENDIF
    IFNDEF INT32_SIZE
    INT32_SIZE EQU 4
    ENDIF
    IFNDEF I32_SIZE
    I32_SIZE EQU 4
    ENDIF
    IFNDEF UINT32_SIZE
    UINT32_SIZE EQU 4
    ENDIF
    IFNDEF UI32_SIZE
    UI32_SIZE EQU 4
    ENDIF
    IFNDEF SINT32_SIZE
    SINT32_SIZE EQU 4
    ENDIF
    IFNDEF SI32_SIZE
    SI32_SIZE EQU 4
    ENDIF
    IFNDEF QWORD_SIZE
    QWORD_SIZE EQU 8
    ENDIF
    IFNDEF UQWORD_SIZE
    UQWORD_SIZE EQU 8
    ENDIF
    IFNDEF SQWORD_SIZE
    SQWORD_SIZE EQU 8
    ENDIF
    IFNDEF LONGLONG_SIZE
    LONGLONG_SIZE EQU 8
    ENDIF
    IFNDEF ULONGLONG_SIZE
    ULONGLONG_SIZE EQU 8
    ENDIF
    IFNDEF SLONGLONG_SIZE
    SLONGLONG_SIZE EQU 8
    ENDIF
    IFNDEF INT64_SIZE
    INT64_SIZE EQU 8
    ENDIF
    IFNDEF I64_SIZE
    I64_SIZE EQU 8
    ENDIF
    IFNDEF UINT64_SIZE
    UINT64_SIZE EQU 8
    ENDIF
    IFNDEF UI64_SIZE
    UI64_SIZE EQU 8
    ENDIF
    IFNDEF SINT64_SIZE
    SINT64_SIZE EQU 8
    ENDIF
    IFNDEF SI64_SIZE
    SI64_SIZE EQU 8
    ENDIF
    IFNDEF FLOAT16_SIZE
    FLOAT16_SIZE EQU 2
    ENDIF
    IFNDEF BFLOAT16_SIZE
    BFLOAT16_SIZE EQU 2
    ENDIF
    IFNDEF FLT16_SIZE
    FLT16_SIZE EQU 2
    ENDIF
    IFNDEF BFLT16_SIZE
    BFLT16_SIZE EQU 2
    ENDIF
    IFNDEF REAL4_SIZE
    REAL4_SIZE EQU 4
    ENDIF
    IFNDEF FLOAT_SIZE
    FLOAT_SIZE EQU 4
    ENDIF
    IFNDEF FLT_SIZE
    FLT_SIZE EQU 4
    ENDIF
    IFNDEF REAL8_SIZE
    REAL8_SIZE EQU 8
    ENDIF
    IFNDEF DOUBLE_SIZE
    DOUBLE_SIZE EQU 8
    ENDIF
    IFNDEF DBL_SIZE
    DBL_SIZE EQU 8
    ENDIF

    IFNDEF BYTE_MAX
    BYTE_MAX EQU 0xff
    ENDIF
    IFNDEF UBYTE_MAX
    UBYTE_MAX EQU 0xff
    ENDIF
    IFNDEF CHAR_MAX
    CHAR_MAX EQU BYTE_MAX
    ENDIF
    IFNDEF UCHAR_MAX
    UCHAR_MAX EQU UBYTE_MAX
    ENDIF
    IFNDEF INT8_MAX
    INT8_MAX EQU BYTE_MAX
    ENDIF
    IFNDEF I8_MAX
    I8_MAX EQU BYTE_MAX
    ENDIF
    IFNDEF UINT8_MAX
    UINT8_MAX EQU UBYTE_MAX
    ENDIF
    IFNDEF UI8_MAX
    UI8_MAX EQU UBYTE_MAX
    ENDIF
    IFNDEF UBYTE_MIN
    UBYTE_MIN EQU 0x0
    ENDIF
    IFNDEF UCHAR_MIN
    UCHAR_MIN EQU UBYTE_MIN
    ENDIF
    IFNDEF UINT8_MIN
    UINT8_MIN EQU UBYTE_MIN
    ENDIF
    IFNDEF UI8_MIN
    UI8_MIN EQU UBYTE_MIN
    ENDIF
    IFNDEF SBYTE_MAX
    SBYTE_MAX EQU 0x7f
    ENDIF
    IFNDEF SCHAR_MAX
    SCHAR_MAX EQU SBYTE_MAX
    ENDIF
    IFNDEF SINT8_MAX
    SINT8_MAX EQU SBYTE_MAX
    ENDIF
    IFNDEF SI8_MAX
    SI8_MAX EQU SBYTE_MAX
    ENDIF
    IFNDEF BYTE_MIN
    BYTE_MIN EQU (-0x7f - 0x1)
    ENDIF
    IFNDEF SBYTE_MIN
    SBYTE_MIN EQU (-0x7f - 0x1)
    ENDIF
    IFNDEF CHAR_MIN
    CHAR_MIN EQU BYTE_MIN
    ENDIF
    IFNDEF SCHAR_MIN
    SCHAR_MIN EQU SBYTE_MIN
    ENDIF
    IFNDEF INT8_MIN
    INT8_MIN EQU BYTE_MIN
    ENDIF
    IFNDEF I8_MIN
    I8_MIN EQU BYTE_MIN
    ENDIF
    IFNDEF SINT8_MIN
    SINT8_MIN EQU SBYTE_MIN
    ENDIF
    IFNDEF SI8_MIN
    SI8_MIN EQU SBYTE_MIN
    ENDIF

    IFNDEF MAX_BYTE
    MAX_BYTE EQU 0xff
    ENDIF
    IFNDEF MAX_UBYTE
    MAX_UBYTE EQU 0xff
    ENDIF
    IFNDEF MAX_CHAR
    MAX_CHAR EQU MAX_BYTE
    ENDIF
    IFNDEF MAX_UCHAR
    MAX_UCHAR EQU MAX_UBYTE
    ENDIF
    IFNDEF MAX_INT8
    MAX_INT8 EQU MAX_BYTE
    ENDIF
    IFNDEF MAX_I8
    MAX_I8 EQU MAX_BYTE
    ENDIF
    IFNDEF MAX_UINT8
    MAX_UINT8 EQU MAX_UBYTE
    ENDIF
    IFNDEF MAX_UI8
    MAX_UI8 EQU MAX_UBYTE
    ENDIF
    IFNDEF MIN_UBYTE
    MIN_UBYTE EQU 0x0
    ENDIF
    IFNDEF MIN_UCHAR
    MIN_UCHAR EQU MIN_UBYTE
    ENDIF
    IFNDEF MIN_UINT8
    MIN_UINT8 EQU MIN_UBYTE
    ENDIF
    IFNDEF MIN_UI8
    MIN_UI8 EQU MIN_UBYTE
    ENDIF
    IFNDEF MAX_SBYTE
    MAX_SBYTE EQU 0x7f
    ENDIF
    IFNDEF MAX_SCHAR
    MAX_SCHAR EQU MAX_SBYTE
    ENDIF
    IFNDEF MAX_SINT8
    MAX_SINT8 EQU MAX_SBYTE
    ENDIF
    IFNDEF MAX_SI8
    MAX_SI8 EQU MAX_SBYTE
    ENDIF
    IFNDEF MIN_BYTE
    MIN_BYTE EQU (-0x7f - 0x1)
    ENDIF
    IFNDEF MIN_SBYTE
    MIN_SBYTE EQU (-0x7f - 0x1)
    ENDIF
    IFNDEF MIN_CHAR
    MIN_CHAR EQU MIN_BYTE
    ENDIF
    IFNDEF MIN_SCHAR
    MIN_SCHAR EQU MIN_SBYTE
    ENDIF
    IFNDEF MIN_INT8
    MIN_INT8 EQU MIN_BYTE
    ENDIF
    IFNDEF MIN_I8
    MIN_I8 EQU MIN_BYTE
    ENDIF
    IFNDEF MIN_SINT8
    MIN_SINT8 EQU MIN_SBYTE
    ENDIF
    IFNDEF MIN_SI8
    MIN_SI8 EQU MIN_SBYTE
    ENDIF

    IFNDEF WORD_MAX
    WORD_MAX EQU 0xffff
    ENDIF
    IFNDEF UWORD_MAX
    UWORD_MAX EQU 0xffff
    ENDIF
    IFNDEF SHORT_MAX
    SHORT_MAX EQU WORD_MAX
    ENDIF
    IFNDEF USHORT_MAX
    USHORT_MAX EQU UWORD_MAX
    ENDIF
    IFNDEF INT16_MAX
    INT16_MAX EQU WORD_MAX
    ENDIF
    IFNDEF I16_MAX
    I16_MAX EQU WORD_MAX
    ENDIF
    IFNDEF UINT16_MAX
    UINT16_MAX EQU UWORD_MAX
    ENDIF
    IFNDEF UI16_MAX
    UI16_MAX EQU UWORD_MAX
    ENDIF
    IFNDEF UWORD_MIN
    UWORD_MIN EQU 0x0
    ENDIF
    IFNDEF USHORT_MIN
    USHORT_MIN EQU UWORD_MIN
    ENDIF
    IFNDEF UINT16_MIN
    UINT16_MIN EQU UWORD_MIN
    ENDIF
    IFNDEF UI16_MIN
    UI16_MIN EQU UWORD_MIN
    ENDIF
    IFNDEF SWORD_MAX
    SWORD_MAX EQU 0x7fff
    ENDIF
    IFNDEF SSHORT_MAX
    SSHORT_MAX EQU SWORD_MAX
    ENDIF
    IFNDEF SINT16_MAX
    SINT16_MAX EQU SWORD_MAX
    ENDIF
    IFNDEF SI16_MAX
    SI16_MAX EQU SWORD_MAX
    ENDIF
    IFNDEF WORD_MIN
    WORD_MIN EQU (-0x7fff - 0x1)
    ENDIF
    IFNDEF SWORD_MIN
    SWORD_MIN EQU (-0x7fff - 0x1)
    ENDIF
    IFNDEF SHORT_MIN
    SHORT_MIN EQU WORD_MIN
    ENDIF
    IFNDEF SSHORT_MIN
    SSHORT_MIN EQU SWORD_MIN
    ENDIF
    IFNDEF INT16_MIN
    INT16_MIN EQU WORD_MIN
    ENDIF
    IFNDEF I16_MIN
    I16_MIN EQU WORD_MIN
    ENDIF
    IFNDEF SINT16_MIN
    SINT16_MIN EQU SWORD_MIN
    ENDIF
    IFNDEF SI16_MIN
    SI16_MIN EQU SWORD_MIN
    ENDIF

    IFNDEF MAX_WORD
    MAX_WORD EQU 0xffff
    ENDIF
    IFNDEF MAX_UWORD
    MAX_UWORD EQU 0xffff
    ENDIF
    IFNDEF MAX_SHORT
    MAX_SHORT EQU MAX_WORD
    ENDIF
    IFNDEF MAX_USHORT
    MAX_USHORT EQU MAX_UWORD
    ENDIF
    IFNDEF MAX_INT16
    MAX_INT16 EQU MAX_WORD
    ENDIF
    IFNDEF MAX_I16
    MAX_I16 EQU MAX_WORD
    ENDIF
    IFNDEF MAX_UINT16
    MAX_UINT16 EQU MAX_UWORD
    ENDIF
    IFNDEF MAX_UI16
    MAX_UI16 EQU MAX_UWORD
    ENDIF
    IFNDEF MIN_UWORD
    MIN_UWORD EQU 0x0
    ENDIF
    IFNDEF MIN_USHORT
    MIN_USHORT EQU MIN_UWORD
    ENDIF
    IFNDEF MIN_UINT16
    MIN_UINT16 EQU MIN_UWORD
    ENDIF
    IFNDEF MIN_UI16
    MIN_UI16 EQU MIN_UWORD
    ENDIF
    IFNDEF MAX_SWORD
    MAX_SWORD EQU 0x7fff
    ENDIF
    IFNDEF MAX_SSHORT
    MAX_SSHORT EQU MAX_SWORD
    ENDIF
    IFNDEF MAX_SINT16
    MAX_SINT16 EQU MAX_SWORD
    ENDIF
    IFNDEF MAX_SI16
    MAX_SI16 EQU MAX_SWORD
    ENDIF
    IFNDEF MIN_WORD
    MIN_WORD EQU (-0x7fff - 0x1)
    ENDIF
    IFNDEF MIN_SWORD
    MIN_SWORD EQU (-0x7fff - 0x1)
    ENDIF
    IFNDEF MIN_SHORT
    MIN_SHORT EQU MIN_WORD
    ENDIF
    IFNDEF MIN_SSHORT
    MIN_SSHORT EQU MIN_SWORD
    ENDIF
    IFNDEF MIN_INT16
    MIN_INT16 EQU MIN_WORD
    ENDIF
    IFNDEF MIN_I16
    MIN_I16 EQU MIN_WORD
    ENDIF
    IFNDEF MIN_SINT16
    MIN_SINT16 EQU MIN_SWORD
    ENDIF
    IFNDEF MIN_SI16
    MIN_SI16 EQU MIN_SWORD
    ENDIF

    IFNDEF BOOL_MAX
    BOOL_MAX EQU 0x1
    ENDIF
    IFNDEF BOOL_MIN
    BOOL_MIN EQU 0x0
    ENDIF

    IFNDEF MAX_BOOL
    MAX_BOOL EQU 0x1
    ENDIF
    IFNDEF MIN_BOOL
    MIN_BOOL EQU 0x0
    ENDIF

    IFNDEF DWORD_MAX
    DWORD_MAX EQU 0xffffffff
    ENDIF
    IFNDEF UDWORD_MAX
    UDWORD_MAX EQU 0xffffffff
    ENDIF
    IFNDEF LONG_MAX
    LONG_MAX EQU DWORD_MAX
    ENDIF
    IFNDEF ULONG_MAX
    ULONG_MAX EQU UDWORD_MAX
    ENDIF
    IFNDEF INT_MAX
    INT_MAX EQU DWORD_MAX
    ENDIF
    IFNDEF UINT_MAX
    UINT_MAX EQU UDWORD_MAX
    ENDIF
    IFNDEF INT32_MAX
    INT32_MAX EQU DWORD_MAX
    ENDIF
    IFNDEF I32_MAX
    I32_MAX EQU DWORD_MAX
    ENDIF
    IFNDEF UINT32_MAX
    UINT32_MAX EQU UDWORD_MAX
    ENDIF
    IFNDEF UI32_MAX
    UI32_MAX EQU UDWORD_MAX
    ENDIF
    IFNDEF UDWORD_MIN
    UDWORD_MIN EQU 0x0
    ENDIF
    IFNDEF ULONG_MIN
    ULONG_MIN EQU UDWORD_MIN
    ENDIF
    IFNDEF UINT_MIN
    UINT_MIN EQU UDWORD_MIN
    ENDIF
    IFNDEF UINT32_MIN
    UINT32_MIN EQU UDWORD_MIN
    ENDIF
    IFNDEF UI32_MIN
    UI32_MIN EQU UDWORD_MIN
    ENDIF
    IFNDEF SDWORD_MAX
    SDWORD_MAX EQU 0x7fffffff
    ENDIF
    IFNDEF SLONG_MAX
    SLONG_MAX EQU SDWORD_MAX
    ENDIF
    IFNDEF SINT_MAX
    SINT_MAX EQU SDWORD_MAX
    ENDIF
    IFNDEF SINT32_MAX
    SINT32_MAX EQU SDWORD_MAX
    ENDIF
    IFNDEF SI32_MAX
    SI32_MAX EQU SDWORD_MAX
    ENDIF
    IFNDEF DWORD_MIN
    DWORD_MIN EQU (-0x7fffffff - 0x1)
    ENDIF
    IFNDEF SDWORD_MIN
    SDWORD_MIN EQU (-0x7fffffff - 0x1)
    ENDIF
    IFNDEF LONG_MIN
    LONG_MIN EQU DWORD_MIN
    ENDIF
    IFNDEF SLONG_MIN
    SLONG_MIN EQU SDWORD_MIN
    ENDIF
    IFNDEF INT_MIN
    INT_MIN EQU DWORD_MIN
    ENDIF
    IFNDEF SINT_MIN
    SINT_MIN EQU SDWORD_MIN
    ENDIF
    IFNDEF INT32_MIN
    INT32_MIN EQU DWORD_MIN
    ENDIF
    IFNDEF I32_MIN
    I32_MIN EQU DWORD_MIN
    ENDIF
    IFNDEF SINT32_MIN
    SINT32_MIN EQU SDWORD_MIN
    ENDIF
    IFNDEF SI32_MIN
    SI32_MIN EQU SDWORD_MIN
    ENDIF

    IFNDEF MAX_DWORD
    MAX_DWORD EQU 0xffffffff
    ENDIF
    IFNDEF MAX_UDWORD
    MAX_UDWORD EQU 0xffffffff
    ENDIF
    IFNDEF MAX_LONG
    MAX_LONG EQU MAX_DWORD
    ENDIF
    IFNDEF MAX_ULONG
    MAX_ULONG EQU MAX_UDWORD
    ENDIF
    IFNDEF MAX_INT
    MAX_INT EQU MAX_DWORD
    ENDIF
    IFNDEF MAX_UINT
    MAX_UINT EQU MAX_UDWORD
    ENDIF
    IFNDEF MAX_INT32
    MAX_INT32 EQU MAX_DWORD
    ENDIF
    IFNDEF MAX_I32
    MAX_I32 EQU MAX_DWORD
    ENDIF
    IFNDEF MAX_UINT32
    MAX_UINT32 EQU MAX_UDWORD
    ENDIF
    IFNDEF MAX_UI32
    MAX_UI32 EQU MAX_UDWORD
    ENDIF
    IFNDEF MIN_UDWORD
    MIN_UDWORD EQU 0x0
    ENDIF
    IFNDEF MIN_ULONG
    MIN_ULONG EQU MIN_UDWORD
    ENDIF
    IFNDEF MIN_UINT
    MIN_UINT EQU MIN_UDWORD
    ENDIF
    IFNDEF MIN_UINT32
    MIN_UINT32 EQU MIN_UDWORD
    ENDIF
    IFNDEF MIN_UI32
    MIN_UI32 EQU MIN_UDWORD
    ENDIF
    IFNDEF MAX_SDWORD
    MAX_SDWORD EQU 0x7fffffff
    ENDIF
    IFNDEF MAX_SLONG
    MAX_SLONG EQU MAX_SDWORD
    ENDIF
    IFNDEF MAX_SINT
    MAX_SINT EQU MAX_SDWORD
    ENDIF
    IFNDEF MAX_SINT32
    MAX_SINT32 EQU MAX_SDWORD
    ENDIF
    IFNDEF MAX_SI32
    MAX_SI32 EQU MAX_SDWORD
    ENDIF
    IFNDEF MIN_DWORD
    MIN_DWORD EQU (-0x7fffffff - 0x1)
    ENDIF
    IFNDEF MIN_SDWORD
    MIN_SDWORD EQU (-0x7fffffff - 0x1)
    ENDIF
    IFNDEF MIN_LONG
    MIN_LONG EQU MIN_DWORD
    ENDIF
    IFNDEF MIN_SLONG
    MIN_SLONG EQU MIN_SDWORD
    ENDIF
    IFNDEF MIN_INT
    MIN_INT EQU MIN_DWORD
    ENDIF
    IFNDEF MIN_SINT
    MIN_SINT EQU MIN_SDWORD
    ENDIF
    IFNDEF MIN_INT32
    MIN_INT32 EQU MIN_DWORD
    ENDIF
    IFNDEF MIN_I32
    MIN_I32 EQU MIN_DWORD
    ENDIF
    IFNDEF MIN_SINT32
    MIN_SINT32 EQU MIN_SDWORD
    ENDIF
    IFNDEF MIN_SI32
    MIN_SI32 EQU MIN_SDWORD
    ENDIF

    IFNDEF QWORD_MAX
    QWORD_MAX EQU 0xffffffffffffffff
    ENDIF
    IFNDEF UQWORD_MAX
    UQWORD_MAX EQU 0xffffffffffffffff
    ENDIF
    IFNDEF LONGLONG_MAX
    LONGLONG_MAX EQU QWORD_MAX
    ENDIF
    IFNDEF ULONGLONG_MAX
    ULONGLONG_MAX EQU UQWORD_MAX
    ENDIF
    IFNDEF INT64_MAX
    INT64_MAX EQU QWORD_MAX
    ENDIF
    IFNDEF I64_MAX
    I64_MAX EQU QWORD_MAX
    ENDIF
    IFNDEF UINT64_MAX
    UINT64_MAX EQU UQWORD_MAX
    ENDIF
    IFNDEF UI64_MAX
    UI64_MAX EQU UQWORD_MAX
    ENDIF
    IFNDEF UQWORD_MIN
    UQWORD_MIN EQU 0x0
    ENDIF
    IFNDEF ULONGLONG_MIN
    ULONGLONG_MIN EQU UQWORD_MIN
    ENDIF
    IFNDEF UINT64_MIN
    UINT64_MIN EQU UQWORD_MIN
    ENDIF
    IFNDEF UI64_MIN
    UI64_MIN EQU UQWORD_MIN
    ENDIF
    IFNDEF SQWORD_MAX
    SQWORD_MAX EQU 0x7fffffffffffffff
    ENDIF
    IFNDEF SLONGLONG_MAX
    SLONGLONG_MAX EQU SQWORD_MAX
    ENDIF
    IFNDEF SINT64_MAX
    SINT64_MAX EQU SQWORD_MAX
    ENDIF
    IFNDEF SI64_MAX
    SI64_MAX EQU SQWORD_MAX
    ENDIF
    IFNDEF QWORD_MIN
    QWORD_MIN EQU (-0x7fffffffffffffff - 0x1)
    ENDIF
    IFNDEF SQWORD_MIN
    SQWORD_MIN EQU (-0x7fffffffffffffff - 0x1)
    ENDIF
    IFNDEF LONGLONG_MIN
    LONGLONG_MIN EQU QWORD_MIN
    ENDIF
    IFNDEF SLONGLONG_MIN
    SLONGLONG_MIN EQU SQWORD_MIN
    ENDIF
    IFNDEF INT64_MIN
    INT64_MIN EQU QWORD_MIN
    ENDIF
    IFNDEF I64_MIN
    I64_MIN EQU QWORD_MIN
    ENDIF
    IFNDEF SINT64_MIN
    SINT64_MIN EQU SQWORD_MIN
    ENDIF
    IFNDEF SI64_MIN
    SI64_MIN EQU SQWORD_MIN
    ENDIF

    IFNDEF MAX_QWORD
    MAX_QWORD EQU 0xffffffffffffffff
    ENDIF
    IFNDEF MAX_UQWORD
    MAX_UQWORD EQU 0xffffffffffffffff
    ENDIF
    IFNDEF MAX_LONGLONG
    MAX_LONGLONG EQU MAX_QWORD
    ENDIF
    IFNDEF MAX_ULONGLONG
    MAX_ULONGLONG EQU MAX_UQWORD
    ENDIF
    IFNDEF MAX_INT64
    MAX_INT64 EQU MAX_QWORD
    ENDIF
    IFNDEF MAX_I64
    MAX_I64 EQU MAX_QWORD
    ENDIF
    IFNDEF MAX_UINT64
    MAX_UINT64 EQU MAX_UQWORD
    ENDIF
    IFNDEF MAX_UI64
    MAX_UI64 EQU MAX_UQWORD
    ENDIF
    IFNDEF MIN_UQWORD
    MIN_UQWORD EQU 0x0
    ENDIF
    IFNDEF MIN_ULONGLONG
    MIN_ULONGLONG EQU MIN_UQWORD
    ENDIF
    IFNDEF MIN_UINT64
    MIN_UINT64 EQU MIN_UQWORD
    ENDIF
    IFNDEF MIN_UI64
    MIN_UI64 EQU MIN_UQWORD
    ENDIF
    IFNDEF MAX_SQWORD
    MAX_SQWORD EQU 0x7fffffffffffffff
    ENDIF
    IFNDEF MAX_SLONGLONG
    MAX_SLONGLONG EQU MAX_SQWORD
    ENDIF
    IFNDEF MAX_SINT64
    MAX_SINT64 EQU MAX_SQWORD
    ENDIF
    IFNDEF MAX_SI64
    MAX_SI64 EQU MAX_SQWORD
    ENDIF
    IFNDEF MIN_QWORD
    MIN_QWORD EQU (-0x7fffffffffffffff - 0x1)
    ENDIF
    IFNDEF MIN_SQWORD
    MIN_SQWORD EQU (-0x7fffffffffffffff - 0x1)
    ENDIF
    IFNDEF MIN_LONGLONG
    MIN_LONGLONG EQU MIN_QWORD
    ENDIF
    IFNDEF MIN_SLONGLONG
    MIN_SLONGLONG EQU MIN_SQWORD
    ENDIF
    IFNDEF MIN_INT64
    MIN_INT64 EQU MIN_QWORD
    ENDIF
    IFNDEF MIN_I64
    MIN_I64 EQU MIN_QWORD
    ENDIF
    IFNDEF MIN_SINT64
    MIN_SINT64 EQU MIN_SQWORD
    ENDIF
    IFNDEF MIN_SI64
    MIN_SI64 EQU MIN_SQWORD
    ENDIF

    IFNDEF BYTE_ERROR
    BYTE_ERROR EQU 0xff
    ENDIF
    IFNDEF CHAR_ERROR
    CHAR_ERROR EQU 0xff
    ENDIF
    IFNDEF INT8_ERROR
    INT8_ERROR EQU 0xff
    ENDIF
    IFNDEF I8_ERROR
    I8_ERROR EQU 0xff
    ENDIF
    IFNDEF UBYTE_ERROR
    UBYTE_ERROR EQU 0xff
    ENDIF
    IFNDEF UCHAR_ERROR
    UCHAR_ERROR EQU 0xff
    ENDIF
    IFNDEF UINT8_ERROR
    UINT8_ERROR EQU 0xff
    ENDIF
    IFNDEF UI8_ERROR
    UI8_ERROR EQU 0xff
    ENDIF
    IFNDEF SBYTE_ERROR
    SBYTE_ERROR EQU (-0x1)
    ENDIF
    IFNDEF SCHAR_ERROR
    SCHAR_ERROR EQU (-0x1)
    ENDIF
    IFNDEF SINT8_ERROR
    SINT8_ERROR EQU (-0x1)
    ENDIF
    IFNDEF SI8_ERROR
    SI8_ERROR EQU (-0x1)
    ENDIF

    IFNDEF WORD_ERROR
    WORD_ERROR EQU 0xffff
    ENDIF
    IFNDEF SHORT_ERROR
    SHORT_ERROR EQU 0xffff
    ENDIF
    IFNDEF INT16_ERROR
    INT16_ERROR EQU 0xffff
    ENDIF
    IFNDEF I16_ERROR
    I16_ERROR EQU 0xffff
    ENDIF
    IFNDEF UWORD_ERROR
    UWORD_ERROR EQU 0xffff
    ENDIF
    IFNDEF USHORT_ERROR
    USHORT_ERROR EQU 0xffff
    ENDIF
    IFNDEF UINT16_ERROR
    UINT16_ERROR EQU 0xffff
    ENDIF
    IFNDEF UI16_ERROR
    UI16_ERROR EQU 0xffff
    ENDIF
    IFNDEF SWORD_ERROR
    SWORD_ERROR EQU (-0x1)
    ENDIF
    IFNDEF SSHORT_ERROR
    SSHORT_ERROR EQU (-0x1)
    ENDIF
    IFNDEF SINT16_ERROR
    SINT16_ERROR EQU (-0x1)
    ENDIF
    IFNDEF SI16_ERROR
    SI16_ERROR EQU (-0x1)
    ENDIF

    IFNDEF DWORD_ERROR
    DWORD_ERROR EQU 0xffffffff
    ENDIF
    IFNDEF LONG_ERROR
    LONG_ERROR EQU 0xffffffff
    ENDIF
    IFNDEF INT_ERROR
    INT_ERROR EQU 0xffffffff
    ENDIF
    IFNDEF INT32_ERROR
    INT32_ERROR EQU 0xffffffff
    ENDIF
    IFNDEF I32_ERROR
    I32_ERROR EQU 0xffffffff
    ENDIF
    IFNDEF UDWORD_ERROR
    UDWORD_ERROR EQU 0xffffffff
    ENDIF
    IFNDEF ULONG_ERROR
    ULONG_ERROR EQU 0xffffffff
    ENDIF
    IFNDEF UINT_ERROR
    UINT_ERROR EQU 0xffffffff
    ENDIF
    IFNDEF UINT32_ERROR
    UINT32_ERROR EQU 0xffffffff
    ENDIF
    IFNDEF UI32_ERROR
    UI32_ERROR EQU 0xffffffff
    ENDIF
    IFNDEF SDWORD_ERROR
    SDWORD_ERROR EQU (-0x1)
    ENDIF
    IFNDEF SLONG_ERROR
    SLONG_ERROR EQU (-0x1)
    ENDIF
    IFNDEF SINT_ERROR
    SINT_ERROR EQU (-0x1)
    ENDIF
    IFNDEF SINT32_ERROR
    SINT32_ERROR EQU (-0x1)
    ENDIF
    IFNDEF SI32_ERROR
    SI32_ERROR EQU (-0x1)
    ENDIF

    IFNDEF QWORD_ERROR
    QWORD_ERROR EQU 0xffffffffffffffff
    ENDIF
    IFNDEF LONGLONG_ERROR
    LONGLONG_ERROR EQU 0xffffffffffffffff
    ENDIF
    IFNDEF INT64_ERROR
    INT64_ERROR EQU 0xffffffffffffffff
    ENDIF
    IFNDEF I64_ERROR
    I64_ERROR EQU 0xffffffffffffffff
    ENDIF
    IFNDEF UQWORD_ERROR
    UQWORD_ERROR EQU 0xffffffffffffffff
    ENDIF
    IFNDEF ULONGLONG_ERROR
    ULONGLONG_ERROR EQU 0xffffffffffffffff
    ENDIF
    IFNDEF UINT64_ERROR
    UINT64_ERROR EQU 0xffffffffffffffff
    ENDIF
    IFNDEF UI64_ERROR
    UI64_ERROR EQU 0xffffffffffffffff
    ENDIF
    IFNDEF SQWORD_ERROR
    SQWORD_ERROR EQU (-0x1)
    ENDIF
    IFNDEF SLONGLONG_ERROR
    SLONGLONG_ERROR EQU (-0x1)
    ENDIF
    IFNDEF SINT64_ERROR
    SINT64_ERROR EQU (-0x1)
    ENDIF
    IFNDEF SI64_ERROR
    SI64_ERROR EQU (-0x1)
    ENDIF

    IFNDEF FLOAT_ERROR
    FLOAT_ERROR EQU (-0x1)
    ENDIF
    IFNDEF FLT_ERROR
    FLT_ERROR EQU (-0x1)
    ENDIF
    IFNDEF DOUBLE_ERROR
    DOUBLE_ERROR EQU (-0x1)
    ENDIF
    IFNDEF DBL_ERROR
    DBL_ERROR EQU (-0x1)
    ENDIF

    IFDEF __X64__
    IFNDEF STACK_SIZE
    STACK_SIZE EQU 16
    ENDIF
    IFNDEF SIZE_T_SIZE
    SIZE_T_SIZE EQU 8
    ENDIF
    IFNDEF PTRDIFF_T_SIZE
    PTRDIFF_T_SIZE EQU 8
    ENDIF
    IFNDEF INTPTR_T_SIZE
    INTPTR_T_SIZE EQU 8
    ENDIF
    IFNDEF UINTPTR_T_SIZE
    UINTPTR_T_SIZE EQU 8
    ENDIF
    IFNDEF PTR_SIZE
    PTR_SIZE EQU 8
    ENDIF
    IFNDEF REG_SIZE
    REG_SIZE EQU 8
    ENDIF
    IFNDEF SINTSIZE_T_MAX
    SINTSIZE_T_MAX EQU SQWORD_MAX
    ENDIF
    IFNDEF SINTSIZE_T_MIN
    SINTSIZE_T_MIN EQU SQWORD_MIN
    ENDIF
    IFNDEF UINTSIZE_T_MAX
    UINTSIZE_T_MAX EQU UQWORD_MAX
    ENDIF
    IFNDEF UINTSIZE_T_MIN
    UINTSIZE_T_MIN EQU UQWORD_MIN
    ENDIF
    IFNDEF INTSIZE_T_MAX
    INTSIZE_T_MAX EQU QWORD_MAX
    ENDIF
    IFNDEF INTSIZE_T_MIN
    INTSIZE_T_MIN EQU QWORD_MIN
    ENDIF
    IFNDEF SIZE_T_MAX
    SIZE_T_MAX EQU QWORD_MAX
    ENDIF
    IFNDEF SIZE_T_MIN
    SIZE_T_MIN EQU QWORD_MIN
    ENDIF
    IFNDEF PTRDIFF_T_MAX
    PTRDIFF_T_MAX EQU QWORD_MAX
    ENDIF
    IFNDEF PTRDIFF_T_MIN
    PTRDIFF_T_MIN EQU QWORD_MIN
    ENDIF
    IFNDEF INTPTR_T_MAX
    INTPTR_T_MAX EQU QWORD_MAX
    ENDIF
    IFNDEF INTPTR_T_MIN
    INTPTR_T_MIN EQU QWORD_MIN
    ENDIF
    IFNDEF UINTPTR_T_MAX
    UINTPTR_T_MAX EQU QWORD_MAX
    ENDIF
    IFNDEF UINTPTR_T_MIN
    UINTPTR_T_MIN EQU QWORD_MIN
    ENDIF
    IFNDEF SINTPTR_MAX
    SINTPTR_MAX EQU SQWORD_MAX
    ENDIF
    IFNDEF SINTPTR_MIN
    SINTPTR_MIN EQU SQWORD_MIN
    ENDIF
    IFNDEF UINTPTR_MAX
    UINTPTR_MAX EQU UQWORD_MAX
    ENDIF
    IFNDEF UINTPTR_MIN
    UINTPTR_MIN EQU UQWORD_MIN
    ENDIF
    IFNDEF INTPTR_MAX
    INTPTR_MAX EQU QWORD_MAX
    ENDIF
    IFNDEF INTPTR_MIN
    INTPTR_MIN EQU QWORD_MIN
    ENDIF
    IFNDEF MAX_SINTSIZE_T
    MAX_SINTSIZE_T EQU MAX_SQWORD
    ENDIF
    IFNDEF MIN_SINTSIZE_T
    MIN_SINTSIZE_T EQU MIN_SQWORD
    ENDIF
    IFNDEF MAX_UINTSIZE_T
    MAX_UINTSIZE_T EQU MAX_UQWORD
    ENDIF
    IFNDEF MIN_UINTSIZE_T
    MIN_UINTSIZE_T EQU MIN_UQWORD
    ENDIF
    IFNDEF MAX_INTSIZE_T
    MAX_INTSIZE_T EQU MAX_QWORD
    ENDIF
    IFNDEF MIN_INTSIZE_T
    MIN_INTSIZE_T EQU MIN_QWORD
    ENDIF
    IFNDEF MAX_SIZE_T
    MAX_SIZE_T EQU MAX_QWORD
    ENDIF
    IFNDEF MIN_SIZE_T
    MIN_SIZE_T EQU MIN_QWORD
    ENDIF
    IFNDEF MAX_PTRDIFF_T
    MAX_PTRDIFF_T EQU MAX_QWORD
    ENDIF
    IFNDEF MIN_PTRDIFF_T
    MIN_PTRDIFF_T EQU MIN_QWORD
    ENDIF
    IFNDEF MAX_INTPTR_T
    MAX_INTPTR_T EQU MAX_QWORD
    ENDIF
    IFNDEF MIN_INTPTR_T
    MIN_INTPTR_T EQU MIN_QWORD
    ENDIF
    IFNDEF MAX_UINTPTR_T
    MAX_UINTPTR_T EQU MAX_QWORD
    ENDIF
    IFNDEF MIN_UINTPTR_T
    MIN_UINTPTR_T EQU MIN_QWORD
    ENDIF
    IFNDEF MAX_SINTPTR
    MAX_SINTPTR EQU MAX_SQWORD
    ENDIF
    IFNDEF MIN_SINTPTR
    MIN_SINTPTR EQU MIN_SQWORD
    ENDIF
    IFNDEF MAX_UINTPTR
    MAX_UINTPTR EQU MAX_UQWORD
    ENDIF
    IFNDEF MIN_UINTPTR
    MIN_UINTPTR EQU MIN_UQWORD
    ENDIF
    IFNDEF MAX_INTPTR
    MAX_INTPTR EQU MAX_QWORD
    ENDIF
    IFNDEF MIN_INTPTR
    MIN_INTPTR EQU MIN_QWORD
    ENDIF
    IFNDEF SINTSIZE_T_ERROR
    SINTSIZE_T_ERROR EQU SQWORD_ERROR
    ENDIF
    IFNDEF UINTSIZE_T_ERROR
    UINTSIZE_T_ERROR EQU UQWORD_ERROR
    ENDIF
    IFNDEF INTSIZE_T_ERROR
    INTSIZE_T_ERROR EQU QWORD_ERROR
    ENDIF
    IFNDEF SIZE_T_ERROR
    SIZE_T_ERROR EQU QWORD_ERROR
    ENDIF
    IFNDEF PTRDIFF_T_ERROR
    PTRDIFF_T_ERROR EQU QWORD_ERROR
    ENDIF
    IFNDEF INTPTR_T_ERROR
    INTPTR_T_ERROR EQU QWORD_ERROR
    ENDIF
    IFNDEF UINTPTR_T_ERROR
    UINTPTR_T_ERROR EQU QWORD_ERROR
    ENDIF
    IFNDEF SINTPTR_ERROR
    SINTPTR_ERROR EQU SQWORD_ERROR
    ENDIF
    IFNDEF UINTPTR_ERROR
    UINTPTR_ERROR EQU UQWORD_ERROR
    ENDIF
    IFNDEF INTPTR_ERROR
    INTPTR_ERROR EQU QWORD_ERROR
    ENDIF
    ENDIF ;/*__X64__*/

    IFDEF __X32__
    IFNDEF STACK_SIZE
    STACK_SIZE EQU 8
    ENDIF
    IFNDEF SIZE_T_SIZE
    SIZE_T_SIZE EQU 4
    ENDIF
    IFNDEF PTRDIFF_T_SIZE
    PTRDIFF_T_SIZE EQU 4
    ENDIF
    IFNDEF INTPTR_T_SIZE
    INTPTR_T_SIZE EQU 4
    ENDIF
    IFNDEF UINTPTR_T_SIZE
    UINTPTR_T_SIZE EQU 4
    ENDIF
    IFNDEF PTR_SIZE
    PTR_SIZE EQU 4
    ENDIF
    IFNDEF REG_SIZE
    REG_SIZE EQU 4
    ENDIF
    IFNDEF SINTSIZE_T_MAX
    SINTSIZE_T_MAX EQU SDWORD_MAX
    ENDIF
    IFNDEF SINTSIZE_T_MIN
    SINTSIZE_T_MIN EQU SDWORD_MIN
    ENDIF
    IFNDEF UINTSIZE_T_MAX
    UINTSIZE_T_MAX EQU UDWORD_MAX
    ENDIF
    IFNDEF UINTSIZE_T_MIN
    UINTSIZE_T_MIN EQU UDWORD_MIN
    ENDIF
    IFNDEF INTSIZE_T_MAX
    INTSIZE_T_MAX EQU DWORD_MAX
    ENDIF
    IFNDEF INTSIZE_T_MIN
    INTSIZE_T_MIN EQU DWORD_MIN
    ENDIF
    IFNDEF SIZE_T_MAX
    SIZE_T_MAX EQU DWORD_MAX
    ENDIF
    IFNDEF SIZE_T_MIN
    SIZE_T_MIN EQU DWORD_MIN
    ENDIF
    IFNDEF PTRDIFF_T_MAX
    PTRDIFF_T_MAX EQU DWORD_MAX
    ENDIF
    IFNDEF PTRDIFF_T_MIN
    PTRDIFF_T_MIN EQU DWORD_MIN
    ENDIF
    IFNDEF INTPTR_T_MAX
    INTPTR_T_MAX EQU DWORD_MAX
    ENDIF
    IFNDEF INTPTR_T_MIN
    INTPTR_T_MIN EQU DWORD_MIN
    ENDIF
    IFNDEF UINTPTR_T_MAX
    UINTPTR_T_MAX EQU DWORD_MAX
    ENDIF
    IFNDEF UINTPTR_T_MIN
    UINTPTR_T_MIN EQU DWORD_MIN
    ENDIF
    IFNDEF SINTPTR_MAX
    SINTPTR_MAX EQU SDWORD_MAX
    ENDIF
    IFNDEF SINTPTR_MIN
    SINTPTR_MIN EQU SDWORD_MIN
    ENDIF
    IFNDEF UINTPTR_MAX
    UINTPTR_MAX EQU UDWORD_MAX
    ENDIF
    IFNDEF UINTPTR_MIN
    UINTPTR_MIN EQU UDWORD_MIN
    ENDIF
    IFNDEF INTPTR_MAX
    INTPTR_MAX EQU DWORD_MAX
    ENDIF
    IFNDEF INTPTR_MIN
    INTPTR_MIN EQU DWORD_MIN
    ENDIF
    IFNDEF MAX_SINTSIZE_T
    MAX_SINTSIZE_T EQU MAX_SDWORD
    ENDIF
    IFNDEF MIN_SINTSIZE_T
    MIN_SINTSIZE_T EQU MIN_SDWORD
    ENDIF
    IFNDEF MAX_UINTSIZE_T
    MAX_UINTSIZE_T EQU MAX_UDWORD
    ENDIF
    IFNDEF MIN_UINTSIZE_T
    MIN_UINTSIZE_T EQU MIN_UDWORD
    ENDIF
    IFNDEF MAX_INTSIZE_T
    MAX_INTSIZE_T EQU MAX_DWORD
    ENDIF
    IFNDEF MIN_INTSIZE_T
    MIN_INTSIZE_T EQU MIN_DWORD
    ENDIF
    IFNDEF MAX_SIZE_T
    MAX_SIZE_T EQU MAX_DWORD
    ENDIF
    IFNDEF MIN_SIZE_T
    MIN_SIZE_T EQU MIN_DWORD
    ENDIF
    IFNDEF MAX_PTRDIFF_T
    MAX_PTRDIFF_T EQU MAX_DWORD
    ENDIF
    IFNDEF MIN_PTRDIFF_T
    MIN_PTRDIFF_T EQU MIN_DWORD
    ENDIF
    IFNDEF MAX_INTPTR_T
    MAX_INTPTR_T EQU MAX_DWORD
    ENDIF
    IFNDEF MIN_INTPTR_T
    MIN_INTPTR_T EQU MIN_DWORD
    ENDIF
    IFNDEF MAX_UINTPTR_T
    MAX_UINTPTR_T EQU MAX_DWORD
    ENDIF
    IFNDEF MIN_UINTPTR_T
    MIN_UINTPTR_T EQU MIN_DWORD
    ENDIF
    IFNDEF MAX_SINTPTR
    MAX_SINTPTR EQU MAX_SDWORD
    ENDIF
    IFNDEF MIN_SINTPTR
    MIN_SINTPTR EQU MIN_SDWORD
    ENDIF
    IFNDEF MAX_UINTPTR
    MAX_UINTPTR EQU MAX_UDWORD
    ENDIF
    IFNDEF MIN_UINTPTR
    MIN_UINTPTR EQU MIN_UDWORD
    ENDIF
    IFNDEF MAX_INTPTR
    MAX_INTPTR EQU MAX_DWORD
    ENDIF
    IFNDEF MIN_INTPTR
    MIN_INTPTR EQU MIN_DWORD
    ENDIF
    IFNDEF SINTSIZE_T_ERROR
    SINTSIZE_T_ERROR EQU SDWORD_ERROR
    ENDIF
    IFNDEF UINTSIZE_T_ERROR
    UINTSIZE_T_ERROR EQU UDWORD_ERROR
    ENDIF
    IFNDEF INTSIZE_T_ERROR
    INTSIZE_T_ERROR EQU DWORD_ERROR
    ENDIF
    IFNDEF SIZE_T_ERROR
    SIZE_T_ERROR EQU DWORD_ERROR
    ENDIF
    IFNDEF PTRDIFF_T_ERROR
    PTRDIFF_T_ERROR EQU DWORD_ERROR
    ENDIF
    IFNDEF INTPTR_T_ERROR
    INTPTR_T_ERROR EQU DWORD_ERROR
    ENDIF
    IFNDEF UINTPTR_T_ERROR
    UINTPTR_T_ERROR EQU DWORD_ERROR
    ENDIF
    IFNDEF SINTPTR_ERROR
    SINTPTR_ERROR EQU SDWORD_ERROR
    ENDIF
    IFNDEF UINTPTR_ERROR
    UINTPTR_ERROR EQU UDWORD_ERROR
    ENDIF
    IFNDEF INTPTR_ERROR
    INTPTR_ERROR EQU DWORD_ERROR
    ENDIF
    ENDIF ;/*__X32__*/

   ;/bool*/
    IFNDEF FALSE
    FALSE EQU 0x0
    ENDIF
    IFNDEF TRUE
    TRUE EQU 0x1

    ENDIF
    IFNDEF NULL
    NULL EQU 0
    ENDIF

   ;/byte*/
    IFNDEF M8_FALSE
    M8_FALSE EQU 0x00
    ENDIF
    IFNDEF M8_TRUE
    M8_TRUE EQU 0xff
    ENDIF
    IFNDEF BYTE_FALSE
    BYTE_FALSE EQU 0x00
    ENDIF
    IFNDEF BYTE_TRUE
    BYTE_TRUE EQU 0xff
    ENDIF
    IFNDEF CHAR_FALSE
    CHAR_FALSE EQU 0x00
    ENDIF
    IFNDEF CHAR_TRUE
    CHAR_TRUE EQU 0xff
    ENDIF
    IFNDEF INT8_FALSE
    INT8_FALSE EQU 0x00
    ENDIF
    IFNDEF INT8_TRUE
    INT8_TRUE EQU 0xff
    ENDIF
    IFNDEF I8_FALSE
    I8_FALSE EQU 0x00
    ENDIF
    IFNDEF I8_TRUE
    I8_TRUE EQU 0xff
    ENDIF
    IFNDEF I8_0
    I8_0 EQU 0x00
    ENDIF
    IFNDEF I8_1
    I8_1 EQU 0x01
    ENDIF
    IFNDEF I8_NEG0
    I8_NEG0 EQU 0x80
    ENDIF
    IFNDEF I8_NEG1
    I8_NEG1 EQU 0xff
    ENDIF
    IFNDEF I8_NEG2
    I8_NEG2 EQU 0xfe
    ENDIF
   ;/word*/
    IFNDEF M16_FALSE
    M16_FALSE EQU 0x0000
    ENDIF
    IFNDEF M16_TRUE
    M16_TRUE EQU 0xffff
    ENDIF
    IFNDEF WORD_FALSE
    WORD_FALSE EQU 0x0000
    ENDIF
    IFNDEF WORD_TRUE
    WORD_TRUE EQU 0xffff
    ENDIF
    IFNDEF SHORT_FALSE
    SHORT_FALSE EQU 0x0000
    ENDIF
    IFNDEF SHORT_TRUE
    SHORT_TRUE EQU 0xffff
    ENDIF
    IFNDEF INT16_FALSE
    INT16_FALSE EQU 0x0000
    ENDIF
    IFNDEF INT16_TRUE
    INT16_TRUE EQU 0xffff
    ENDIF
    IFNDEF I16_FALSE
    I16_FALSE EQU 0x0000
    ENDIF
    IFNDEF I16_TRUE
    I16_TRUE EQU 0xffff
    ENDIF
    IFNDEF I16_0
    I16_0 EQU 0x0000
    ENDIF
    IFNDEF I16_1
    I16_1 EQU 0x0001
    ENDIF
    IFNDEF I16_NEG0
    I16_NEG0 EQU 0x8000
    ENDIF
    IFNDEF I16_NEG1
    I16_NEG1 EQU 0xffff
    ENDIF
    IFNDEF I16_NEG2
    I16_NEG2 EQU 0xfffe
    ENDIF
   ;/dword*/
    IFNDEF M32_FALSE
    M32_FALSE EQU 0x00000000
    ENDIF
    IFNDEF M32_TRUE
    M32_TRUE EQU 0xffffffff
    ENDIF
    IFNDEF DWORD_FALSE
    DWORD_FALSE EQU 0x00000000
    ENDIF
    IFNDEF DWORD_TRUE
    DWORD_TRUE EQU 0xffffffff
    ENDIF
    IFNDEF LONG_FALSE
    LONG_FALSE EQU 0x00000000
    ENDIF
    IFNDEF LONG_TRUE
    LONG_TRUE EQU 0xffffffff
    ENDIF
    IFNDEF INT_FALSE
    INT_FALSE EQU 0x00000000
    ENDIF
    IFNDEF INT_TRUE
    INT_TRUE EQU 0xffffffff
    ENDIF
    IFNDEF INT32_FALSE
    INT32_FALSE EQU 0x00000000
    ENDIF
    IFNDEF INT32_TRUE
    INT32_TRUE EQU 0xffffffff
    ENDIF
    IFNDEF I32_FALSE
    I32_FALSE EQU 0x00000000
    ENDIF
    IFNDEF I32_TRUE
    I32_TRUE EQU 0xffffffff
    ENDIF
    IFNDEF I32_0
    I32_0 EQU 0x00000000
    ENDIF
    IFNDEF I32_1
    I32_1 EQU 0x00000001
    ENDIF
    IFNDEF I32_2
    I32_2 EQU 0x00000002
    ENDIF
    IFNDEF I32_NEG0
    I32_NEG0 EQU 0x80000000
    ENDIF
    IFNDEF I32_NEG1
    I32_NEG1 EQU 0xffffffff
    ENDIF
    IFNDEF I32_NEG2
    I32_NEG2 EQU 0xfffffffe
   ;/qword*/
    ENDIF
    IFNDEF MM_SIZE
    MM_SIZE EQU 8
    ENDIF
    IFNDEF M64_SIZE
    M64_SIZE EQU 8
    ENDIF
    IFNDEF MM_FALSE
    MM_FALSE EQU 0x0000000000000000
    ENDIF
    IFNDEF MM_TRUE
    MM_TRUE EQU 0xffffffffffffffff
    ENDIF
    IFNDEF M64_FALSE
    M64_FALSE EQU 0x0000000000000000
    ENDIF
    IFNDEF M64_TRUE
    M64_TRUE EQU 0xffffffffffffffff
    ENDIF
    IFNDEF QWORD_FALSE
    QWORD_FALSE EQU 0x0000000000000000
    ENDIF
    IFNDEF QWORD_TRUE
    QWORD_TRUE EQU 0xffffffffffffffff
    ENDIF
    IFNDEF LONGLONG_FALSE
    LONGLONG_FALSE EQU 0x0000000000000000
    ENDIF
    IFNDEF LONGLONG_TRUE
    LONGLONG_TRUE EQU 0xffffffffffffffff
    ENDIF
    IFNDEF INT64_FALSE
    INT64_FALSE EQU 0x0000000000000000
    ENDIF
    IFNDEF INT64_TRUE
    INT64_TRUE EQU 0xffffffffffffffff
    ENDIF
    IFNDEF I64_FALSE
    I64_FALSE EQU 0x0000000000000000
    ENDIF
    IFNDEF I64_TRUE
    I64_TRUE EQU 0xffffffffffffffff
    ENDIF
    IFNDEF I64_0
    I64_0 EQU 0x0000000000000000
    ENDIF
    IFNDEF I64_1
    I64_1 EQU 0x0000000000000001
    ENDIF
    IFNDEF I64_NEG0
    I64_NEG0 EQU 0x8000000000000000
    ENDIF
    IFNDEF I64_NEG1
    I64_NEG1 EQU 0xffffffffffffffff
    ENDIF
    IFNDEF I64_NEG2
    I64_NEG2 EQU 0xfffffffffffffffe
    ENDIF

   ;/xmm type*/
    IFNDEF XMM_SIZE
    XMM_SIZE EQU 16
    ENDIF
    IFNDEF M128_SIZE
    M128_SIZE EQU 16
    ENDIF
    IFNDEF XMMWORD_SIZE
    XMMWORD_SIZE EQU 16
    ENDIF
    IFNDEF OWORD_SIZE
    OWORD_SIZE EQU 16
    ENDIF

   ;/ymm type*/
    IFNDEF YMM_SIZE
    YMM_SIZE EQU 32
    ENDIF
    IFNDEF M256_SIZE
    M256_SIZE EQU 32
    ENDIF
    IFNDEF YMMWORD_SIZE
    YMMWORD_SIZE EQU 32
    ENDIF

   ;/zmm type*/
    IFNDEF ZMM_SIZE
    ZMM_SIZE EQU 64
    ENDIF
    IFNDEF M512_SIZE
    M512_SIZE EQU 64
    ENDIF
    IFNDEF ZMMWORD_SIZE
    ZMMWORD_SIZE EQU 32
    ENDIF
    
    IFDEF CASEMAPNONE

    IFDEF BYTE_SIZE
    byte_size EQU BYTE_SIZE
    ENDIF
    IFDEF UBYTE_SIZE
    ubyte_size EQU UBYTE_SIZE
    ENDIF
    IFDEF SBYTE_SIZE
    sbyte_size EQU SBYTE_SIZE
    ENDIF
    IFDEF CHAR_SIZE
    char_size EQU CHAR_SIZE
    ENDIF
    IFDEF UCHAR_SIZE
    uchar_size EQU UCHAR_SIZE
    ENDIF
    IFDEF SCHAR_SIZE
    schar_size EQU SCHAR_SIZE
    ENDIF
    IFDEF INT8_SIZE
    int8_size EQU INT8_SIZE
    ENDIF
    IFDEF I8_SIZE
    i8_size EQU I8_SIZE
    ENDIF
    IFDEF UINT8_SIZE
    uint8_size EQU UINT8_SIZE
    ENDIF
    IFDEF UI8_SIZE
    ui8_size EQU UI8_SIZE
    ENDIF
    IFDEF SINT8_SIZE
    sint8_size EQU SINT8_SIZE
    ENDIF
    IFDEF SI8_SIZE
    si8_size EQU SI8_SIZE
    ENDIF
    IFDEF WORD_SIZE
    word_size EQU WORD_SIZE
    ENDIF
    IFDEF UWORD_SIZE
    uword_size EQU UWORD_SIZE
    ENDIF
    IFDEF SWORD_SIZE
    sword_size EQU SWORD_SIZE
    ENDIF
    IFDEF SHORT_SIZE
    short_size EQU SHORT_SIZE
    ENDIF
    IFDEF USHORT_SIZE
    ushort_size EQU USHORT_SIZE
    ENDIF
    IFDEF SSHORT_SIZE
    sshort_size EQU SSHORT_SIZE
    ENDIF
    IFDEF INT16_SIZE
    int16_size EQU INT16_SIZE
    ENDIF
    IFDEF I16_SIZE
    i16_size EQU I16_SIZE
    ENDIF
    IFDEF UINT16_SIZE
    uint16_size EQU UINT16_SIZE
    ENDIF
    IFDEF UI16_SIZE
    ui16_size EQU UI16_SIZE
    ENDIF
    IFDEF SINT16_SIZE
    sint16_size EQU SINT16_SIZE
    ENDIF
    IFDEF SI16_SIZE
    si16_size EQU SI16_SIZE
    ENDIF
    IFDEF DWORD_SIZE
    dword_size EQU DWORD_SIZE
    ENDIF
    IFDEF UDWORD_SIZE
    udword_size EQU UDWORD_SIZE
    ENDIF
    IFDEF SDWORD_SIZE
    sdword_size EQU SDWORD_SIZE
    ENDIF
    IFDEF LONG_SIZE
    long_size EQU LONG_SIZE
    ENDIF
    IFDEF ULONG_SIZE
    ulong_size EQU ULONG_SIZE
    ENDIF
    IFDEF SLONG_SIZE
    slong_size EQU SLONG_SIZE
    ENDIF
    IFDEF BOOL_SIZE
    bool_size EQU BOOL_SIZE
    ENDIF
    IFDEF INT_SIZE
    int_size EQU INT_SIZE
    ENDIF
    IFDEF UINT_SIZE
    uint_size EQU UINT_SIZE
    ENDIF
    IFDEF SINT_SIZE
    sint_size EQU SINT_SIZE
    ENDIF
    IFDEF INT32_SIZE
    int32_size EQU INT32_SIZE
    ENDIF
    IFDEF I32_SIZE
    i32_size EQU I32_SIZE
    ENDIF
    IFDEF UINT32_SIZE
    uint32_size EQU UINT32_SIZE
    ENDIF
    IFDEF UI32_SIZE
    ui32_size EQU UI32_SIZE
    ENDIF
    IFDEF SINT32_SIZE
    sint32_size EQU SINT32_SIZE
    ENDIF
    IFDEF SI32_SIZE
    si32_size EQU SI32_SIZE
    ENDIF
    IFDEF QWORD_SIZE
    qword_size EQU QWORD_SIZE
    ENDIF
    IFDEF UQWORD_SIZE
    uqword_size EQU UQWORD_SIZE
    ENDIF
    IFDEF SQWORD_SIZE
    sqword_size EQU SQWORD_SIZE
    ENDIF
    IFDEF LONGLONG_SIZE
    longlong_size EQU LONGLONG_SIZE
    ENDIF
    IFDEF ULONGLONG_SIZE
    ulonglong_size EQU ULONGLONG_SIZE
    ENDIF
    IFDEF SLONGLONG_SIZE
    slonglong_size EQU SLONGLONG_SIZE
    ENDIF
    IFDEF INT64_SIZE
    int64_size EQU INT64_SIZE
    ENDIF
    IFDEF I64_SIZE
    i64_size EQU I64_SIZE
    ENDIF
    IFDEF UINT64_SIZE
    uint64_size EQU UINT64_SIZE
    ENDIF
    IFDEF UI64_SIZE
    ui64_size EQU UI64_SIZE
    ENDIF
    IFDEF SINT64_SIZE
    sint64_size EQU SINT64_SIZE
    ENDIF
    IFDEF SI64_SIZE
    si64_size EQU SI64_SIZE
    ENDIF
    IFDEF FLOAT16_SIZE
    float16_SIZE EQU FLOAT16_SIZE
    ENDIF
    IFDEF BFLOAT16_SIZE
    bfloat16_SIZE EQU BFLOAT16_SIZE
    ENDIF
    IFDEF FLT16_SIZE
    flt16_SIZE EQU FLT16_SIZE
    ENDIF
    IFDEF BFLT16_SIZE
    bflt16_SIZE EQU BFLT16_SIZE
    ENDIF
    IFDEF REAL4_SIZE
    real4_size EQU REAL4_SIZE
    ENDIF
    IFDEF FLOAT_SIZE
    float_size EQU FLOAT_SIZE
    ENDIF
    IFDEF FLT_SIZE
    flt_size EQU FLT_SIZE
    ENDIF
    IFDEF REAL8_SIZE
    real8_size EQU REAL8_SIZE
    ENDIF
    IFDEF DOUBLE_SIZE
    double_size EQU DOUBLE_SIZE
    ENDIF
    IFDEF DBL_SIZE
    dbl_size EQU DBL_SIZE
    ENDIF

    IFDEF BYTE_MAX
    byte_max EQU BYTE_MAX
    ENDIF
    IFDEF UBYTE_MAX
    ubyte_max EQU UBYTE_MAX
    ENDIF
    IFDEF CHAR_MAX
    char_max EQU CHAR_MAX
    ENDIF
    IFDEF UCHAR_MAX
    uchar_max EQU UCHAR_MAX
    ENDIF
    IFDEF INT8_MAX
    int8_max EQU INT8_MAX
    ENDIF
    IFDEF I8_MAX
    i8_max EQU I8_MAX
    ENDIF
    IFDEF UINT8_MAX
    uint8_max EQU UINT8_MAX
    ENDIF
    IFDEF UI8_MAX
    ui8_max EQU UI8_MAX
    ENDIF
    IFDEF UBYTE_MIN
    ubyte_min EQU UBYTE_MIN
    ENDIF
    IFDEF UCHAR_MIN
    uchar_min EQU UCHAR_MIN
    ENDIF
    IFDEF UINT8_MIN
    uint8_min EQU UINT8_MIN
    ENDIF
    IFDEF UI8_MIN
    ui8_min EQU UI8_MIN
    ENDIF
    IFDEF SBYTE_MAX
    sbyte_max EQU SBYTE_MAX
    ENDIF
    IFDEF SCHAR_MAX
    schar_max EQU SCHAR_MAX
    ENDIF
    IFDEF SINT8_MAX
    sint8_max EQU SINT8_MAX
    ENDIF
    IFDEF SI8_MAX
    si8_max EQU SI8_MAX
    ENDIF
    IFDEF BYTE_MIN
    byte_min EQU BYTE_MIN
    ENDIF
    IFDEF SBYTE_MIN
    sbyte_min EQU SBYTE_MIN
    ENDIF
    IFDEF CHAR_MIN
    char_min EQU CHAR_MIN
    ENDIF
    IFDEF SCHAR_MIN
    schar_min EQU SCHAR_MIN
    ENDIF
    IFDEF INT8_MIN
    int8_min EQU INT8_MIN
    ENDIF
    IFDEF SINT8_MIN
    sint8_min EQU SINT8_MIN
    ENDIF
    IFDEF I8_MIN
    i8_min EQU I8_MIN
    ENDIF
    IFDEF SI8_MIN
    si8_min EQU SI8_MIN
    ENDIF

    IFDEF MAX_BYTE
    max_byte EQU MAX_BYTE
    ENDIF
    IFDEF MAX_UBYTE
    max_ubyte EQU MAX_UBYTE
    ENDIF
    IFDEF MAX_CHAR
    max_char EQU MAX_CHAR
    ENDIF
    IFDEF MAX_UCHAR
    max_uchar EQU MAX_UCHAR
    ENDIF
    IFDEF MAX_INT8
    max_int8 EQU MAX_INT8
    ENDIF
    IFDEF MAX_UINT8
    max_uint8 EQU MAX_UINT8
    ENDIF
    IFDEF MAX_I8
    max_i8 EQU MAX_I8
    ENDIF
    IFDEF MAX_UI8
    max_ui8 EQU MAX_UI8
    ENDIF
    IFDEF MIN_UBYTE
    min_ubyte EQU MIN_UBYTE
    ENDIF
    IFDEF MIN_UCHAR
    min_uchar EQU MIN_UCHAR
    ENDIF
    IFDEF MIN_UINT8
    min_uint8 EQU MIN_UINT8
    ENDIF
    IFDEF MIN_UI8
    min_ui8 EQU MIN_UI8
    ENDIF
    IFDEF MAX_SBYTE
    max_sbyte EQU MAX_SBYTE
    ENDIF
    IFDEF MAX_SCHAR
    max_schar EQU MAX_SCHAR
    ENDIF
    IFDEF MAX_SINT8
    max_sint8 EQU MAX_SINT8
    ENDIF
    IFDEF MAX_SI8
    max_si8 EQU MAX_SI8
    ENDIF
    IFDEF MIN_BYTE
    min_byte EQU MIN_BYTE
    ENDIF
    IFDEF MIN_SBYTE
    min_sbyte EQU MIN_SBYTE
    ENDIF
    IFDEF MIN_CHAR
    min_char EQU MIN_CHAR
    ENDIF
    IFDEF MIN_SCHAR
    min_schar EQU MIN_SCHAR
    ENDIF
    IFDEF MIN_INT8
    min_int8 EQU MIN_INT8
    ENDIF
    IFDEF MIN_I8
    min_i8 EQU MIN_I8
    ENDIF
    IFDEF MIN_SINT8
    min_sint8 EQU MIN_SINT8
    ENDIF
    IFDEF MIN_SI8
    min_si8 EQU MIN_SI8
    ENDIF

    IFDEF WORD_MAX
    word_max EQU WORD_MAX
    ENDIF
    IFDEF UWORD_MAX
    uword_max EQU UWORD_MAX
    ENDIF
    IFDEF SHORT_MAX
    short_max EQU SHORT_MAX
    ENDIF
    IFDEF USHORT_MAX
    ushort_max EQU USHORT_MAX
    ENDIF
    IFDEF INT16_MAX
    int16_max EQU INT16_MAX
    ENDIF
    IFDEF I16_MAX
    i16_max EQU I16_MAX
    ENDIF
    IFDEF UINT16_MAX
    uint16_max EQU UINT16_MAX
    ENDIF
    IFDEF UI16_MAX
    ui16_max EQU UI16_MAX
    ENDIF
    IFDEF UWORD_MIN
    uword_min EQU UWORD_MIN
    ENDIF
    IFDEF USHORT_MIN
    ushort_min EQU USHORT_MIN
    ENDIF
    IFDEF UINT16_MIN
    uint16_min EQU UINT16_MIN
    ENDIF
    IFDEF UI16_MIN
    ui16_min EQU UI16_MIN
    ENDIF
    IFDEF SWORD_MAX
    sword_max EQU SWORD_MAX
    ENDIF
    IFDEF SSHORT_MAX
    sshort_max EQU SSHORT_MAX
    ENDIF
    IFDEF SINT16_MAX
    sint16_max EQU SINT16_MAX
    ENDIF
    IFDEF SI16_MAX
    si16_max EQU SI16_MAX
    ENDIF
    IFDEF WORD_MIN
    word_min EQU WORD_MIN
    ENDIF
    IFDEF SWORD_MIN
    sword_min EQU SWORD_MIN
    ENDIF
    IFDEF SHORT_MIN
    short_min EQU SHORT_MIN
    ENDIF
    IFDEF SSHORT_MIN
    sshort_min EQU SSHORT_MIN
    ENDIF
    IFDEF INT16_MIN
    int16_min EQU INT16_MIN
    ENDIF
    IFDEF I16_MIN
    i16_min EQU I16_MIN
    ENDIF
    IFDEF SINT16_MIN
    sint16_min EQU SINT16_MIN
    ENDIF
    IFDEF SI16_MIN
    si16_min EQU SI16_MIN
    ENDIF
    
    IFDEF MAX_WORD
    max_word EQU MAX_WORD
    ENDIF
    IFDEF MAX_UWORD
    max_uword EQU MAX_UWORD
    ENDIF
    IFDEF MAX_SHORT
    max_short EQU MAX_SHORT
    ENDIF
    IFDEF MAX_USHORT
    max_ushort EQU MAX_USHORT
    ENDIF
    IFDEF MAX_INT16
    max_int16 EQU MAX_INT16
    ENDIF
    IFDEF MAX_UINT16
    max_uint16 EQU MAX_UINT16
    ENDIF
    IFDEF MAX_I16
    max_i16 EQU MAX_I16
    ENDIF
    IFDEF MAX_UI16
    max_ui16 EQU MAX_UI16
    ENDIF
    IFDEF MIN_UWORD
    min_uword EQU MIN_UWORD
    ENDIF
    IFDEF MIN_USHORT
    min_ushort EQU MIN_USHORT
    ENDIF
    IFDEF MIN_UINT16
    min_uint16 EQU MIN_UINT16
    ENDIF
    IFDEF MIN_UI16
    min_ui16 EQU MIN_UI16
    ENDIF
    IFDEF MAX_SWORD
    max_sword EQU MAX_SWORD
    ENDIF
    IFDEF MAX_SSHORT
    max_sshort EQU MAX_SSHORT
    ENDIF
    IFDEF MAX_SINT16
    max_sint16 EQU MAX_SINT16
    ENDIF
    IFDEF MAX_SI16
    max_si16 EQU MAX_SI16
    ENDIF
    IFDEF MIN_WORD
    min_word EQU MIN_WORD
    ENDIF
    IFDEF MIN_SWORD
    min_sword EQU MIN_SWORD
    ENDIF
    IFDEF MIN_SHORT
    min_short EQU MIN_SHORT
    ENDIF
    IFDEF MIN_SSHORT
    min_sshort EQU MIN_SSHORT
    ENDIF
    IFDEF MIN_INT16
    min_int16 EQU MIN_INT16
    ENDIF
    IFDEF MIN_I16
    min_i16 EQU MIN_I16
    ENDIF
    IFDEF MIN_SINT16
    min_sint16 EQU MIN_SINT16
    ENDIF
    IFDEF MIN_SI16
    min_si16 EQU MIN_SI16
    ENDIF

    IFDEF BOOL_MAX
    bool_max EQU BOOL_MAX
    ENDIF
    IFDEF BOOL_MIN
    bool_min EQU BOOL_MIN
    ENDIF
    
    IFDEF MAX_BOOL
    max_bool EQU MAX_BOOL
    ENDIF
    IFDEF MIN_BOOL
    min_bool EQU MIN_BOOL
    ENDIF

    IFDEF DWORD_MAX
    dword_max EQU DWORD_MAX
    ENDIF
    IFDEF UDWORD_MAX
    udword_max EQU UDWORD_MAX
    ENDIF
    IFDEF LONG_MAX
    long_max EQU LONG_MAX
    ENDIF
    IFDEF ULONG_MAX
    ulong_max EQU ULONG_MAX
    ENDIF
    IFDEF INT_MAX
    int_max EQU INT_MAX
    ENDIF
    IFDEF UINT_MAX
    uint_max EQU UINT_MAX
    ENDIF
    IFDEF INT32_MAX
    int32_max EQU INT32_MAX
    ENDIF
    IFDEF I32_MAX
    i32_max EQU I32_MAX
    ENDIF
    IFDEF UINT32_MAX
    uint32_max EQU UINT32_MAX
    ENDIF
    IFDEF UI32_MAX
    ui32_max EQU UI32_MAX
    ENDIF
    IFDEF UDWORD_MIN
    udword_min EQU UDWORD_MIN
    ENDIF
    IFDEF ULONG_MIN
    ulong_min EQU ULONG_MIN
    ENDIF
    IFDEF UINT_MIN
    uint_min EQU UINT_MIN
    ENDIF
    IFDEF UINT32_MIN
    uint32_min EQU UINT32_MIN
    ENDIF
    IFDEF UI32_MIN
    ui32_min EQU UI32_MIN
    ENDIF
    IFDEF SDWORD_MAX
    sdword_max EQU SDWORD_MAX
    ENDIF
    IFDEF SLONG_MAX
    slong_max EQU SLONG_MAX
    ENDIF
    IFDEF SINT_MAX
    sint_max EQU SINT_MAX
    ENDIF
    IFDEF SINT32_MAX
    sint32_max EQU SINT32_MAX
    ENDIF
    IFDEF SI32_MAX
    si32_max EQU SI32_MAX
    ENDIF
    IFDEF DWORD_MIN
    dword_min EQU DWORD_MIN
    ENDIF
    IFDEF SDWORD_MIN
    sdword_min EQU SDWORD_MIN
    ENDIF
    IFDEF LONG_MIN
    long_min EQU LONG_MIN
    ENDIF
    IFDEF SLONG_MIN
    slong_min EQU SLONG_MIN
    ENDIF
    IFDEF INT_MIN
    int_min EQU INT_MIN
    ENDIF
    IFDEF SINT_MIN
    sint_min EQU SINT_MIN
    ENDIF
    IFDEF INT32_MIN
    int32_min EQU INT32_MIN
    ENDIF
    IFDEF I32_MIN
    i32_min EQU I32_MIN
    ENDIF
    IFDEF SINT32_MIN
    sint32_min EQU SINT32_MIN
    ENDIF
    IFDEF SI32_MIN
    si32_min EQU SI32_MIN
    ENDIF

    IFDEF MAX_DWORD
    max_dword EQU MAX_DWORD
    ENDIF
    IFDEF MAX_UDWORD
    max_udword EQU MAX_UDWORD
    ENDIF
    IFDEF MAX_LONG
    max_long EQU MAX_LONG
    ENDIF
    IFDEF MAX_ULONG
    max_ulong EQU MAX_ULONG
    ENDIF
    IFDEF MAX_INT
    max_int EQU MAX_INT
    ENDIF
    IFDEF MAX_UINT
    max_uint EQU MAX_UINT
    ENDIF
    IFDEF MAX_INT32
    max_int32 EQU MAX_INT32
    ENDIF
    IFDEF MAX_I32
    max_i32 EQU MAX_I32
    ENDIF
    IFDEF MAX_UINT32
    max_uint32 EQU MAX_UINT32
    ENDIF
    IFDEF MAX_UI32
    max_ui32 EQU MAX_UI32
    ENDIF
    IFDEF MIN_UDWORD
    min_udword EQU MIN_UDWORD
    ENDIF
    IFDEF MIN_ULONG
    min_ulong EQU MIN_ULONG
    ENDIF
    IFDEF MIN_UINT
    min_uint EQU MIN_UINT
    ENDIF
    IFDEF MIN_UINT32
    min_uint32 EQU MIN_UINT32
    ENDIF
    IFDEF MIN_UI32
    min_ui32 EQU MIN_UI32
    ENDIF
    IFDEF MAX_SDWORD
    max_sdword EQU MAX_SDWORD
    ENDIF
    IFDEF MAX_SLONG
    max_slong EQU MAX_SLONG
    ENDIF
    IFDEF MAX_SINT
    max_sint EQU MAX_SINT
    ENDIF
    IFDEF MAX_SINT32
    max_sint32 EQU MAX_SINT32
    ENDIF
    IFDEF MAX_SI32
    max_si32 EQU MAX_SI32
    ENDIF
    IFDEF MIN_DWORD
    min_dword EQU MIN_DWORD
    ENDIF
    IFDEF MIN_SDWORD
    min_sdword EQU MIN_SDWORD
    ENDIF
    IFDEF MIN_LONG
    min_long EQU MIN_LONG
    ENDIF
    IFDEF MIN_SLONG
    min_slong EQU MIN_SLONG
    ENDIF
    IFDEF MIN_INT
    min_int EQU MIN_INT
    ENDIF
    IFDEF MIN_SINT
    min_sint EQU MIN_SINT
    ENDIF
    IFDEF MIN_INT32
    min_int32 EQU MIN_INT32
    ENDIF
    IFDEF MIN_I32
    min_i32 EQU MIN_I32
    ENDIF
    IFDEF MIN_SINT32
    min_sint32 EQU MIN_SINT32
    ENDIF
    IFDEF MIN_SI32
    min_si32 EQU MIN_SI32
    ENDIF

    IFDEF QWORD_MAX
    qword_max EQU QWORD_MAX
    ENDIF
    IFDEF UQWORD_MAX
    uqword_max EQU UQWORD_MAX
    ENDIF
    IFDEF LONGLONG_MAX
    longlong_max EQU LONGLONG_MAX
    ENDIF
    IFDEF ULONGLONG_MAX
    ulonglong_max EQU ULONGLONG_MAX
    ENDIF
    IFDEF INT64_MAX
    int64_max EQU INT64_MAX
    ENDIF
    IFDEF I64_MAX
    i64_max EQU I64_MAX
    ENDIF
    IFDEF UINT64_MAX
    uint64_max EQU UINT64_MAX
    ENDIF
    IFDEF UI64_MAX
    ui64_max EQU UI64_MAX
    ENDIF
    IFDEF UQWORD_MIN
    uqword_min EQU UQWORD_MIN
    ENDIF
    IFDEF ULONGLONG_MIN
    ulonglong_min EQU ULONGLONG_MIN
    ENDIF
    IFDEF UINT64_MIN
    uint64_min EQU UINT64_MIN
    ENDIF
    IFDEF UI64_MIN
    ui64_min EQU UI64_MIN
    ENDIF
    IFDEF SQWORD_MAX
    sqword_max EQU SQWORD_MAX
    ENDIF
    IFDEF SLONGLONG_MAX
    slonglong_max EQU SLONGLONG_MAX
    ENDIF
    IFDEF SINT64_MAX
    sint64_max EQU SINT64_MAX
    ENDIF
    IFDEF SI64_MAX
    si64_max EQU SI64_MAX
    ENDIF
    IFDEF QWORD_MIN
    qword_min EQU QWORD_MIN
    ENDIF
    IFDEF SQWORD_MIN
    sqword_min EQU SQWORD_MIN
    ENDIF
    IFDEF LONGLONG_MIN
    longlong_min EQU LONGLONG_MIN
    ENDIF
    IFDEF SLONGLONG_MIN
    slonglong_min EQU SLONGLONG_MIN
    ENDIF
    IFDEF INT64_MIN
    int64_min EQU INT64_MIN
    ENDIF
    IFDEF I64_MIN
    i64_min EQU I64_MIN
    ENDIF
    IFDEF SINT64_MIN
    sint64_min EQU SINT64_MIN
    ENDIF
    IFDEF SI64_MIN
    si64_min EQU SI64_MIN
    ENDIF

    IFDEF MAX_QWORD
    max_qword EQU MAX_QWORD
    ENDIF
    IFDEF MAX_UQWORD
    max_uqword EQU MAX_UQWORD
    ENDIF
    IFDEF MAX_LONGLONG
    max_longlong EQU MAX_LONGLONG
    ENDIF
    IFDEF MAX_ULONGLONG
    max_ulonglong EQU MAX_ULONGLONG
    ENDIF
    IFDEF MAX_INT64
    max_int64 EQU MAX_INT64
    ENDIF
    IFDEF MAX_I64
    max_i64 EQU MAX_I64
    ENDIF
    IFDEF MAX_UINT64
    max_uint64 EQU MAX_UINT64
    ENDIF
    IFDEF MAX_UI64
    max_ui64 EQU MAX_UI64
    ENDIF
    IFDEF MIN_UQWORD
    min_uqword EQU MIN_UQWORD
    ENDIF
    IFDEF MIN_ULONGLONG
    min_ulonglong EQU MIN_ULONGLONG
    ENDIF
    IFDEF MIN_UINT64
    min_uint64 EQU MIN_UINT64
    ENDIF
    IFDEF MIN_UI64
    min_ui64 EQU MIN_UI64
    ENDIF
    IFDEF MAX_SQWORD
    max_sqword EQU MAX_SQWORD
    ENDIF
    IFDEF MAX_SLONGLONG
    max_slonglong EQU MAX_SLONGLONG
    ENDIF
    IFDEF MAX_SINT64
    max_sint64 EQU MAX_SINT64
    ENDIF
    IFDEF MAX_SI64
    max_si64 EQU MAX_SI64
    ENDIF
    IFDEF MIN_QWORD
    min_qword EQU MIN_QWORD
    ENDIF
    IFDEF MIN_SQWORD
    min_sqword EQU MIN_SQWORD
    ENDIF
    IFDEF MIN_LONGLONG
    min_longlong EQU MIN_LONGLONG
    ENDIF
    IFDEF MIN_SLONGLONG
    min_slonglong EQU MIN_SLONGLONG
    ENDIF
    IFDEF MIN_INT64
    min_int64 EQU MIN_INT64
    ENDIF
    IFDEF MIN_I64
    min_i64 EQU MIN_I64
    ENDIF
    IFDEF MIN_SINT64
    min_sint64 EQU MIN_SINT64
    ENDIF
    IFDEF MIN_SI64
    min_si64 EQU MIN_SI64
    ENDIF

    IFDEF BYTE_ERROR
    byte_error EQU BYTE_ERROR
    ENDIF
    IFDEF CHAR_ERROR
    char_error EQU CHAR_ERROR
    ENDIF
    IFDEF INT8_ERROR
    int8_error EQU INT8_ERROR
    ENDIF
    IFDEF I8_ERROR
    i8_error EQU I8_ERROR
    ENDIF
    IFDEF UBYTE_ERROR
    ubyte_error EQU UBYTE_ERROR
    ENDIF
    IFDEF UCHAR_ERROR
    uchar_error EQU UCHAR_ERROR
    ENDIF
    IFDEF UINT8_ERROR
    uint8_error EQU UINT8_ERROR
    ENDIF
    IFDEF UI8_ERROR
    ui8_error EQU UI8_ERROR
    ENDIF
    IFDEF SBYTE_ERROR
    sbyte_error EQU SBYTE_ERROR
    ENDIF
    IFDEF SCHAR_ERROR
    schar_error EQU SCHAR_ERROR
    ENDIF
    IFDEF SINT8_ERROR
    sint8_error EQU SINT8_ERROR
    ENDIF
    IFDEF SI8_ERROR
    si8_error EQU SI8_ERROR
    ENDIF

    IFDEF WORD_ERROR
    word_error EQU WORD_ERROR
    ENDIF
    IFDEF SHORT_ERROR
    short_error EQU SHORT_ERROR
    ENDIF
    IFDEF INT16_ERROR
    int16_error EQU INT16_ERROR
    ENDIF
    IFDEF I16_ERROR
    i16_error EQU I16_ERROR
    ENDIF
    IFDEF UWORD_ERROR
    uword_error EQU UWORD_ERROR
    ENDIF
    IFDEF USHORT_ERROR
    ushort_error EQU USHORT_ERROR
    ENDIF
    IFDEF UINT16_ERROR
    uint16_error EQU UINT16_ERROR
    ENDIF
    IFDEF UI16_ERROR
    ui16_error EQU UI16_ERROR
    ENDIF
    IFDEF SWORD_ERROR
    sword_error EQU SWORD_ERROR
    ENDIF
    IFDEF SSHORT_ERROR
    sshort_error EQU SSHORT_ERROR
    ENDIF
    IFDEF SINT16_ERROR
    sint16_error EQU SINT16_ERROR
    ENDIF
    IFDEF SI16_ERROR
    si16_error EQU SI16_ERROR
    ENDIF

    IFDEF DWORD_ERROR
    dword_error EQU DWORD_ERROR
    ENDIF
    IFDEF LONG_ERROR
    long_error EQU LONG_ERROR
    ENDIF
    IFDEF INT_ERROR
    int_error EQU INT_ERROR
    ENDIF
    IFDEF INT32_ERROR
    int32_error EQU INT32_ERROR
    ENDIF
    IFDEF I32_ERROR
    i32_error EQU I32_ERROR
    ENDIF
    IFDEF UDWORD_ERROR
    udword_error EQU UDWORD_ERROR
    ENDIF
    IFDEF ULONG_ERROR
    ulong_error EQU ULONG_ERROR
    ENDIF
    IFDEF UINT_ERROR
    uint_error EQU UINT_ERROR
    ENDIF
    IFDEF UINT32_ERROR
    uint32_error EQU UINT32_ERROR
    ENDIF
    IFDEF UI32_ERROR
    ui32_error EQU UI32_ERROR
    ENDIF
    IFDEF SDWORD_ERROR
    sdword_error EQU SDWORD_ERROR
    ENDIF
    IFDEF SLONG_ERROR
    slong_error EQU SLONG_ERROR
    ENDIF
    IFDEF SINT_ERROR
    sint_error EQU SINT_ERROR
    ENDIF
    IFDEF SINT32_ERROR
    sint32_error EQU SINT32_ERROR
    ENDIF
    IFDEF SI32_ERROR
    si32_error EQU SI32_ERROR
    ENDIF

    IFDEF QWORD_ERROR
    qword_error EQU QWORD_ERROR
    ENDIF
    IFDEF LONGLONG_ERROR
    longlong_error EQU LONGLONG_ERROR
    ENDIF
    IFDEF INT64_ERROR
    int64_error EQU INT64_ERROR
    ENDIF
    IFDEF I64_ERROR
    i64_error EQU I64_ERROR
    ENDIF
    IFDEF UQWORD_ERROR
    uqword_error EQU UQWORD_ERROR
    ENDIF
    IFDEF ULONGLONG_ERROR
    ulonglong_error EQU ULONGLONG_ERROR
    ENDIF
    IFDEF UINT64_ERROR
    uint64_error EQU UINT64_ERROR
    ENDIF
    IFDEF UI64_ERROR
    ui64_error EQU UI64_ERROR
    ENDIF
    IFDEF SQWORD_ERROR
    sqword_error EQU SQWORD_ERROR
    ENDIF
    IFDEF SLONGLONG_ERROR
    slonglong_error EQU SLONGLONG_ERROR
    ENDIF
    IFDEF SINT64_ERROR
    sint64_error EQU SINT64_ERROR
    ENDIF
    IFDEF SI64_ERROR
    si64_error EQU SI64_ERROR
    ENDIF

    IFDEF FLOAT_ERROR
    float_error EQU FLOAT_ERROR
    ENDIF
    IFDEF FLT_ERROR
    flt_error EQU FLT_ERROR
    ENDIF
    IFDEF DOUBLE_ERROR
    double_error EQU DOUBLE_ERROR
    ENDIF
    IFDEF DBL_ERROR
    dbl_error EQU DBL_ERROR
    ENDIF

    IFDEF STACK_SIZE
    stack_size EQU STACK_SIZE
    ENDIF
    IFDEF SIZE_T_SIZE
    size_t_size EQU SIZE_T_SIZE
    ENDIF
    IFDEF PTRDIFF_T_SIZE
    ptrdiff_t_size EQU PTRDIFF_T_SIZE
    ENDIF
    IFDEF INTPTR_T_SIZE
    intptr_t_size EQU INTPTR_T_SIZE
    ENDIF
    IFDEF UINTPTR_T_SIZE
    uintptr_t_size EQU UINTPTR_T_SIZE
    ENDIF
    IFDEF PTR_SIZE
    ptr_size EQU PTR_SIZE
    ENDIF
    IFDEF REG_SIZE
    reg_size EQU REG_SIZE
    ENDIF
    IFDEF SINTSIZE_T_MAX
    sintsize_t_max EQU SINTSIZE_T_MAX
    ENDIF
    IFDEF SINTSIZE_T_MIN
    sintsize_t_min EQU SINTSIZE_T_MIN
    ENDIF
    IFDEF UINTSIZE_T_MAX
    uintsize_t_max EQU UINTSIZE_T_MAX
    ENDIF
    IFDEF UINTSIZE_T_MIN
    uintsize_t_min EQU UINTSIZE_T_MIN
    ENDIF
    IFDEF INTSIZE_T_MAX
    intsize_t_max EQU INTSIZE_T_MAX
    ENDIF
    IFDEF INTSIZE_T_MIN
    intsize_t_min EQU INTSIZE_T_MIN
    ENDIF
    IFDEF SIZE_T_MAX
    size_t_max EQU SIZE_T_MAX
    ENDIF
    IFDEF SIZE_T_MIN
    size_t_min EQU SIZE_T_MIN
    ENDIF
    IFDEF PTRDIFF_T_MAX
    ptrdiff_t_max EQU PTRDIFF_T_MAX
    ENDIF
    IFDEF PTRDIFF_T_MIN
    ptrdiff_t_min EQU PTRDIFF_T_MIN
    ENDIF
    IFDEF INTPTR_T_MAX
    intptr_t_max EQU INTPTR_T_MAX
    ENDIF
    IFDEF INTPTR_T_MIN
    intptr_t_min EQU INTPTR_T_MIN
    ENDIF
    IFDEF UINTPTR_T_MAX
    uintptr_t_max EQU UINTPTR_T_MAX
    ENDIF
    IFDEF UINTPTR_T_MIN
    uintptr_t_min EQU UINTPTR_T_MIN
    ENDIF
    IFDEF SINTPTR_MAX
    sintptr_max EQU SINTPTR_MAX
    ENDIF
    IFDEF SINTPTR_MIN
    sintptr_min EQU SINTPTR_MIN
    ENDIF
    IFDEF UINTPTR_MAX
    uintptr_max EQU UINTPTR_MAX
    ENDIF
    IFDEF UINTPTR_MIN
    uintptr_min EQU UINTPTR_MIN
    ENDIF
    IFDEF INTPTR_MAX
    intptr_max EQU INTPTR_MAX
    ENDIF
    IFDEF INTPTR_MIN
    intptr_min EQU INTPTR_MIN
    ENDIF
    IFDEF MAX_SINTSIZE_T
    max_sintsize_t EQU MAX_SINTSIZE_T
    ENDIF
    IFDEF MIN_SINTSIZE_T
    min_sintsize_t EQU MIN_SINTSIZE_T
    ENDIF
    IFDEF MAX_UINTSIZE_T
    max_uintsize_t EQU MAX_UINTSIZE_T
    ENDIF
    IFDEF MIN_UINTSIZE_T
    min_uintsize_t EQU MIN_UINTSIZE_T
    ENDIF
    IFDEF MAX_INTSIZE_T
    max_intsize_t EQU MAX_INTSIZE_T
    ENDIF
    IFDEF MIN_INTSIZE_T
    min_intsize_t EQU MIN_INTSIZE_T
    ENDIF
    IFDEF MAX_SIZE_T
    max_size_t EQU MAX_SIZE_T
    ENDIF
    IFDEF MIN_SIZE_T
    min_size_t EQU MIN_SIZE_T
    ENDIF
    IFDEF MAX_PTRDIFF_T
    max_ptrdiff_t EQU MAX_PTRDIFF_T
    ENDIF
    IFDEF MIN_PTRDIFF_T
    min_ptrdiff_t EQU MIN_PTRDIFF_T
    ENDIF
    IFDEF MAX_INTPTR_T
    max_intptr_t EQU MAX_INTPTR_T
    ENDIF
    IFDEF MIN_INTPTR_T
    min_intptr_t EQU MIN_INTPTR_T
    ENDIF
    IFDEF MAX_UINTPTR_T
    max_uintptr_t EQU MAX_UINTPTR_T
    ENDIF
    IFDEF MIN_UINTPTR_T
    min_uintptr_t EQU MIN_UINTPTR_T
    ENDIF
    IFDEF MAX_SINTPTR
    max_sintptr EQU MAX_SINTPTR
    ENDIF
    IFDEF MIN_SINTPTR
    min_sintptr EQU MIN_SINTPTR
    ENDIF
    IFDEF MAX_UINTPTR
    max_uintptr EQU MAX_UINTPTR
    ENDIF
    IFDEF MIN_UINTPTR
    min_uintptr EQU MIN_UINTPTR
    ENDIF
    IFDEF MAX_INTPTR
    max_intptr EQU MAX_INTPTR
    ENDIF
    IFDEF MIN_INTPTR
    min_intptr EQU MIN_INTPTR
    ENDIF
    IFDEF SINTSIZE_T_ERROR
    sintsize_t_error EQU SINTSIZE_T_ERROR
    ENDIF
    IFDEF UINTSIZE_T_ERROR
    uintsize_t_error EQU UINTSIZE_T_ERROR
    ENDIF
    IFDEF INTSIZE_T_ERROR
    intsize_t_error EQU INTSIZE_T_ERROR
    ENDIF
    IFDEF SIZE_T_ERROR
    size_t_error EQU SIZE_T_ERROR
    ENDIF
    IFDEF PTRDIFF_T_ERROR
    ptrdiff_t_error EQU PTRDIFF_T_ERROR
    ENDIF
    IFDEF INTPTR_T_ERROR
    intptr_t_error EQU INTPTR_T_ERROR
    ENDIF
    IFDEF UINTPTR_T_ERROR
    uintptr_t_error EQU UINTPTR_T_ERROR
    ENDIF
    IFDEF SINTPTR_ERROR
    sintptrt_error EQU SINTPTR_ERROR
    ENDIF
    IFDEF UINTPTR_ERROR
    uintptr_error EQU UINTPTR_ERROR
    ENDIF
    IFDEF INTPTR_ERROR
    intptr_error EQU INTPTR_ERROR
    ENDIF

    IFDEF FALSE
    false EQU FALSE
    ENDIF
    IFDEF TRUE
    true EQU TRUE
    ENDIF

    IFDEF NULL
    null EQU NULL
    ENDIF

    IFDEF M8_FALSE
    m8_false EQU M8_FALSE
    ENDIF
    IFDEF M8_TRUE
    m8_true EQU M8_TRUE
    ENDIF
    IFDEF BYTE_FALSE
    byte_false EQU BYTE_FALSE
    ENDIF
    IFDEF BYTE_TRUE
    byte_true EQU BYTE_TRUE
    ENDIF
    IFDEF CHAR_FALSE
    char_false EQU CHAR_FALSE
    ENDIF
    IFDEF CHAR_TRUE
    char_true EQU CHAR_TRUE
    ENDIF
    IFDEF INT8_FALSE
    int8_false EQU INT8_FALSE
    ENDIF
    IFDEF INT8_TRUE
    int8_true EQU INT8_TRUE
    ENDIF
    IFDEF I8_FALSE
    i8_false EQU I8_FALSE
    ENDIF
    IFDEF I8_TRUE
    i8_true EQU I8_TRUE
    ENDIF
    IFDEF I8_0
    i8_0 EQU I8_0
    ENDIF
    IFDEF I8_1
    i8_1 EQU I8_1
    ENDIF
    IFDEF I8_NEG0
    i8_neg0 EQU I8_NEG0
    ENDIF
    IFDEF I8_NEG1
    i8_neg1 EQU I8_NEG1
    ENDIF
    IFDEF I8_NEG2
    i8_neg2 EQU I8_NEG2
    ENDIF

    IFDEF M16_FALSE
    m16_false EQU M16_FALSE
    ENDIF
    IFDEF M16_TRUE
    m16_true EQU M16_TRUE
    ENDIF
    IFDEF WORD_FALSE
    word_false EQU WORD_FALSE
    ENDIF
    IFDEF WORD_TRUE
    word_true EQU WORD_TRUE
    ENDIF
    IFDEF SHORT_FALSE
    short_false EQU SHORT_FALSE
    ENDIF
    IFDEF SHORT_TRUE
    short_true EQU SHORT_TRUE
    ENDIF
    IFDEF INT16_FALSE
    int16_false EQU INT16_FALSE
    ENDIF
    IFDEF INT16_TRUE
    int16_true EQU INT16_TRUE
    ENDIF
    IFDEF I16_FALSE
    i16_false EQU I16_FALSE
    ENDIF
    IFDEF I16_TRUE
    i16_true EQU I16_TRUE
    ENDIF
    IFDEF I16_0
    i16_0 EQU I16_0
    ENDIF
    IFDEF I16_1
    i16_1 EQU I16_1
    ENDIF
    IFDEF I16_NEG0
    i16_neg0 EQU I16_NEG0
    ENDIF
    IFDEF I16_NEG1
    i16_neg1 EQU I16_NEG1
    ENDIF
    IFDEF I16_NEG2
    i16_neg2 EQU I16_NEG2
    ENDIF

    IFDEF M32_FALSE
    m32_false EQU M32_FALSE
    ENDIF
    IFDEF M32_TRUE
    m32_true EQU M32_TRUE
    ENDIF
    IFDEF DWORD_FALSE
    dword_false EQU DWORD_FALSE
    ENDIF
    IFDEF DWORD_TRUE
    dword_true EQU DWORD_TRUE
    ENDIF
    IFDEF LONG_FALSE
    long_false EQU LONG_FALSE
    ENDIF
    IFDEF LONG_TRUE
    long_true EQU LONG_TRUE
    ENDIF
    IFDEF INT_FALSE
    int_false EQU INT_FALSE
    ENDIF
    IFDEF INT_TRUE
    int_true EQU INT_TRUE
    ENDIF
    IFDEF INT32_FALSE
    int32_false EQU INT32_FALSE
    ENDIF
    IFDEF INT32_TRUE
    int32_true EQU INT32_TRUE
    ENDIF
    IFDEF I32_FALSE
    i32_false EQU I32_FALSE
    ENDIF
    IFDEF I32_TRUE
    i32_true EQU I32_TRUE
    ENDIF
    IFDEF I32_0
    i32_0 EQU I32_0
    ENDIF
    IFDEF I32_1
    i32_1 EQU I32_1
    ENDIF
    IFDEF I32_2
    i32_2 EQU I32_2
    ENDIF
    IFDEF I32_NEG0
    i32_neg0 EQU I32_NEG0
    ENDIF
    IFDEF I32_NEG1
    i32_neg1 EQU I32_NEG1
    ENDIF
    IFDEF I32_NEG2
    i32_neg2 EQU I32_NEG2
    ENDIF

    IFDEF MM_SIZE
    mm_size EQU MM_SIZE
    ENDIF
    IFDEF M64_SIZE
    m64_size EQU M64_SIZE
    ENDIF
    IFDEF MM_FALSE
    mm_false EQU MM_FALSE
    ENDIF
    IFDEF MM_TRUE
    mm_true EQU MM_TRUE
    ENDIF
    IFDEF M64_FALSE
    m64_false EQU M64_FALSE
    ENDIF
    IFDEF M64_TRUE
    m64_true EQU M64_TRUE
    ENDIF
    IFDEF QWORD_FALSE
    qword_false EQU QWORD_FALSE
    ENDIF
    IFDEF QWORD_TRUE
    qword_true EQU QWORD_TRUE
    ENDIF
    IFDEF LONGLONG_FALSE
    longlong_false EQU LONGLONG_FALSE
    ENDIF
    IFDEF LONGLONG_TRUE
    longlong_true EQU LONGLONG_TRUE
    ENDIF
    IFDEF INT64_FALSE
    int64_false EQU INT64_FALSE
    ENDIF
    IFDEF INT64_TRUE
    int64_true EQU INT64_TRUE
    ENDIF
    IFDEF I64_FALSE
    i64_false EQU I64_FALSE
    ENDIF
    IFDEF I64_TRUE
    i64_true EQU I64_TRUE
    ENDIF
    IFDEF I64_0
    i64_0 EQU I64_0
    ENDIF
    IFDEF I64_1
    i64_1 EQU I64_1
    ENDIF
    IFDEF I64_NEG0
    i64_neg0 EQU I64_NEG0
    ENDIF
    IFDEF I64_NEG1
    i64_neg1 EQU I64_NEG1
    ENDIF
    IFDEF I64_NEG2
    i64_neg2 EQU I64_NEG2
    ENDIF

    IFDEF XMM_SIZE
    xmm_size EQU XMM_SIZE
    ENDIF
    IFDEF M128_SIZE
    m128_size EQU M128_SIZE
    ENDIF
    IFDEF XMMWORD_SIZE
    xmmword_size EQU XMMWORD_SIZE
    ENDIF
    IFDEF OWORD_SIZE
    oword_size EQU OWORD_SIZE
    ENDIF
    IFDEF YMM_SIZE
    ymm_size EQU YMM_SIZE
    ENDIF
    IFDEF M256_SIZE
    m256_size EQU M256_SIZE
    ENDIF
    IFDEF YMMWORD_SIZE
    ymmword_size EQU YMMWORD_SIZE
    ENDIF
    IFDEF ZMM_SIZE
    zmm_size EQU ZMM_SIZE
    ENDIF
    IFDEF M512_SIZE
    m512_size EQU M512_SIZE
    ENDIF
    IFDEF ZMMWORD_SIZE
    zmmword_size EQU ZMMWORD_SIZE
    ENDIF

    ENDIF ;CASEMAPNONE

    INCLUDE real4limits.inc
    INCLUDE real8limits.inc
    
    ENDIF ;WITHMACROLIB

    ENDIF    ;LIMITS_INC
