
; / / / / / / / / / / / / / / / / / / / / / / / / / / / / / / / / / / / / / / / / / / /
; / / / / / / / / / / / / / / / / / / / / / / / / / / / / / / / / / / / / / / / / / / /
; / /                                                                               / /
; / /                Copyright 2020 (c) UASM macro assembly library                 / /
; / /                                                                               / /
; / /    Licensed under the Apache License, Version 2.0 (the "License");            / /
; / /    you may not use this file except in compliance with the License.           / /
; / /    You may obtain a copy of the License at                                    / /
; / /                                                                               / /
; / /        http://www.apache.org/licenses/LICENSE-2.0                             / /
; / /                                                                               / /
; / /    Unless required by applicable law or agreed to in writing, software        / /
; / /    distributed under the License is distributed on an "AS IS" BASIS,          / /
; / /    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.   / /
; / /    See the License for the specific language governing permissions and        / /
; / /    limitations under the License.                                             / /
; / /                                                                               / /
; / / / / / / / / / / / / / / / / / / / / / / / / / / / / / / / / / / / / / / / / / / /
; / / / / / / / / / / / / / / / / / / / / / / / / / / / / / / / / / / / / / / / / / / /

    IFNDEF REAL4LIMITS_INC
    REAL4LIMITS EQU 1
    
    IFDEF WITHMACROLIB

    IFNDEF MACROLIB_INC
    .ERR <"REAL4LIMITS_INC must be included by MACROLIB_INC">
    ENDIF
    
    IFNDEF LIMITS_INC
    .ERR <"REAL4LIMITS_INC requires LIMITS_INC">
    ENDIF
    
    IFNDEF X86ORX64
    .ERR <"REAL4LIMITS_INC requires one x86 or x64 platform type">
    ENDIF

   ;/float mask*/
    FLT_1LSHL3_MSK EQU 0x00000008
    FLT_1LSHL4_MSK EQU 0x00000010
    FLT_1LSHL7_MSK EQU 0x00000080
    FLT_1LSHL8_MSK EQU 0x00000100
    FLT_1LSHL11_MSK EQU 0x00000800
    FLT_1LSHL12_MSK EQU 0x00001000
    FLT_1LSHL15_MSK EQU 0x00008000
    FLT_1LSHL16_MSK EQU 0x00010000
    FLT_1LSHL19_MSK EQU 0x00080000
    FLT_1LSHL20_MSK EQU 0x00100000
    FLT_1LSHL23_MSK EQU 0x00800000
    FLT_1LSHL24_MSK EQU 0x01000000
    FLT_1LSHL27_MSK EQU 0x08000000
    FLT_1LSHL28_MSK EQU 0x10000000
    FLT_1LSHL31_MSK EQU 0x80000000

    FLT_NEG1LSHL3_MSK EQU 0xfffffff8
    FLT_NEG1LSHL4_MSK EQU 0xfffffff0
    FLT_NEG1LSHL7_MSK EQU 0xffffff80
    FLT_NEG1LSHL8_MSK EQU 0xffffff00
    FLT_NEG1LSHL11_MSK EQU 0xfffff800
    FLT_NEG1LSHL12_MSK EQU 0xfffff000
    FLT_NEG1LSHL15_MSK EQU 0xffff8000
    FLT_NEG1LSHL16_MSK EQU 0xffff0000
    FLT_NEG1LSHL19_MSK EQU 0xfff80000
    FLT_NEG1LSHL20_MSK EQU 0xfff00000
    FLT_NEG1LSHL23_MSK EQU 0xff800000
    FLT_NEG1LSHL24_MSK EQU 0xff000000
    FLT_NEG1LSHL27_MSK EQU 0xf8000000
    FLT_NEG1LSHL28_MSK EQU 0xf0000000
    FLT_NEG1LSHL31_MSK EQU 0x80000000

    FLT_FALSE_MSK EQU 0x00000000
    FLT_TRUE_MSK EQU 0xffffffff
    FLT_ERROR_MSK EQU FLT_ERROR

    FLT_MAGIC_MSK EQU 0x4b000000
    FLT_SIGN_MSK EQU 0x80000000
    FLT_INVSIGN_MSK EQU 0x7fffffff

    FLT_INF_MSK EQU 0x7f800000
    FLT_FIN_MSK EQU 0xff000000
    FLT_INVINF_MSK EQU 0x807fffff
    FLT_NEGINF_MSK EQU 0xff800000
    FLT_NAN_MSK EQU 0x7fffffff
    FLT_QNAN_MSK EQU 0x7fc00000
    FLT_NEGQNAN_MSK EQU 0xffc00000
    FLT_NANTEST_MSK EQU 0x007fffff
    FLT_ABS_MSK EQU 0x7fffffff
    FLT_MIN_MSK EQU 0x00800000
    FLT_MAX_MSK EQU 0x7f7fffff
    FLT_NOFRACTION_MSK EQU 0x00800000
    FLT_MINDENORM_MSK EQU 0x00000001
    FLT_DENORMLIMIT_MSK EQU 0x00800000
    FLT_MINNORMAL_MSK EQU 0x00800000
    FLT_MAXNORMAL_MSK EQU 0x7f7fffff

    FLT_DECDIG_MSK EQU 0x00000009
    FLT_DIG_MSK EQU 0x00000006
    FLT_NEGDECDIG_MSK EQU 0xfffffff7
    FLT_NEGDIG_MSK EQU 0xfffffffa
    FLT_EPS_MSK EQU 0x34000000
    FLT_EPSILON_MSK EQU 0x34000000
    FLT_NORMEPS_MSK EQU 0x1e3ce508
    FLT_GUARD_MSK EQU 0x00000000
    FLT_MANTPOW2_MSK EQU 0x00800000
    FLT_MAXMANTPOW2_MSK EQU 0x7f7fffff
    FLT_MANTDIG_MSK EQU 0x00000018
    FLT_MANT_MSK EQU 0x00000017
    FLT_NEGMANTDIG_MSK EQU 0xffffffe8
    FLT_NEGMANT_MSK EQU 0xffffffe9
    FLT_MAXEXPO_MSK EQU 0x00000080
    FLT_EXPOSIGN_MSK EQU 0x00000080
    FLT_EXPO_MSK EQU 0x0000007f
    FLT_NEGMAXEXPO_MSK EQU 0xffffff80
    FLT_NEGEXPOSIGN_MSK EQU 0xffffff80
    FLT_NEGEXPO_MSK EQU 0xffffff81
    FLT_SUBNORMALEXPO_MSK EQU 0xffffff82
    FLT_MINEXPO_MSK EQU 0xffffff83
    FLT_MAXDECEXPO_MSK EQU 0x00000026
    FLT_NEGMAXDECEXPO_MSK EQU 0xffffffda
    FLT_MINDECEXPO_MSK EQU 0xffffffd8
    FLT_EXPOFIELD_MSK EQU 0xff000000
    FLT_MANTFIELD_MSK EQU 0x00ffffff
    FLT_NORM_MSK EQU 0x00000000
    FLT_RADIX_MSK EQU 0x00000002
    FLT_ROUNDS_MSK EQU 0x00000001
    FLT_SUBDEC_MSK EQU 0x0000000a
    FLT_SQRTMAX_MSK EQU 0x5f7ffff0
    FLT_SMALLNORMAL_MSK EQU 0x00800000

    FLT_HALFMINUSEPS_MSK EQU 0x3efffffd
    FLT_TRUEINT_MSK EQU 0x00000001
    
    FLT_BYTE_MSK EQU 0x000000ff
    FLT_BYTE_EVEN_MSK EQU 0x00ff00ff
    FLT_BYTE_ODD_MSK EQU 0xff00ff00
    FLT_4LOW_MSK EQU 0x0fffffff
    FLT_4HIGH_MSK EQU 0xfffffff0
    FLT_FLIP4_MSK EQU 0x00000008
    FLT_8LOW_MSK EQU 0x00ffffff
    FLT_8HIGH_MSK EQU 0xffffff00
    FLT_FLIP8_MSK EQU 0x00000080
    FLT_12LOW_MSK EQU 0x000fffff
    FLT_12HIGH_MSK EQU 0xfffff000
    FLT_FLIP12_MSK EQU 0x00000800
    FLT_16LOW_MSK EQU 0x0000ffff
    FLT_16HIGH_MSK EQU 0xffff0000
    FLT_FLIP16_MSK EQU 0x00008000
    FLT_20LOW_MSK EQU 0x00000fff
    FLT_20HIGH_MSK EQU 0xfff00000
    FLT_FLIP20_MSK EQU 0x00080000
    FLT_24LOW_MSK EQU 0x000000ff
    FLT_24HIGH_MSK EQU 0xff000000
    FLT_FLIP24_MSK EQU 0x00800000
    FLT_28LOW_MSK EQU 0x0000000f
    FLT_28HIGH_MSK EQU 0xf0000000
    FLT_FLIP28_MSK EQU 0x08000000
    FLT_32LOW_MSK EQU 0x00000000
    FLT_32HIGH_MSK EQU 0x00000000
    FLT_FLIP32_MSK EQU 0x80000000

    FLT_0_MSK EQU 0x00000000
    FLT_0D5_MSK EQU 0x3f000000
    FLT_1_MSK EQU 0x3f800000
    FLT_1D5_MSK EQU 0x3fc00000
    FLT_2_MSK EQU 0x40000000
    FLT_2D5_MSK EQU 0x40200000
    FLT_3_MSK EQU 0x40400000
    FLT_4_MSK EQU 0x40800000
    FLT_5_MSK EQU 0x40a00000
    FLT_6_MSK EQU 0x40c00000
    FLT_7_MSK EQU 0x40e00000
    FLT_8_MSK EQU 0x41000000
    FLT_9_MSK EQU 0x41100000
    FLT_10_MSK EQU 0x41200000
    FLT_20_MSK EQU 0x41a00000
    FLT_23_MSK EQU 0x41b80000
    FLT_23D5_MSK EQU 0x41bc0000
    FLT_24_MSK EQU 0x41c00000
    FLT_24D5_MSK EQU 0x41c40000
    FLT_25_MSK EQU 0x41c80000

    FLT_128_MSK EQU 0x43000000

    FLT_253_MSK EQU 0x437d0000

    FLT_NEG0_MSK EQU 0x80000000
    FLT_NEG1_MSK EQU 0xbf800000

    FLT_NEG150_MSK EQU 0xc3160000
    
    FLT_A8_MSK EQU 0x00ff0000
    FLT_R8_MSK EQU 0x0000ff00
    FLT_G8_MSK EQU 0x000000ff
    FLT_B8_MSK EQU 0xff000000

    FLT_FLIPA8_MSK EQU FLT_0_MSK
    FLT_FLIPR8_MSK EQU FLT_0_MSK
    FLT_FLIPG8_MSK EQU FLT_0_MSK
    FLT_FLIPB8_MSK EQU FLT_NEG0_MSK

    FLT_A2_MSK EQU 0x000003ff
    FLT_B10_MSK EQU 0x000ffc00
    FLT_G10_MSK EQU 0x3ff00000
    FLT_R10_MSK EQU 0xc0000000

    FLT_FLIPA2_MSK EQU 0x00000200
    FLT_FLIPB10_MSK EQU 0x00080000
    FLT_FLIPG10_MSK EQU 0x20000000
    FLT_FLIPR10_MSK EQU 0x80000000

    FLT_BIN128_MSK EQU FLT_128_MSK
    FLT_BINNEG150_MSK EQU FLT_NEG150_MSK

    FLT_MAXRAND_MSK EQU 0x00007fff

    FLT_MAXI8_MSK EQU 0x0000007f
    FLT_MINI8_MSK EQU 0xffffff80
    FLT_MAXU8_MSK EQU 0x000000ff

    FLT_MAXI16_MSK EQU 0x00007fff
    FLT_MINI16_MSK EQU 0xffff8000
    FLT_MAXU16_MSK EQU 0x0000ffff

    FLT_MAXI32_MSK EQU 0x7fffffff
    FLT_MINI32_MSK EQU 0x80000000
    FLT_MAXU32_MSK EQU 0xffffffff

    FLT_MAXI8XU8_MSK EQU 0x00008000
    FLT_MINI8XU8_MSK EQU 0xffff8000
    FLT_MAXI8XU16_MSK EQU 0x00800000
    FLT_MINI8XU16_MSK EQU 0xff800000

    FLT_MAXI16XU16_MSK EQU 0x80000000
    FLT_MINI16XU16_MSK EQU 0x80000000

    FLT_FIXUNSIGNED_MSK EQU 0x80000000
    FLT_FIXUNSIGNED32_MSK EQU 0x80000000
    FLT_FIXMAXI32_MSK EQU 0x7fffff80
    FLT_FIXMAXU32_MSK EQU 0xffffff00

   ;/float int*/
    FLT_1LSHL3_INT EQU 8
    FLT_1LSHL4_INT6 EQU 1
    FLT_1LSHL7_INT EQU 128
    FLT_1LSHL8_INT EQU 256
    FLT_1LSHL11_INT EQU 2048
    FLT_1LSHL12_INT EQU 4096
    FLT_1LSHL15_INT EQU 32768
    FLT_1LSHL16_INT EQU 65536
    FLT_1LSHL19_INT EQU 524288
    FLT_1LSHL20_INT EQU 1048576
    FLT_1LSHL23_INT EQU 8388608
    FLT_1LSHL24_INT EQU 16777216
    FLT_1LSHL27_INT EQU 134217728
    FLT_1LSHL28_INT EQU 268435456
    FLT_1LSHL31_INT EQU 2147483648

    FLT_NEG1LSHL3_INT EQU (-8)
    FLT_NEG1LSHL4_INT EQU (-16)
    FLT_NEG1LSHL7_INT EQU (-128)
    FLT_NEG1LSHL8_INT EQU (-256)
    FLT_NEG1LSHL11_INT EQU (-2048)
    FLT_NEG1LSHL12_INT EQU (-4096)
    FLT_NEG1LSHL15_INT EQU (-32768)
    FLT_NEG1LSHL16_INT EQU (-65536)
    FLT_NEG1LSHL19_INT EQU (-524288)
    FLT_NEG1LSHL20_INT EQU (-1048576)
    FLT_NEG1LSHL23_INT EQU (-8388608)
    FLT_NEG1LSHL24_INT EQU (-16777216)
    FLT_NEG1LSHL27_INT EQU (-134217728)
    FLT_NEG1LSHL28_INT EQU (-268435456)
    FLT_NEG1LSHL31_INT EQU (-2147483648)

    FLT_FALSE_INT EQU 0
    FLT_TRUE_INT EQU (-1)
    FLT_ERROR_INT EQU FLT_ERROR

    FLT_MAGIC_INT EQU 1258291200
    FLT_SIGN_INT EQU (-2147483648)
    FLT_INVSIGN_INT EQU 2147483647

    FLT_INF_INT EQU 2139095040
    FLT_FIN_INT EQU (-16777216)
    FLT_INVINF_INT EQU (-2139095041)
    FLT_NEGINF_INT EQU (-8388608)
    FLT_NAN_INT EQU 2147483647
    FLT_QNAN_INT EQU 2143289344
    FLT_NEGQNAN_INT EQU (-4194304)
    FLT_NANTEST_INT EQU 8388607
    FLT_ABS_INT EQU 2147483647
    FLT_MIN_INT EQU 8388608
    FLT_MAX_INT EQU 2139095039
    FLT_NOFRACTION_INT EQU 8388608
    FLT_MINDENORM_INT EQU 1
    FLT_DENORMLIMIT_INT EQU 8388608
    FLT_MINNORMAL_INT EQU 8388608
    FLT_MAXNORMAL_INT EQU 2139095039

    FLT_DECDIG_INT EQU 9
    FLT_DIG_INT EQU 6
    FLT_NEGDECDIG_INT EQU (-9)
    FLT_NEGDIG_INT EQU (-6)
    FLT_EPS_INT EQU 872415232
    FLT_EPSILON_INT EQU 872415232
    FLT_NORMEPS_INT EQU 507307272
    FLT_GUARD_INT EQU 0
    FLT_MANTPOW2_INT EQU 8388608
    FLT_MAXMANTPOW2_INT EQU 2139095039
    FLT_MANTDIG_INT EQU 24
    FLT_MANT_INT EQU 23
    FLT_NEGMANTDIG_INT EQU (-24)
    FLT_NEGMANT_INT EQU (-23)
    FLT_MAXEXPO_INT EQU 128
    FLT_EXPOSIGN_INT EQU 128
    FLT_EXPO_INT EQU 127
    FLT_NEGMAXEXPO_INT EQU (-128)
    FLT_NEGEXPOSIGN_INT EQU (-128)
    FLT_NEGEXPO_INT EQU (-127)
    FLT_SUBNORMALEXPO_INT EQU (-126)
    FLT_MINEXPO_INT EQU (-125)
    FLT_MAXDECEXPO_INT EQU 38
    FLT_NEGMAXDECEXPO_INT EQU (-38)
    FLT_MINDECEXPO_INT EQU (-37)
    FLT_EXPOFIELD_INT EQU (-16777216)
    FLT_MANTFIELD_INT EQU 16777215
    FLT_NORM_INT EQU 0
    FLT_RADIX_INT EQU 2
    FLT_ROUNDS_INT EQU 1
    FLT_SUBDEC_INT EQU 10
    FLT_SQRTMAX_INT EQU 1602224112
    FLT_SMALLNORMAL_INT EQU 8388608

    FLT_HALFMINUSEPS_INT EQU 1056964605
    FLT_TRUEINT_INT EQU 1

    FLT_BYTE_INT EQU 255
    FLT_BYTE_EVEN_INT EQU 16711935
    FLT_BYTE_ODD_INT EQU (-16711936)
    FLT_4LOW_INT EQU 268435455
    FLT_4HIGH_INT EQU (-16)
    FLT_FLIP4_INT EQU 8
    FLT_8LOW_INT EQU 16777215
    FLT_8HIGH_INT EQU (-256)
    FLT_FLIP8_INT EQU 128
    FLT_12LOW_INT EQU 1048575
    FLT_12HIGH_INT EQU (-4096)
    FLT_FLIP12_INT EQU 2048
    FLT_16LOW_INT EQU 65535
    FLT_16HIGH_INT EQU (-65536)
    FLT_FLIP16_INT EQU 32768
    FLT_20LOW_INT EQU 4095
    FLT_20HIGH_INT EQU (-1048576)
    FLT_FLIP20_INT EQU 524288
    FLT_24LOW_INT EQU 255
    FLT_24HIGH_INT EQU (-16777216)
    FLT_FLIP24_INT EQU 8388608
    FLT_28LOW_INT EQU 15
    FLT_28HIGH_INT EQU (-268435456)
    FLT_FLIP28_INT EQU 134217728
    FLT_32LOW_INT EQU 0
    FLT_32HIGH_INT EQU 0
    FLT_FLIP32_INT EQU (-2147483648)

    FLT_0_INT EQU 0x00000000
    FLT_0D5_INT EQU 1056964608
    FLT_1_INT EQU 1065353216
    FLT_1D5_INT EQU 1069547520
    FLT_2_INT EQU 1073741824
    FLT_2D5_INT EQU 1075838976
    FLT_3_INT EQU 1077936128
    FLT_4_INT EQU 1082130432
    FLT_5_INT EQU 1084227584
    FLT_6_INT EQU 1086324736
    FLT_7_INT EQU 1088421888
    FLT_8_INT EQU 1090519040
    FLT_9_INT EQU 1091567616
    FLT_10_INT EQU 1092616192
    FLT_20_INT EQU 1101004800
    FLT_23_INT EQU 1102577664
    FLT_23D5_INT EQU 1102839808
    FLT_24_INT EQU 1103101952
    FLT_24D5_INT EQU 1103364096
    FLT_25_INT EQU 1103626240

    FLT_128_INT EQU 1124073472

    FLT_253_INT EQU 1132265472

    FLT_NEG0_INT EQU (-2147483648)
    FLT_NEG1_INT EQU (-1082130432)

    FLT_NEG150_INT EQU (-1021968384)

    FLT_A8_INT EQU 16711680
    FLT_R8_INT EQU 65280
    FLT_G8_INT EQU 255
    FLT_B8_INT EQU (-16777216)

    FLT_FLIPA8_INT EQU FLT_0_INT
    FLT_FLIPR8_INT EQU FLT_0_INT
    FLT_FLIPG8_INT EQU FLT_0_INT
    FLT_FLIPB8_INT EQU FLT_NEG0_INT

    FLT_A2_INT EQU 1023
    FLT_B10_INT EQU 1047552
    FLT_G10_INT EQU 1072693248
    FLT_R10_INT EQU (-1073741824)

    FLT_FLIPA2_INT EQU 512
    FLT_FLIPB10_INT EQU 524288
    FLT_FLIPG10_INT EQU 536870912
    FLT_FLIPR10_INT EQU (-2147483648)

    FLT_BIN128_INT EQU FLT_128_INT
    FLT_BINNEG150_INT EQU FLT_NEG150_INT

    FLT_MAXRAND_INT EQU 32767

    FLT_MAXI8_INT EQU 127
    FLT_MINI8_INT EQU (-128)
    FLT_MAXU8_INT EQU 255

    FLT_MAXI16_INT EQU 32767
    FLT_MINI16_INT EQU (-32768)
    FLT_MAXU16_INT EQU 65535

    FLT_MAXI32_INT EQU 2147483647
    FLT_MINI32_INT EQU (-2147483648)
    FLT_MAXU32_INT EQU (-1)

    FLT_MAXI8XU8_INT EQU 32768
    FLT_MINI8XU8_INT EQU (-32768)
    FLT_MAXI8XU16_INT EQU 8388608
    FLT_MINI8XU16_INT EQU (-8388608)

    FLT_MAXI16XU16_INT EQU (-2147483648)
    FLT_MINI16XU16_INT EQU (-2147483648)

    FLT_FIXUNSIGNED_INT EQU (-2147483648)
    FLT_FIXUNSIGNED32_INT EQU (-2147483648)
    FLT_FIXMAXI32_INT EQU 2147483520
    FLT_FIXMAXU32_INT EQU (-256)

   ;/float*/
    FLT_1LSHL3 EQU 8.0
    FLT_1LSHL4 EQU 16.0
    FLT_1LSHL7 EQU 128.0
    FLT_1LSHL8 EQU 256.0
    FLT_1LSHL11 EQU 2048.0
    FLT_1LSHL12 EQU 4096.0
    FLT_1LSHL15 EQU 32768.0
    FLT_1LSHL16 EQU 65536.0
    FLT_1LSHL19 EQU 524288.0
    FLT_1LSHL20 EQU 1048576.0
    FLT_1LSHL23 EQU 8388608.0
    FLT_1LSHL24 EQU 16777216.0
    FLT_1LSHL27 EQU 134217728.0
    FLT_1LSHL28 EQU 268435456.0
    FLT_1LSHL31 EQU 2147483648.0

    FLT_NEG1LSHL3 EQU (-8.0)
    FLT_NEG1LSHL4 EQU (-16.0)
    FLT_NEG1LSHL7 EQU (-128.0)
    FLT_NEG1LSHL8 EQU (-256.0)
    FLT_NEG1LSHL11 EQU (-2048.0)
    FLT_NEG1LSHL12 EQU (-4096.0)
    FLT_NEG1LSHL15 EQU (-32768.0)
    FLT_NEG1LSHL16 EQU (-65536.0)
    FLT_NEG1LSHL19 EQU (-524288.0)
    FLT_NEG1LSHL20 EQU (-1048576.0)
    FLT_NEG1LSHL23 EQU (-8388608.0)
    FLT_NEG1LSHL24 EQU (-16777216.0)
    FLT_NEG1LSHL27 EQU (-134217728.0)
    FLT_NEG1LSHL28 EQU (-268435456.0)
    FLT_NEG1LSHL31 EQU (-2147483648.0)

    FLT_FALSE EQU FLT_FALSE_MSK
    FLT_TRUE EQU FLT_TRUE_MSK

    FLT_MAGIC EQU FLT_MAGIC_MSK
    FLT_SIGN EQU FLT_SIGN_MSK
    FLT_INVSIGN EQU FLT_INVSIGN_MSK

    FLT_INF EQU FLT_INF_MSK
    FLT_FIN EQU FLT_FIN_MSK
    FLT_INVINF EQU FLT_INVINF_MSK
    FLT_NEGINF EQU FLT_NEGINF_MSK
    FLT_NAN EQU FLT_NAN_MSK
    FLT_QNAN EQU FLT_QNAN_MSK
    FLT_NEGQNAN EQU FLT_NEGQNAN_MSK
    FLT_NANTEST EQU FLT_NANTEST_MSK
    FLT_ABS EQU FLT_ABS_MSK
    FLT_MIN EQU (1.175494351e-038)
    FLT_MAX EQU (3.402823457175904428664032e+038)
    FLT_NOFRACTION EQU 8388608.0
    ;//FLT_MINDENORM EQU (1.401298463344573974609375e-045)
    FLT_MINDENORM EQU 0x00000001
    FLT_DENORMLIMIT EQU (1.175494351e-038)
    FLT_MINNORMAL EQU (1.175494351e-038)
    FLT_MAXNORMAL EQU (3.402823457175904428664032e+038)

    FLT_DECDIG EQU 9.0
    FLT_DIG EQU 6.0
    FLT_NEGDECDIG EQU (-9.0)
    FLT_NEGDIG EQU (-6.0)
    FLT_EPS EQU (1.192092896e-07)
    FLT_EPSILON EQU (1.192092896e-07)
    FLT_NORMEPS EQU (1.0e-020)
    FLT_GUARD EQU 0.0
    FLT_MANTPOW2 EQU (1.175494351e-038)
    FLT_MAXMANTPOW2 EQU (3.402823457175904428664032e+038)
    FLT_MANTDIG EQU 24.0
    FLT_MANT EQU 23.0
    FLT_NEGMANTDIG EQU (-24.0)
    FLT_NEGMANT EQU (-23.0)
    FLT_MAXEXPO EQU 128.0
    FLT_EXPOSIGN EQU 128.0
    FLT_EXPO EQU 127.0
    FLT_NEGMAXEXPO EQU (-128.0)
    FLT_NEGEXPOSIGN EQU (-128.0)
    FLT_NEGEXPO EQU (-127.0)
    FLT_SUBNORMALEXPO EQU (-126.0)
    FLT_MINEXPO EQU (-125.0)
    FLT_MAXDECEXPO EQU 38.0
    FLT_NEGMAXDECEXPO EQU (-38.0)
    FLT_MINDECEXPO EQU (-37.0)
    FLT_EXPOFIELD EQU (-16777216.0)
    FLT_MANTFIELD EQU 16777215.0
    FLT_NORM EQU 0.0
    FLT_RADIX EQU 2.0
    FLT_ROUNDS EQU 1.0
    FLT_SUBDEC EQU 10.0
    FLT_SQRTMAX EQU (1.8446726e+019)
    FLT_SMALLNORMAL EQU (1.175494351e-038)

    FLT_HALFMINUSEPS EQU 0.499999910593032825
    FLT_TRUEINT EQU 1.0

    FLT_BYTE EQU 255.0
    FLT_BYTE_EVEN EQU 16711935.0
    FLT_BYTE_ODD EQU (-16711936.0)
    FLT_4LOW EQU 268435455.0
    FLT_4HIGH EQU (-16.0)
    FLT_FLIP4 EQU 8.0
    FLT_8LOW EQU 16777215.0
    FLT_8HIGH EQU (-256.0)
    FLT_FLIP8 EQU 128.0
    FLT_12LOW EQU 1048575.0
    FLT_12HIGH EQU (-4096.0)
    FLT_FLIP12 EQU 2048.0
    FLT_16LOW EQU 65535.0
    FLT_16HIGH EQU (-65536.0)
    FLT_FLIP16 EQU 32768.0
    FLT_20LOW EQU 4095.0
    FLT_20HIGH EQU (-1048576.0)
    FLT_FLIP20 EQU 524288.0
    FLT_24LOW EQU 255.0
    FLT_24HIGH EQU (-16777216.0)
    FLT_FLIP24 EQU 8388608.0
    FLT_28LOW EQU 15.0
    FLT_28HIGH EQU (-268435456.0)
    FLT_FLIP28 EQU 134217728.0
    FLT_32LOW EQU 0.0
    FLT_32HIGH EQU 0.0
    FLT_FLIP32 EQU (-2147483648.0)

    FLT_0 EQU 0.0
    FLT_0D0001 EQU 0.0001
    FLT_0D0002 EQU 0.0002
    FLT_0D0003 EQU 0.0003
    FLT_0D0004 EQU 0.0004
    FLT_0D0005 EQU 0.0005
    FLT_0D0006 EQU 0.0006
    FLT_0D0007 EQU 0.0007
    FLT_0D0008 EQU 0.0008
    FLT_0D0009 EQU 0.0009
    FLT_0D001 EQU 0.001
    FLT_0D002 EQU 0.002
    FLT_0D003 EQU 0.003
    FLT_0D004 EQU 0.004
    FLT_0D005 EQU 0.005
    FLT_0D006 EQU 0.006
    FLT_0D007 EQU 0.007
    FLT_0D008 EQU 0.008
    FLT_0D009 EQU 0.009
    FLT_0D01 EQU 0.01
    FLT_0D02 EQU 0.02
    FLT_0D025 EQU 0.025
    FLT_0D03 EQU 0.03
    FLT_0D04 EQU 0.04
    FLT_0D05 EQU 0.05
    FLT_0D06 EQU 0.06
    FLT_0D07 EQU 0.07
    FLT_0D08 EQU 0.08
    FLT_0D09 EQU 0.09
    FLT_0D1 EQU 0.1
    FLT_0D2 EQU 0.2
    FLT_0D25 EQU 0.25
    FLT_0D3 EQU 0.3
    FLT_0D4 EQU 0.4
    FLT_0D5 EQU 0.5
    FLT_0D6 EQU 0.6
    FLT_0D7 EQU 0.7
    FLT_0D8 EQU 0.8
    FLT_0D9 EQU 0.9
    FLT_1 EQU 1.0
    FLT_1D25 EQU 1.25
    FLT_1D5 EQU 1.5
    FLT_2 EQU 2.0
    FLT_2D25 EQU 2.25
    FLT_2D5 EQU 2.5
    FLT_3 EQU 3.0
    FLT_3D25 EQU 3.25
    FLT_3D5 EQU 3.5
    FLT_4 EQU 4.0
    FLT_4D25 EQU 4.25
    FLT_4D5 EQU 4.5
    FLT_5 EQU 5.0
    FLT_5D25 EQU 5.25
    FLT_5D5 EQU 5.5
    FLT_6 EQU 6.0
    FLT_6D25 EQU 6.25
    FLT_6D5 EQU 6.5
    FLT_7 EQU 7.0
    FLT_7D25 EQU 7.25
    FLT_7D5 EQU 7.5
    FLT_8 EQU 8.0
    FLT_8D25 EQU 8.25
    FLT_8D5 EQU 8.5
    FLT_9 EQU 9.0
    FLT_9D25 EQU 9.25
    FLT_9D5 EQU 9.5
    FLT_10 EQU 10.0
    FLT_11 EQU 11.0
    FLT_12 EQU 12.0
    FLT_13 EQU 13.0
    FLT_14 EQU 14.0
    FLT_15 EQU 15.0
    FLT_16 EQU 16.0
    FLT_17 EQU 17.0
    FLT_18 EQU 18.0
    FLT_19 EQU 19.0
    FLT_20 EQU 20.0
    FLT_21 EQU 21.0
    FLT_22 EQU 22.0
    FLT_23 EQU 23.0
    FLT_24 EQU 24.0
    FLT_24D5 EQU 24.5
    FLT_25 EQU 25.0
    FLT_26 EQU 26.0
    FLT_27 EQU 27.0
    FLT_28 EQU 28.0
    FLT_29 EQU 29.0
    FLT_30 EQU 30.0
    FLT_31 EQU 31.0
    FLT_32 EQU 32.0
    FLT_33 EQU 33.0
    FLT_34 EQU 34.0
    FLT_35 EQU 35.0
    FLT_36 EQU 36.0
    FLT_37 EQU 37.0
    FLT_38 EQU 38.0
    FLT_39 EQU 39.0
    FLT_40 EQU 40.0
    FLT_41 EQU 41.0
    FLT_42 EQU 42.0
    FLT_43 EQU 43.0
    FLT_44 EQU 44.0
    FLT_45 EQU 45.0
    FLT_46 EQU 46.0
    FLT_47 EQU 47.0
    FLT_48 EQU 48.0
    FLT_49 EQU 49.0
    FLT_50 EQU 50.0
    FLT_51 EQU 51.0
    FLT_52 EQU 52.0
    FLT_53 EQU 53.0
    FLT_54 EQU 54.0
    FLT_55 EQU 55.0
    FLT_56 EQU 56.0
    FLT_57 EQU 57.0
    FLT_58 EQU 58.0
    FLT_59 EQU 59.0
    FLT_60 EQU 60.0
    FLT_61 EQU 61.0
    FLT_62 EQU 62.0
    FLT_63 EQU 63.0
    FLT_64 EQU 64.0
    FLT_65 EQU 65.0
    FLT_66 EQU 66.0
    FLT_67 EQU 67.0
    FLT_68 EQU 68.0
    FLT_69 EQU 69.0
    FLT_70 EQU 70.0
    FLT_71 EQU 71.0
    FLT_72 EQU 72.0
    FLT_73 EQU 73.0
    FLT_74 EQU 74.0
    FLT_75 EQU 75.0
    FLT_76 EQU 76.0
    FLT_77 EQU 77.0
    FLT_78 EQU 78.0
    FLT_79 EQU 79.0
    FLT_80 EQU 80.0
    FLT_81 EQU 81.0
    FLT_82 EQU 82.0
    FLT_83 EQU 83.0
    FLT_84 EQU 84.0
    FLT_85 EQU 85.0
    FLT_86 EQU 86.0
    FLT_87 EQU 87.0
    FLT_88 EQU 88.0
    FLT_89 EQU 89.0
    FLT_90 EQU 90.0
    FLT_91 EQU 91.0
    FLT_92 EQU 92.0
    FLT_93 EQU 93.0
    FLT_94 EQU 94.0
    FLT_95 EQU 95.0
    FLT_96 EQU 96.0
    FLT_97 EQU 97.0
    FLT_98 EQU 98.0
    FLT_99 EQU 99.0
    FLT_100 EQU 100.0
    FLT_125 EQU 125.0
    FLT_126 EQU 126.0
    FLT_127 EQU 127.0
    FLT_128 EQU 128.0
    FLT_140 EQU 140.0
    FLT_145 EQU 145.0
    FLT_150 EQU 150.0
    FLT_180 EQU 180.0
    FLT_253 EQU 253.0
    FLT_254 EQU 254.0
    FLT_255 EQU 255.0
    FLT_256 EQU 256.0
    FLT_360 EQU 360.0
    FLT_511 EQU 511.0
    FLT_512 EQU 512.0
    FLT_513 EQU 513.0
    FLT_1023 EQU 1023.0
    FLT_1024 EQU 1024.0
    FLT_1025 EQU 1025.0

    FLT_32767 EQU 32767.0
    FLT_32768 EQU 32768.0
    FLT_65535 EQU 65535.0
    FLT_65536 EQU 65536.0
    FLT_2147483647 EQU 2147483647.0
    FLT_2147483648 EQU 2147483648.0
    FLT_4294967295 EQU 4294967295.0
    FLT_4294967296 EQU 4294967296.0

    FLT_NEG0 EQU (-0.0)
    FLT_NEG0D0001 EQU (-0.0001)
    FLT_NEG0D0002 EQU (-0.0002)
    FLT_NEG0D0003 EQU (-0.0003)
    FLT_NEG0D0004 EQU (-0.0004)
    FLT_NEG0D0005 EQU (-0.0005)
    FLT_NEG0D0006 EQU (-0.0006)
    FLT_NEG0D0007 EQU (-0.0007)
    FLT_NEG0D0008 EQU (-0.0008)
    FLT_NEG0D0009 EQU (-0.0009)
    FLT_NEG0D001 EQU (-0.001)
    FLT_NEG0D002 EQU (-0.002)
    FLT_NEG0D003 EQU (-0.003)
    FLT_NEG0D004 EQU (-0.004)
    FLT_NEG0D005 EQU (-0.005)
    FLT_NEG0D006 EQU (-0.006)
    FLT_NEG0D007 EQU (-0.007)
    FLT_NEG0D008 EQU (-0.008)
    FLT_NEG0D009 EQU (-0.009)
    FLT_NEG0D01 EQU (-0.01)
    FLT_NEG0D02 EQU (-0.02)
    FLT_NEG0D025 EQU (-0.025)
    FLT_NEG0D03 EQU (-0.03)
    FLT_NEG0D04 EQU (-0.04)
    FLT_NEG0D05 EQU (-0.05)
    FLT_NEG0D06 EQU (-0.06)
    FLT_NEG0D07 EQU (-0.07)
    FLT_NEG0D08 EQU (-0.08)
    FLT_NEG0D09 EQU (-0.09)
    FLT_NEG0D1 EQU (-0.1)
    FLT_NEG0D2 EQU (-0.2)
    FLT_NEG0D25 EQU (-0.25)
    FLT_NEG0D3 EQU (-0.3)
    FLT_NEG0D4 EQU (-0.4)
    FLT_NEG0D5 EQU (-0.5)
    FLT_NEG0D6 EQU (-0.6)
    FLT_NEG0D7 EQU (-0.7)
    FLT_NEG0D8 EQU (-0.8)
    FLT_NEG0D9 EQU (-0.9)
    FLT_NEG1 EQU (-1.0)
    FLT_NEG1D25 EQU (-1.25)
    FLT_NEG1D5 EQU (-1.5)
    FLT_NEG2 EQU (-2.0)
    FLT_NEG2D25 EQU (-2.25)
    FLT_NEG2D5 EQU (-2.5)
    FLT_NEG3 EQU (-3.0)
    FLT_NEG3D25 EQU (-3.25)
    FLT_NEG3D5 EQU (-3.5)
    FLT_NEG4 EQU (-4.0)
    FLT_NEG4D25 EQU (-4.25)
    FLT_NEG4D5 EQU (-4.5)
    FLT_NEG5 EQU (-5.0)
    FLT_NEG5D25 EQU (-5.25)
    FLT_NEG5D5 EQU (-5.5)
    FLT_NEG6 EQU (-6.0)
    FLT_NEG6D25 EQU (-6.25)
    FLT_NEG6D5 EQU (-6.5)
    FLT_NEG7 EQU (-7.0)
    FLT_NEG7D25 EQU (-7.25)
    FLT_NEG7D5 EQU (-7.5)
    FLT_NEG8 EQU (-8.0)
    FLT_NEG8D25 EQU (-8.25)
    FLT_NEG8D5 EQU (-8.5)
    FLT_NEG9 EQU (-9.0)
    FLT_NEG9D25 EQU (-9.25)
    FLT_NEG9D5 EQU (-9.5)
    FLT_NEG10 EQU (-10.0)
    FLT_NEG11 EQU (-11.0)
    FLT_NEG12 EQU (-12.0)
    FLT_NEG13 EQU (-13.0)
    FLT_NEG14 EQU (-14.0)
    FLT_NEG15 EQU (-15.0)
    FLT_NEG16 EQU (-16.0)
    FLT_NEG17 EQU (-17.0)
    FLT_NEG18 EQU (-18.0)
    FLT_NEG19 EQU (-19.0)
    FLT_NEG20 EQU (-20.0)
    FLT_NEG21 EQU (-21.0)
    FLT_NEG22 EQU (-22.0)
    FLT_NEG23 EQU (-23.0)
    FLT_NEG24 EQU (-24.0)
    FLT_NEG24D5 EQU (-24.5)
    FLT_NEG25 EQU (-25.0)
    FLT_NEG26 EQU (-26.0)
    FLT_NEG27 EQU (-27.0)
    FLT_NEG28 EQU (-28.0)
    FLT_NEG29 EQU (-29.0)
    FLT_NEG30 EQU (-30.0)
    FLT_NEG31 EQU (-31.0)
    FLT_NEG32 EQU (-32.0)
    FLT_NEG33 EQU (-33.0)
    FLT_NEG34 EQU (-34.0)
    FLT_NEG35 EQU (-35.0)
    FLT_NEG36 EQU (-36.0)
    FLT_NEG37 EQU (-37.0)
    FLT_NEG38 EQU (-38.0)
    FLT_NEG39 EQU (-39.0)
    FLT_NEG40 EQU (-40.0)
    FLT_NEG41 EQU (-41.0)
    FLT_NEG42 EQU (-42.0)
    FLT_NEG43 EQU (-43.0)
    FLT_NEG44 EQU (-44.0)
    FLT_NEG45 EQU (-45.0)
    FLT_NEG46 EQU (-46.0)
    FLT_NEG47 EQU (-47.0)
    FLT_NEG48 EQU (-48.0)
    FLT_NEG49 EQU (-49.0)
    FLT_NEG50 EQU (-50.0)
    FLT_NEG51 EQU (-51.0)
    FLT_NEG52 EQU (-52.0)
    FLT_NEG53 EQU (-53.0)
    FLT_NEG54 EQU (-54.0)
    FLT_NEG55 EQU (-55.0)
    FLT_NEG56 EQU (-56.0)
    FLT_NEG57 EQU (-57.0)
    FLT_NEG58 EQU (-58.0)
    FLT_NEG59 EQU (-59.0)
    FLT_NEG60 EQU (-60.0)
    FLT_NEG61 EQU (-61.0)
    FLT_NEG62 EQU (-62.0)
    FLT_NEG63 EQU (-63.0)
    FLT_NEG64 EQU (-64.0)
    FLT_NEG65 EQU (-65.0)
    FLT_NEG66 EQU (-66.0)
    FLT_NEG67 EQU (-67.0)
    FLT_NEG68 EQU (-68.0)
    FLT_NEG69 EQU (-69.0)
    FLT_NEG70 EQU (-70.0)
    FLT_NEG71 EQU (-71.0)
    FLT_NEG72 EQU (-72.0)
    FLT_NEG73 EQU (-73.0)
    FLT_NEG74 EQU (-74.0)
    FLT_NEG75 EQU (-75.0)
    FLT_NEG76 EQU (-76.0)
    FLT_NEG77 EQU (-77.0)
    FLT_NEG78 EQU (-78.0)
    FLT_NEG79 EQU (-79.0)
    FLT_NEG80 EQU (-80.0)
    FLT_NEG81 EQU (-81.0)
    FLT_NEG82 EQU (-82.0)
    FLT_NEG83 EQU (-83.0)
    FLT_NEG84 EQU (-84.0)
    FLT_NEG85 EQU (-85.0)
    FLT_NEG86 EQU (-86.0)
    FLT_NEG87 EQU (-87.0)
    FLT_NEG88 EQU (-88.0)
    FLT_NEG89 EQU (-89.0)
    FLT_NEG90 EQU (-90.0)
    FLT_NEG91 EQU (-91.0)
    FLT_NEG92 EQU (-92.0)
    FLT_NEG93 EQU (-93.0)
    FLT_NEG94 EQU (-94.0)
    FLT_NEG95 EQU (-95.0)
    FLT_NEG96 EQU (-96.0)
    FLT_NEG97 EQU (-97.0)
    FLT_NEG98 EQU (-98.0)
    FLT_NEG99 EQU (-99.0)
    FLT_NEG100 EQU (-100.0)
    FLT_NEG125 EQU (-125.0)
    FLT_NEG126 EQU (-126.0)
    FLT_NEG127 EQU (-127.0)
    FLT_NEG128 EQU (-128.0)
    FLT_NEG140 EQU (-140.0)
    FLT_NEG145 EQU (-145.0)
    FLT_NEG150 EQU (-150.0)
    FLT_NEG180 EQU (-180.0)
    FLT_NEG253 EQU (-253.0)
    FLT_NEG254 EQU (-254.0)
    FLT_NEG255 EQU (-255.0)
    FLT_NEG256 EQU (-256.0)
    FLT_NEG360 EQU (-360.0)
    FLT_NEG511 EQU (-511.0)
    FLT_NEG512 EQU (-512.0)
    FLT_NEG513 EQU (-513.0)
    FLT_NEG1023 EQU (-1023.0)
    FLT_NEG1024 EQU (-1024.0)
    FLT_NEG1025 EQU (-1025.0)

    FLT_NEG32767 EQU (-32767.0)
    FLT_NEG32768 EQU (-32768.0)
    FLT_NEG65535 EQU (-65535.0)
    FLT_NEG65536 EQU (-65536.0)
    FLT_NEG2147483647 EQU (-2147483647.0)
    FLT_NEG2147483648 EQU (-2147483648.0)
    FLT_NEG4294967295 EQU (-4294967295.0)
    FLT_NEG4294967296 EQU (-4294967296.0)

    FLT_BIN128 EQU FLT_128_MSK
    FLT_BINNEG150 EQU FLT_NEG150_MSK

    FLT_MAXRAND EQU FLT_32767

    FLT_MAXI8 EQU 127.0
    FLT_MINI8 EQU (-128.0)
    FLT_MAXU8 EQU 255.0
    FLT_MINU8 EQU 0.0

    FLT_MAXI16 EQU 32767.0
    FLT_MINI16 EQU (-32768.0)
    FLT_MAXU16 EQU 65535.0
    FLT_MINU16 EQU 0.0

    FLT_MAXI32 EQU 2147483647.0
    FLT_MINI32 EQU (-2147483648.0)
    FLT_MAXU32 EQU 4294967295.0
    FLT_MINU32 EQU 0.0

    FLT_MAXI8XU8 EQU 32768.0
    FLT_MINI8XU8 EQU (-32768.0)
    FLT_MAXI8XU16 EQU 8388608.0
    FLT_MINI8XU16 EQU (-8388608.0)

    FLT_MAXI16XU16 EQU 2147483648.0
    FLT_MINI16XU16 EQU (-2147483648.0)

    FLT_FIXUNSIGNED EQU 2147483648.0
    FLT_FIXUNSIGNED32 EQU 2147483648.0
    FLT_FIXMAXI32 EQU 2147483520.0
    FLT_FIXMAXU32 EQU 4294967040.0

    FLT_RCPI16 EQU (3.0518509475997192297128208258309e-05)
    FLT_RCPU16 EQU 0.0000152587890625
    FLT_RCPI16XU16 EQU (4.656754985961485641041291543321e-010)

    FLT_FIXAA8 EQU FLT_0
    FLT_FIXR8 EQU FLT_0
    FLT_FIXG8 EQU FLT_0
    FLT_FIXB8 EQU FLT_2147483648

    FLT_NORMA8 EQU (5.983838848039216e-08)
    FLT_NORMR8 EQU (1.531862745098039e-05)
    FLT_NORMG8 EQU 0.003921568627451
    FLT_NORMB8 EQU (2.337437050015319e-010)

    FLT_FIXAA2 EQU (-512.0)
    FLT_FIXB10 EQU (-524288.0)
    FLT_FIXG10 EQU (-536870912.0)
    FLT_FIXR10 EQU FLT_2147483648

    FLT_NORMA2 EQU 0.0019569471624266
    FLT_NORMB10 EQU (1.911081213307241e-06)
    FLT_NORMG10 EQU (1.866290247370352e-09)
    FLT_NORMR10 EQU (3.104408582051595e-010)

    FLT_MG EQU 1024.0
    FLT_NEGMG EQU (-1024.0)
    FLT_HALFMG EQU 512.0
    FLT_NEGHALFMG EQU (-512.0)
    FLT_MGDIV4 EQU 256.0
    FLT_NEGMGDIV4 EQU (-256.0)
    FLT_HALFMGXMG EQU 524288.0
    FLT_HALFMGXSQRMG EQU 536870912.0
    FLT_HALFMGXCUBEMG EQU 549755813888.0
    FLT_NEGHALFMGXMG EQU (-524288.0)
    FLT_NEGHALFMGXSQRMG EQU (-536870912.0)
    FLT_NEGHALFMGXCUBEMG EQU (-549755813888.0)
    FLT_SQRMG EQU 1048576.0
    FLT_CUBEMG EQU 1073741824.0
    FLT_SQRTMG EQU 32.0
    FLT_CBRTMG EQU 10.0793683991589853181
    FLT_RCPMG EQU 0.0009765625
    FLT_RCPSQRMG EQU 0.00000095367431640625
    FLT_RCPCUBEMG EQU 0.00000000093132257462
    FLT_RCPSQRTMG EQU 0.03125
    FLT_RCPCBRTMG EQU 0.09921256574801246717

    FLT_2MG EQU 2048.0
    FLT_NEG2MG EQU (-2048.0)
    FLT_SQR2MG EQU 4194304.0
    FLT_CUBE2MG EQU 8589934592.0
    FLT_SQRT2MG EQU 45.25483399593904156165403917471
    FLT_CBRT2MG EQU 12.699208415745595798013645114178
    FLT_4MG EQU 4096.0
    FLT_NEG4MG EQU (-4096.0)
    FLT_SQR4MG EQU 16777216.0
    FLT_CUBE4MG EQU 68719476736.0
    FLT_SQRT4MG EQU 64.0
    FLT_CBRT4MG EQU 16.0
    FLT_RCP2MG EQU 0.00048828125
    FLT_RCP4MG EQU 0.000244140625

    FLT_E EQU 2.71828182845904523536
    FLT_EXP EQU 2.71828182845904523536
    FLT_LOGE EQU 0.434294481903251827651
    FLT_LOGEHIGH EQU 0.434294481903251827651
    FLT_LOG2E EQU 1.44269504088896340736
    FLT_LOG2EHIGH EQU 1.44269504088896340736
    FLT_LOG10E EQU 0.434294481903251827651
    FLT_RCPLOG2E EQU 0.693147180559945309417
    FLT_RCPLOG10E EQU 2.30258509299404568402
    FLT_LOG2T EQU 3.3219280948873622
    FLT_LOG2 EQU 0.301029995663981195214
    FLT_LOG2HIGH EQU 0.301029995663981195214
    FLT_LN2 EQU 0.693147180559945309417
    FLT_LN2HIGH EQU 0.693147180559945309417
    FLT_1DIVLN2 EQU 1.44269504088896340736
    FLT_2DIVLN2 EQU 2.88539008177792681472
    FLT_LNT EQU 2.3025850929940459
    FLT_LNTHIGH EQU 2.3025850929940459
    FLT_LN10 EQU 2.302585092994045684018
    FLT_SQRT2 EQU 1.414213562373095048802
    FLT_RCPSQRT2 EQU 0.707106781186547524401
    FLT_SQRT2DIV2 EQU 0.707106781186547524401
    FLT_SQRT2DIV2HIGH EQU 0.707106781186547524401
    FLT_SQRT2DIV2LOW EQU (1.210161749e-08)
    FLT_SQRTHALF EQU 0.707106781186547524401
    FLT_SQRTHALFHIGH EQU 0.707106781186547524401
    FLT_SQRTHALFLOW EQU (1.210161749e-08)
    FLT_POW2 EQU 7.389056098930650227230
    FLT_RCPPOW2 EQU 0.135335283236612691893
    FLT_CBRT2 EQU 1.259921049894873164767
    FLT_RCPCBRT2 EQU 0.793700525984099737375
    FLT_1DIV3 EQU 0.333333333333333333333
    FLT_1DIV7 EQU 0.142857142857142857142
    FLT_1DIV9 EQU 0.111111111111111111111
    FLT_2DIV3 EQU 0.666666666666666666667
    FLT_2DIV7 EQU 0.285714285714285714285
    FLT_2DIV9 EQU 0.222222222222222222222
    FLT_4DIV3 EQU 1.333333333333333333333
    FLT_4DIV7 EQU 0.571428571428571428571
    FLT_4DIV9 EQU 0.444444444444444444444

    FLT_PI EQU 3.14159265358979323846
    FLT_PIHIGH EQU 3.14159265358979323846
    FLT_HALFPI EQU 1.57079632679489661923
    FLT_2PI EQU 6.28318530717958647692
    FLT_NEGPI EQU (-3.14159265358979323846)
    FLT_NEGHALFPI EQU (-1.57079632679489661923)
    FLT_NEG2PI EQU (-6.28318530717958647692)
    FLT_RCPPI EQU 0.31830988618379067154
    FLT_INVPI EQU 0.31830988618379067154
    FLT_RCP2PI EQU 0.15915494309189533577
    FLT_INV2PI EQU 0.15915494309189533577
    FLT_PIDIV2 EQU 1.57079632679489661923
    FLT_PIDIV2HIGH EQU 1.57079632679489661923
    FLT_PIDIV4 EQU 0.78539816339744830962
    FLT_PIDIV4HIGH EQU 0.78539816339744830962
    FLT_PIX3DIV4 EQU 2.35619449019234492884
    FLT_SQRTPI EQU 1.77245385090551602729
    FLT_SQRT2PI EQU 2.50662827463100050242
    FLT_SQRT2PIHIGH EQU 2.50662827463100050242
    FLT_RCPSQRTPI EQU 0.56418958354775628695
    FLT_RCPSQRT2PI EQU 0.39894228040143267794
    FLT_SQRTPIDIV2 EQU 0.88622692545275801365
    FLT_SQRTPIDIV2HIGH EQU 0.88622692545275801365
    FLT_SQRT2PIDIV2 EQU 1.25331413731550025121
    FLT_SQRT2PIDIV2HIGH EQU 1.25331413731550025121
    FLT_2DIVPI EQU 0.63661977236758134308
    FLT_2DIV2PI EQU 0.31830988618379067154
    FLT_2DIVSQRTPI EQU 1.12837916709551257389
    FLT_2DIVSQRT2PI EQU 0.79788456080286535588
    FLT_SQRT2DIVPI EQU 0.45015815807855303477
    FLT_LOGPI EQU 0.49714987269413385435
    FLT_LOG2PI EQU 0.79817986835811504957
    FLT_LNPI EQU 1.14472988584940017415
    FLT_LN2PI EQU 1.83787706640934548356
    FLT_POWPI EQU 23.1406926327792690057
    FLT_RCPPOWPI EQU 0.04321391826377224977
    FLT_POW2PI EQU 535.491655524764736503
    FLT_RCPPOW2PI EQU 0.00186744273170798881
    FLT_CBRTPI EQU 1.46459188756152326302
    FLT_RCPCBRTPI EQU 0.68278406325529568148
    FLT_CBRT2PI EQU 1.84527014864402841910
    FLT_RCPCBRT2PI EQU 0.54192607013928900874

    FLT_POW2TOM126 EQU (1.175494351e-038)
    FLT_POW2TO126 EQU 8.507059173e37
    FLT_NORMHUGE EQU 3.402823466e38
    FLT_POW2TO23 EQU 8388608.0
    FLT_POW2TO24 EQU 16777216.0
    FLT_MAXI32POW2TO23 EQU 2139095039.0
    FLT_POW2TO31 EQU 2147483648.0
    FLT_POW2TO32 EQU 4294967296.0

    FLT_REMQUOBITS EQU 3
    FLT_REMQUOMASK EQU 7

    FLT_TRIGPLOSS EQU 105615.0

    FLT_DEGTORAD EQU 0.017453292519943295769
    FLT_RADTODEG EQU 57.29577951308232087679

    FLT_DEGTOGRAD EQU 1.111111111111111111111
    FLT_GRADTODEG EQU 0.9

    FLT_RADTOGRAD EQU 63.66197723675813430755
    FLT_GRADTORAD EQU 0.015707963267948966192

    FLT_SUNGRAVITY EQU 274.13
    FLT_JUPITERGRAVITY EQU 25.95
    FLT_NEPTUNEGRAVITY EQU 14.07
    FLT_SATURNGRAVITY EQU 11.08
    FLT_URANUSGRAVITY EQU 10.67
    FLT_EARTHGRAVITY EQU 9.81
    FLT_VENUSGRAVITY EQU 8.87
    FLT_MARSGRAVITY EQU 3.77
    FLT_MERCURYGRAVITY EQU 3.59
    FLT_MOONGRAVITY EQU 1.62
    FLT_PLUTOGRAVITY EQU 0.42

    FLT_KMTOINCH EQU 39370.08
    FLT_KMTOFEET EQU 3280.84
    FLT_KMTOYARDS EQU 1093.613
    FLT_KMTOMILES EQU 0.000621371

    FLT_METOINCH EQU 39.37008
    FLT_METOFEET EQU 3.28084
    FLT_METOYARDS EQU 1.093613
    FLT_METOMILES EQU 0.000621371

    FLT_CMTOINCH EQU 0.3937008
    FLT_CMTOFEET EQU 0.0328084
    FLT_CMTOYARDS EQU 0.01093613
    FLT_CMTOMILES EQU 0.00000621371

    FLT_MILLTOINCH EQU 0.03937008
    FLT_MILLTOFEET EQU 0.00328084
    FLT_MILLTOYARDS EQU 0.001093613
    FLT_MILLTOMILES EQU 0.000000621371

    FLT_INCHTOMILL EQU 25.4
    FLT_INCHTOCM EQU 2.54
    FLT_INCHTOME EQU 0.0254
    FLT_INCHTOKM EQU 0.0000254
    FLT_INCHTOFEET EQU 0.083333
    FLT_INCHTOYARDS EQU 0.027778
    FLT_INCHTOMILES EQU 0.000016

    FLT_FEETTOMILL EQU 304.8
    FLT_FEETTOCM EQU 30.48
    FLT_FEETTOME EQU 0.3048
    FLT_FEETTOKM EQU 0.0003048
    FLT_FEETTOINCH EQU 12.0
    FLT_FEETTOYARDS EQU 0.333333
    FLT_FEETTOMILES EQU 0.000189

    FLT_YARDSTOMILL EQU 914.4
    FLT_YARDSTOCM EQU 91.44
    FLT_YARDSTOME EQU 0.9144
    FLT_YARDSTOKM EQU 0.0009144
    FLT_YARDSTOINCH EQU 36.0
    FLT_YARDSTOFEET EQU 3.0
    FLT_YARDSTOMILES EQU 0.000568

    FLT_MILESTOMILL EQU 1609344.0
    FLT_MILESTOCM EQU 160934.4
    FLT_MILESTOME EQU 1609.344
    FLT_MILESTOKM EQU 1.609344
    FLT_MILESTOINCH EQU 63360.0
    FLT_MILESTOFEET EQU 5280.0
    FLT_MILESTOYARDS EQU 1760.0

    FLT_KMPHTOMEPS EQU 0.27777777777778
    FLT_KMPHTOKMPS EQU 0.00027777777777778
    FLT_KMPHTOMEPM EQU 16.666666666667
    FLT_KMPHTOMILESPH EQU 0.62137119223733
    FLT_KMPHTOMILESPS EQU 0.00017260310895481
    FLT_KMPHTOFEETPS EQU 0.91134444444444
    FLT_KMPHTOFEETPM EQU 54.680666666667

    FLT_KMPSTOMEPS EQU 1000.0
    FLT_KMPSTOKMPH EQU 3600.0
    FLT_KMPSTOMEPM EQU 60000.0
    FLT_KMPSTOMILESPH EQU 2236.9362920544
    FLT_KMPSTOMILESPS EQU 0.62137119223733
    FLT_KMPSTOFEETPS EQU 3280.84
    FLT_KMPSTOFEETPM EQU 196850.4

    FLT_MEPSTOKMPH EQU 3.6
    FLT_MEPSTOKMPS EQU 0.001
    FLT_MEPSTOMEPM EQU 60.0
    FLT_MEPSTOMILESPH EQU 2.2369362920544
    FLT_MEPSTOMILESPS EQU 0.00062137119223733
    FLT_MEPSTOFEETPS EQU 3.28084
    FLT_MEPSTOFEETPM EQU 196.8504

    FLT_MEPMTOKMPH EQU 0.06
    FLT_MEPMTOKMPS EQU (1.6666666666667e-05)
    FLT_MEPMTOMEPS EQU 0.016666666666667
    FLT_MEPMTOMILESPH EQU 0.03728227153424
    FLT_MEPMTOMILESPS EQU (1.0356186537289e-05)
    FLT_MEPMTOFEETPS EQU 0.054680666666667
    FLT_MEPMTOFEETPM EQU 3.28084

    FLT_MILESPHTOKMPH EQU 1.609344
    FLT_MILESPHTOKMPS EQU 0.00044704
    FLT_MILESPHTOMEPS EQU 0.44704
    FLT_MILESPHTOMEPM EQU 26.8224
    FLT_MILESPHTOMILESPS EQU 0.00027777777777778
    FLT_MILESPHTOFEETPS EQU 1.4666667136
    FLT_MILESPHTOFEETPM EQU 88.000002816

    FLT_MILESPSTOKMPH EQU 5793.6384
    FLT_MILESPSTOKMPS EQU 1.609344
    FLT_MILESPSTOMEPS EQU 1609.344
    FLT_MILESPSTOMEPM EQU 96560.64
    FLT_MILESPSTOMILESPH EQU 3600.0
    FLT_MILESPSTOFEETPS EQU 5280.00016896
    FLT_MILESPSTOFEETPM EQU 316800.0101376

    FLT_FEETPSTOKMPH EQU 1.097279964887
    FLT_FEETPSTOKMPS EQU 0.0003047999902464
    FLT_FEETPSTOMEPS EQU 0.3047999902464
    FLT_FEETPSTOMEPM EQU 18.287999414784
    FLT_FEETPSTOMILESPH EQU 0.68181816
    FLT_FEETPSTOMILESPS EQU 0.00018939393333333
    FLT_FEETPSTOFEETPM EQU 60.0

    FLT_FEETPMTOKMPH EQU 0.018287999414784
    FLT_FEETPMTOKMPS EQU (5.07999983744e-06)
    FLT_FEETPMTOMEPS EQU 0.00507999983744
    FLT_FEETPMTOMEPM EQU 0.3047999902464
    FLT_FEETPMTOMILESPH EQU 0.011363636
    FLT_FEETPMTOMILESPS EQU (3.1565655555556e-06)
    FLT_FEETPMTOFEETPS EQU 0.016666666666667

    FLT_SOUNDSPEEDP50C EQU 360.35
    FLT_SOUNDSPEEDP45C EQU 357.551
    FLT_SOUNDSPEEDP40C EQU 354.73
    FLT_SOUNDSPEEDP35C EQU 351.887
    FLT_SOUNDSPEEDP30C EQU 349.02
    FLT_SOUNDSPEEDP25C EQU 346.13
    FLT_SOUNDSPEEDP20C EQU 343.216
    FLT_SOUNDSPEEDP15C EQU 340.276
    FLT_SOUNDSPEEDP10C EQU 337.311
    FLT_SOUNDSPEEDP5C EQU 334.319
    FLT_SOUNDSPEED0C EQU 331.301
    FLT_SOUNDSPEEDN5C EQU 328.255
    FLT_SOUNDSPEEDN10C EQU 325.18
    FLT_SOUNDSPEEDN15C EQU 322.076
    FLT_SOUNDSPEEDN20C EQU 318.942
    FLT_SOUNDSPEEDN25C EQU 315.776
    FLT_SOUNDSPEEDN30C EQU 312.579
    FLT_SOUNDSPEEDN35C EQU 309.348
    FLT_SOUNDSPEEDN40C EQU 306.083
    FLT_SOUNDSPEEDN45C EQU 302.784
    FLT_SOUNDSPEEDN50C EQU 299.447

    FLT_SCHSCALE EQU FLT_1DIVLN2
    FLT_THSCALE EQU FLT_2DIVLN2

    FLT_EXPEST1 EQU (-6.93147182e-01)
    FLT_EXPEST2 EQU (+2.40226462e-01)
    FLT_EXPEST3 EQU (-5.55036440e-02)
    FLT_EXPEST4 EQU (+9.61597636e-03)
    FLT_EXPEST5 EQU (-1.32823968e-03)
    FLT_EXPEST6 EQU (+1.47491097e-04)
    FLT_EXPEST7 EQU (-1.08635004e-05)
    FLT_LOGEST0 EQU (+1.442693)
    FLT_LOGEST1 EQU (-0.721242)
    FLT_LOGEST2 EQU (+0.479384)
    FLT_LOGEST3 EQU (-0.350295)
    FLT_LOGEST4 EQU (+0.248590)
    FLT_LOGEST5 EQU (-0.145700)
    FLT_LOGEST6 EQU (+0.057148)
    FLT_LOGEST7 EQU (-0.010578)
    
    IFDEF CASEMAPNONE

   ;/*float mask*/
    flt_1lshl3_msk EQU FLT_1LSHL3_MSK
    flt_1lshl4_msk EQU FLT_1LSHL4_MSK
    flt_1lshl7_msk EQU FLT_1LSHL7_MSK
    flt_1lshl8_msk EQU FLT_1LSHL8_MSK
    flt_1lshl11_msk EQU FLT_1LSHL11_MSK
    flt_1lshl12_msk EQU FLT_1LSHL12_MSK
    flt_1lshl15_msk EQU FLT_1LSHL15_MSK
    flt_1lshl16_msk EQU FLT_1LSHL16_MSK
    flt_1lshl19_msk EQU FLT_1LSHL19_MSK
    flt_1lshl20_msk EQU FLT_1LSHL20_MSK
    flt_1lshl23_msk EQU FLT_1LSHL23_MSK
    flt_1lshl24_msk EQU FLT_1LSHL24_MSK
    flt_1lshl27_msk EQU FLT_1LSHL27_MSK
    flt_1lshl28_msk EQU FLT_1LSHL28_MSK
    flt_1lshl31_msk EQU FLT_1LSHL31_MSK

    flt_neg1lshl3_msk EQU FLT_NEG1LSHL3_MSK
    flt_neg1lshl4_msk EQU FLT_NEG1LSHL4_MSK
    flt_neg1lshl7_msk EQU FLT_NEG1LSHL7_MSK
    flt_neg1lshl8_msk EQU FLT_NEG1LSHL8_MSK
    flt_neg1lshl11_msk EQU FLT_NEG1LSHL11_MSK
    flt_neg1lshl12_msk EQU FLT_NEG1LSHL12_MSK
    flt_neg1lshl15_msk EQU FLT_NEG1LSHL15_MSK
    flt_neg1lshl16_msk EQU FLT_NEG1LSHL16_MSK
    flt_neg1lshl19_msk EQU FLT_NEG1LSHL19_MSK
    flt_neg1lshl20_msk EQU FLT_NEG1LSHL20_MSK
    flt_neg1lshl23_msk EQU FLT_NEG1LSHL23_MSK
    flt_neg1lshl24_msk EQU FLT_NEG1LSHL24_MSK
    flt_neg1lshl27_msk EQU FLT_NEG1LSHL27_MSK
    flt_neg1lshl28_msk EQU FLT_NEG1LSHL28_MSK
    flt_neg1lshl31_msk EQU FLT_NEG1LSHL31_MSK

    flt_false_msk EQU FLT_FALSE_MSK
    flt_true_msk EQU FLT_TRUE_MSK
    flt_error_msk EQU FLT_ERROR_MSK

    flt_magic_msk EQU FLT_MAGIC_MSK
    flt_sign_msk EQU FLT_SIGN_MSK
    flt_invsign_msk EQU FLT_INVSIGN_MSK

    flt_inf_msk EQU FLT_INF_MSK
    flt_fin_msk EQU FLT_FIN_MSK
    flt_invinf_msk EQU FLT_INVINF_MSK
    flt_neginf_msk EQU FLT_NEGINF_MSK
    flt_nan_msk EQU FLT_NAN_MSK
    flt_qnan_msk EQU FLT_QNAN_MSK
    flt_negqnan_msk EQU FLT_NEGQNAN_MSK
    flt_nantest_msk EQU FLT_NANTEST_MSK
    flt_abs_msk EQU FLT_ABS_MSK
    flt_min_msk EQU FLT_MIN_MSK
    flt_max_msk EQU FLT_MAX_MSK
    flt_nofraction_msk EQU FLT_NOFRACTION_MSK
    flt_mindenorm_msk EQU FLT_MINDENORM_MSK
    flt_denormlimit_msk EQU FLT_DENORMLIMIT_MSK
    flt_minnormal_msk EQU FLT_MINNORMAL_MSK
    flt_maxnormal_msk EQU FLT_MAXNORMAL_MSK

    flt_decdig_msk EQU FLT_DECDIG_MSK
    flt_dig_msk EQU FLT_DIG_MSK
    flt_negdecdig_msk EQU FLT_NEGDECDIG_MSK
    flt_negdig_msk EQU FLT_NEGDIG_MSK
    flt_eps_msk EQU FLT_EPS_MSK
    flt_epsilon_msk EQU FLT_EPSILON_MSK
    flt_normeps_msk EQU FLT_NORMEPS_MSK
    flt_guard_msk EQU FLT_GUARD_MSK
    flt_mantpow2_msk EQU FLT_MANTPOW2_MSK
    flt_maxmantpow2_msk EQU FLT_MAXMANTPOW2_MSK
    flt_mantdig_msk EQU FLT_MANTDIG_MSK
    flt_mant_msk EQU FLT_MANT_MSK
    flt_negmantdig_msk EQU FLT_NEGMANTDIG_MSK
    flt_negmant_msk EQU FLT_NEGMANT_MSK
    flt_maxexpo_msk EQU FLT_MAXEXPO_MSK
    flt_exposign_msk EQU FLT_EXPOSIGN_MSK
    flt_expo_msk EQU FLT_EXPO_MSK
    flt_negmaxexpo_msk EQU FLT_NEGMAXEXPO_MSK
    flt_negexposign_msk EQU FLT_NEGEXPOSIGN_MSK
    flt_negexpo_msk EQU FLT_NEGEXPO_MSK
    flt_subnormalexpo_msk EQU FLT_SUBNORMALEXPO_MSK
    flt_minexpo_msk EQU FLT_MINEXPO_MSK
    flt_maxdecexpo_msk EQU FLT_MAXDECEXPO_MSK
    flt_negmaxdecexpo_msk EQU FLT_NEGMAXDECEXPO_MSK
    flt_mindecexpo_msk EQU FLT_MINDECEXPO_MSK
    flt_expofield_msk EQU FLT_EXPOFIELD_MSK
    flt_mantfield_msk EQU FLT_MANTFIELD_MSK
    flt_norm_msk EQU FLT_NORM_MSK
    flt_radix_msk EQU FLT_RADIX_MSK
    flt_rounds_msk EQU FLT_ROUNDS_MSK
    flt_subdec_msk EQU FLT_SUBDEC_MSK
    flt_sqrtmax_msk EQU FLT_SQRTMAX_MSK
    flt_smallnormal_msk EQU FLT_SMALLNORMAL_MSK

    flt_halfminuseps_msk EQU FLT_HALFMINUSEPS_MSK
    flt_trueint_msk EQU FLT_TRUEINT_MSK

    flt_byte_msk EQU FLT_BYTE_MSK
    flt_byte_even_msk EQU FLT_BYTE_EVEN_MSK
    flt_byte_odd_msk EQU FLT_BYTE_ODD_MSK
    flt_4low_msk EQU FLT_4LOW_MSK
    flt_4high_msk EQU FLT_4HIGH_MSK
    flt_flip4_msk EQU FLT_FLIP4_MSK
    flt_8low_msk EQU FLT_8LOW_MSK
    flt_8high_msk EQU FLT_8HIGH_MSK
    flt_flip8_msk EQU FLT_FLIP8_MSK
    flt_12low_msk EQU FLT_12LOW_MSK
    flt_12high_msk EQU FLT_12HIGH_MSK
    flt_flip12_msk EQU FLT_FLIP12_MSK
    flt_16low_msk EQU FLT_16LOW_MSK
    flt_16high_msk EQU FLT_16HIGH_MSK
    flt_flip16_msk EQU FLT_FLIP16_MSK
    flt_20low_msk EQU FLT_20LOW_MSK
    flt_20high_msk EQU FLT_20HIGH_MSK
    flt_flip20_msk EQU FLT_FLIP20_MSK
    flt_24low_msk EQU FLT_24LOW_MSK
    flt_24high_msk EQU FLT_24HIGH_MSK
    flt_flip24_msk EQU FLT_FLIP24_MSK
    flt_28low_msk EQU FLT_28LOW_MSK
    flt_28high_msk EQU FLT_28HIGH_MSK
    flt_flip28_msk EQU FLT_FLIP28_MSK
    flt_32low_msk EQU FLT_32LOW_MSK
    flt_32high_msk EQU FLT_32HIGH_MSK
    flt_flip32_msk EQU FLT_FLIP32_MSK

    flt_0_msk EQU FLT_0_MSK
    flt_0d5_msk EQU FLT_0D5_MSK
    flt_1_msk EQU FLT_1_MSK
    flt_1d5_msk EQU FLT_1D5_MSK
    flt_2_msk EQU FLT_2_MSK
    flt_2d5_msk EQU FLT_2D5_MSK
    flt_3_msk EQU FLT_3_MSK
    flt_4_msk EQU FLT_4_MSK
    flt_5_msk EQU FLT_5_MSK
    flt_6_msk EQU FLT_6_MSK
    flt_7_msk EQU FLT_7_MSK
    flt_8_msk EQU FLT_8_MSK
    flt_9_msk EQU FLT_9_MSK
    flt_10_msk EQU FLT_10_MSK
    flt_20_msk EQU FLT_20_MSK
    flt_23_msk EQU FLT_23_MSK
    flt_23d5_msk EQU FLT_23D5_MSK
    flt_24_msk EQU FLT_24_MSK
    flt_24d5_msk EQU FLT_24D5_MSK
    flt_25_msk EQU FLT_25_MSK

    flt_128_msk EQU FLT_128_MSK

    flt_253_msk EQU FLT_253_MSK

    flt_neg0_msk EQU FLT_NEG0_MSK
    flt_neg1_msk EQU FLT_NEG1_MSK

    flt_neg150_msk EQU FLT_NEG150_MSK

    flt_a8_msk EQU FLT_A8_MSK
    flt_r8_msk EQU FLT_R8_MSK
    flt_g8_msk EQU FLT_G8_MSK
    flt_b8_msk EQU FLT_B8_MSK

    flt_flipa8_msk EQU FLT_FLIPA8_MSK
    flt_flipr8_msk EQU FLT_FLIPR8_MSK
    flt_flipg8_msk EQU FLT_FLIPG8_MSK
    flt_flipb8_msk EQU FLT_FLIPB8_MSK

    flt_a2_msk EQU FLT_A2_MSK
    flt_b10_msk EQU FLT_B10_MSK
    flt_g10_msk EQU FLT_G10_MSK
    flt_r10_msk EQU FLT_R10_MSK

    flt_flipa2_msk EQU FLT_FLIPA2_MSK
    flt_flipb10_msk EQU FLT_FLIPB10_MSK
    flt_flipg10_msk EQU FLT_FLIPG10_MSK
    flt_flipr10_msk EQU FLT_FLIPR10_MSK

    flt_bin128_msk EQU FLT_BIN128_MSK
    flt_binneg150_msk EQU FLT_BINNEG150_MSK

    flt_maxrand_msk EQU FLT_MAXRAND_MSK

    flt_maxi8_msk EQU FLT_MAXI8_MSK
    flt_mini8_msk EQU FLT_MINI8_MSK
    flt_maxu8_msk EQU FLT_MAXU8_MSK

    flt_maxi16_msk EQU FLT_MAXI16_MSK
    flt_mini16_msk EQU FLT_MINI16_MSK
    flt_maxu16_msk EQU FLT_MAXU16_MSK

    flt_maxi32_msk EQU FLT_MAXI32_MSK
    flt_mini32_msk EQU FLT_MINI32_MSK
    flt_maxu32_msk EQU FLT_MAXU32_MSK

    flt_maxi8xu8_msk EQU FLT_MAXI8XU8_MSK
    flt_mini8xu8_msk EQU FLT_MINI8XU8_MSK
    flt_maxi8xu16_msk EQU FLT_MAXI8XU16_MSK
    flt_mini8xu16_msk EQU FLT_MINI8XU16_MSK

    flt_maxi16xu16_msk EQU FLT_MAXI16XU16_MSK
    flt_mini16xu16_msk EQU FLT_MINI16XU16_MSK

    flt_fixunsigned_msk EQU FLT_FIXUNSIGNED_MSK
    flt_fixunsigned32_msk EQU FLT_FIXUNSIGNED32_MSK
    flt_fixmaxi32_msk EQU FLT_FIXMAXI32_MSK
    flt_fixmaxu32_msk EQU FLT_FIXMAXU32_MSK

   ;/*float int*/
    flt_1lshl3_int EQU FLT_1LSHL3_INT
    flt_1lshl4_int EQU FLT_1LSHL4_INT
    flt_1lshl7_int EQU FLT_1LSHL7_INT
    flt_1lshl8_int EQU FLT_1LSHL8_INT
    flt_1lshl11_int EQU FLT_1LSHL11_INT
    flt_1lshl12_int EQU FLT_1LSHL12_INT
    flt_1lshl15_int EQU FLT_1LSHL15_INT
    flt_1lshl16_int EQU FLT_1LSHL16_INT
    flt_1lshl19_int EQU FLT_1LSHL19_INT
    flt_1lshl20_int EQU FLT_1LSHL20_INT
    flt_1lshl23_int EQU FLT_1LSHL23_INT
    flt_1lshl24_int EQU FLT_1LSHL24_INT
    flt_1lshl27_int EQU FLT_1LSHL27_INT
    flt_1lshl28_int EQU FLT_1LSHL28_INT
    flt_1lshl31_int EQU FLT_1LSHL31_INT

    flt_neg1lshl3_int EQU FLT_NEG1LSHL3_INT
    flt_neg1lshl4_int EQU FLT_NEG1LSHL4_INT
    flt_neg1lshl7_int EQU FLT_NEG1LSHL7_INT
    flt_neg1lshl8_int EQU FLT_NEG1LSHL8_INT
    flt_neg1lshl11_int EQU FLT_NEG1LSHL11_INT
    flt_neg1lshl12_int EQU FLT_NEG1LSHL12_INT
    flt_neg1lshl15_int EQU FLT_NEG1LSHL15_INT
    flt_neg1lshl16_int EQU FLT_NEG1LSHL16_INT
    flt_neg1lshl19_int EQU FLT_NEG1LSHL19_INT
    flt_neg1lshl20_int EQU FLT_NEG1LSHL20_INT
    flt_neg1lshl23_int EQU FLT_NEG1LSHL23_INT
    flt_neg1lshl24_int EQU FLT_NEG1LSHL24_INT
    flt_neg1lshl27_int EQU FLT_NEG1LSHL27_INT
    flt_neg1lshl28_int EQU FLT_NEG1LSHL28_INT
    flt_neg1lshl31_int EQU FLT_NEG1LSHL31_INT

    flt_false_int EQU FLT_FALSE_INT
    flt_true_int EQU FLT_TRUE_INT
    flt_error_int EQU FLT_ERROR_INT

    flt_magic_int EQU FLT_MAGIC_INT
    flt_sign_int EQU FLT_SIGN_INT
    flt_invsign_int EQU FLT_INVSIGN_INT

    flt_inf_int EQU FLT_INF_INT
    flt_fin_int EQU FLT_FIN_INT
    flt_invinf_int EQU FLT_INVINF_INT
    flt_neginf_int EQU FLT_NEGINF_INT
    flt_nan_int EQU FLT_NAN_INT
    flt_qnan_int EQU FLT_QNAN_INT
    flt_negqnan_int EQU FLT_NEGQNAN_INT
    flt_nantest_int EQU FLT_NANTEST_INT
    flt_abs_int EQU FLT_ABS_INT
    flt_min_int EQU FLT_MIN_INT
    flt_max_int EQU FLT_MAX_INT
    flt_nofraction_int EQU FLT_NOFRACTION_INT
    flt_mindenorm_int EQU FLT_MINDENORM_INT
    flt_denormlimit_int EQU FLT_DENORMLIMIT_INT
    flt_minnormal_int EQU FLT_MINNORMAL_INT
    flt_maxnormal_int EQU FLT_MAXNORMAL_INT

    flt_decdig_int EQU FLT_DECDIG_INT
    flt_dig_int EQU FLT_DIG_INT
    flt_negdecdig_int EQU FLT_NEGDECDIG_INT
    flt_negdig_int EQU FLT_NEGDIG_INT
    flt_eps_int EQU FLT_EPS_INT
    flt_epsilon_int EQU FLT_EPSILON_INT
    flt_normeps_int EQU FLT_NORMEPS_INT
    flt_guard_int EQU FLT_GUARD_INT
    flt_mantpow2_int EQU FLT_MANTPOW2_INT
    flt_maxmantpow2_int EQU FLT_MAXMANTPOW2_INT
    flt_mantdig_int EQU FLT_MANTDIG_INT
    flt_mant_int EQU FLT_MANT_INT
    flt_negmantdig_int EQU FLT_NEGMANTDIG_INT
    flt_negmant_int EQU FLT_NEGMANT_INT
    flt_maxexpo_int EQU FLT_MAXEXPO_INT
    flt_exposign_int EQU FLT_EXPOSIGN_INT
    flt_expo_int EQU FLT_EXPO_INT
    flt_negmaxexpo_int EQU FLT_NEGMAXEXPO_INT
    flt_negexposign_int EQU FLT_NEGEXPOSIGN_INT
    flt_negexpo_int EQU FLT_NEGEXPO_INT
    flt_subnormalexpo_int EQU FLT_SUBNORMALEXPO_INT
    flt_minexpo_int EQU FLT_MINEXPO_INT
    flt_maxdecexpo_int EQU FLT_MAXDECEXPO_INT
    flt_negmaxdecexpo_int EQU FLT_NEGMAXDECEXPO_INT
    flt_mindecexpo_int EQU FLT_MINDECEXPO_INT
    flt_expofield_int EQU FLT_EXPOFIELD_INT
    flt_mantfield_int EQU FLT_MANTFIELD_INT
    flt_norm_int EQU FLT_NORM_INT
    flt_radix_int EQU FLT_RADIX_INT
    flt_rounds_int EQU FLT_ROUNDS_INT
    flt_subdec_int EQU FLT_SUBDEC_INT
    flt_sqrtmax_int EQU FLT_SQRTMAX_INT
    flt_smallnormal_int EQU FLT_SMALLNORMAL_INT

    flt_halfminuseps_int EQU FLT_HALFMINUSEPS_INT
    flt_trueint_int EQU FLT_TRUEINT_INT

    flt_byte_int EQU FLT_BYTE_INT
    flt_byte_even_int EQU FLT_BYTE_EVEN_INT
    flt_byte_odd_int EQU FLT_BYTE_ODD_INT
    flt_4low_int EQU FLT_4LOW_INT
    flt_4high_int EQU FLT_4HIGH_INT
    flt_flip4_int EQU FLT_FLIP4_INT
    flt_8low_int EQU FLT_8LOW_INT
    flt_8high_int EQU FLT_8HIGH_INT
    flt_flip8_int EQU FLT_FLIP8_INT
    flt_12low_int EQU FLT_12LOW_INT
    flt_12high_int EQU FLT_12HIGH_INT
    flt_flip12_int EQU FLT_FLIP12_INT
    flt_16low_int EQU FLT_16LOW_INT
    flt_16high_int EQU FLT_16HIGH_INT
    flt_flip16_int EQU FLT_FLIP16_INT
    flt_20low_int EQU FLT_20LOW_INT
    flt_20high_int EQU FLT_20HIGH_INT
    flt_flip20_int EQU FLT_FLIP20_INT
    flt_24low_int EQU FLT_24LOW_INT
    flt_24high_int EQU FLT_24HIGH_INT
    flt_flip24_int EQU FLT_FLIP24_INT
    flt_28low_int EQU FLT_28LOW_INT
    flt_28high_int EQU FLT_28HIGH_INT
    flt_flip28_int EQU FLT_FLIP28_INT
    flt_32low_int EQU FLT_32LOW_INT
    flt_32high_int EQU FLT_32HIGH_INT
    flt_flip32_int EQU FLT_FLIP32_INT

    flt_0_int EQU FLT_0_INT
    flt_0d5_int EQU FLT_0D5_INT
    flt_1_int EQU FLT_1_INT
    flt_1d5_int EQU FLT_1D5_INT
    flt_2_int EQU FLT_2_INT
    flt_2d5_int EQU FLT_2D5_INT
    flt_3_int EQU FLT_3_INT
    flt_4_int EQU FLT_4_INT
    flt_5_int EQU FLT_5_INT
    flt_6_int EQU FLT_6_INT
    flt_7_int EQU FLT_7_INT
    flt_8_int EQU FLT_8_INT
    flt_9_int EQU FLT_9_INT
    flt_10_int EQU FLT_10_INT
    flt_20_int EQU FLT_20_INT
    flt_23_int EQU FLT_23_INT
    flt_23d5_int EQU FLT_23D5_INT
    flt_24_int EQU FLT_24_INT
    flt_24d5_int EQU FLT_24D5_INT
    flt_25_int EQU FLT_25_INT

    flt_128_int EQU FLT_128_INT

    flt_253_int EQU FLT_253_INT

    flt_neg0_int EQU FLT_NEG0_INT
    flt_neg1_int EQU FLT_NEG1_INT

    flt_neg150_int EQU FLT_NEG150_INT

    flt_a8_int EQU FLT_A8_INT
    flt_r8_int EQU FLT_R8_INT
    flt_g8_int EQU FLT_G8_INT
    flt_b8_int EQU FLT_B8_INT

    flt_flipa8_int EQU FLT_FLIPA8_INT
    flt_flipr8_int EQU FLT_FLIPR8_INT
    flt_flipg8_int EQU FLT_FLIPG8_INT
    flt_flipb8_int EQU FLT_FLIPB8_INT

    flt_a2_int EQU FLT_A2_INT
    flt_b10_int EQU FLT_B10_INT
    flt_g10_int EQU FLT_G10_INT
    flt_r10_int EQU FLT_R10_INT

    flt_flipa2_int EQU FLT_FLIPA2_INT
    flt_flipb10_int EQU FLT_FLIPB10_INT
    flt_flipg10_int EQU FLT_FLIPG10_INT
    flt_flipr10_int EQU FLT_FLIPR10_INT

    flt_bin128_int EQU FLT_BIN128_INT
    flt_binneg150_int EQU FLT_BINNEG150_INT

    flt_maxrand_int EQU FLT_MAXRAND_INT

    flt_maxi8_int EQU FLT_MAXI8_INT
    flt_mini8_int EQU FLT_MINI8_INT
    flt_maxu8_int EQU FLT_MAXU8_INT

    flt_maxi16_int EQU FLT_MAXI16_INT
    flt_mini16_int EQU FLT_MINI16_INT
    flt_maxu16_int EQU FLT_MAXU16_INT

    flt_maxi32_int EQU FLT_MAXI32_INT
    flt_mini32_int EQU FLT_MINI32_INT
    flt_maxu32_int EQU FLT_MAXU32_INT

    flt_maxi8xu8_int EQU FLT_MAXI8XU8_INT
    flt_mini8xu8_int EQU FLT_MINI8XU8_INT
    flt_maxi8xu16_int EQU FLT_MAXI8XU16_INT
    flt_mini8xu16_int EQU FLT_MINI8XU16_INT

    flt_maxi16xu16_int EQU FLT_MAXI16XU16_INT
    flt_mini16xu16_int EQU FLT_MINI16XU16_INT

    flt_fixunsigned_int EQU FLT_FIXUNSIGNED_INT
    flt_fixunsigned32_int EQU FLT_FIXUNSIGNED32_INT
    flt_fixmaxi32_int EQU FLT_FIXMAXI32_INT
    flt_fixmaxu32_int EQU FLT_FIXMAXU32_INT

   ;/*float*/
    flt_1lshl3 EQU FLT_1LSHL3
    flt_1lshl4 EQU FLT_1LSHL4
    flt_1lshl7 EQU FLT_1LSHL7
    flt_1lshl8 EQU FLT_1LSHL8
    flt_1lshl11 EQU FLT_1LSHL11
    flt_1lshl12 EQU FLT_1LSHL12
    flt_1lshl15 EQU FLT_1LSHL15
    flt_1lshl16 EQU FLT_1LSHL16
    flt_1lshl19 EQU FLT_1LSHL19
    flt_1lshl20 EQU FLT_1LSHL20
    flt_1lshl23 EQU FLT_1LSHL23
    flt_1lshl24 EQU FLT_1LSHL24
    flt_1lshl27 EQU FLT_1LSHL27
    flt_1lshl28 EQU FLT_1LSHL28
    flt_1lshl31 EQU FLT_1LSHL31

    flt_neg1lshl3 EQU FLT_NEG1LSHL3
    flt_neg1lshl4 EQU FLT_NEG1LSHL4
    flt_neg1lshl7 EQU FLT_NEG1LSHL7
    flt_neg1lshl8 EQU FLT_NEG1LSHL8
    flt_neg1lshl11 EQU FLT_NEG1LSHL11
    flt_neg1lshl12 EQU FLT_NEG1LSHL12
    flt_neg1lshl15 EQU FLT_NEG1LSHL15
    flt_neg1lshl16 EQU FLT_NEG1LSHL16
    flt_neg1lshl19 EQU FLT_NEG1LSHL19
    flt_neg1lshl20 EQU FLT_NEG1LSHL20
    flt_neg1lshl23 EQU FLT_NEG1LSHL23
    flt_neg1lshl24 EQU FLT_NEG1LSHL24
    flt_neg1lshl27 EQU FLT_NEG1LSHL27
    flt_neg1lshl28 EQU FLT_NEG1LSHL28
    flt_neg1lshl31 EQU FLT_NEG1LSHL31

    flt_false EQU FLT_FALSE
    flt_true EQU FLT_TRUE

    flt_magic EQU FLT_MAGIC
    flt_sign EQU FLT_SIGN
    flt_invsign EQU FLT_INVSIGN

    flt_inf EQU FLT_INF
    flt_fin EQU FLT_FIN
    flt_invinf EQU FLT_INVINF
    flt_neginf EQU FLT_NEGINF
    flt_nan EQU FLT_NAN
    flt_qnan EQU FLT_QNAN
    flt_negqnan EQU FLT_NEGQNAN
    flt_nantest EQU FLT_NANTEST
    flt_abs EQU FLT_ABS
    flt_min EQU FLT_MIN
    flt_max EQU FLT_MAX
    flt_nofraction EQU FLT_NOFRACTION
    flt_mindenorm EQU FLT_MINDENORM
    flt_denormlimit EQU FLT_DENORMLIMIT
    flt_minnormal EQU FLT_MINNORMAL
    flt_maxnormal EQU FLT_MAXNORMAL

    flt_decdig EQU FLT_DECDIG
    flt_dig EQU FLT_DIG
    flt_negdecdig EQU FLT_NEGDECDIG
    flt_negdig EQU FLT_NEGDIG
    flt_eps EQU FLT_EPS
    flt_epsilon EQU FLT_EPSILON
    flt_normeps EQU FLT_NORMEPS
    flt_guard EQU FLT_GUARD
    flt_mantpow2 EQU FLT_MANTPOW2
    flt_maxmantpow2 EQU FLT_MAXMANTPOW2
    flt_mantdig EQU FLT_MANTDIG
    flt_mant EQU FLT_MANT
    flt_negmantdig EQU FLT_NEGMANTDIG
    flt_negmant EQU FLT_NEGMANT
    flt_maxexpo EQU FLT_MAXEXPO
    flt_exposign EQU FLT_EXPOSIGN
    flt_expo EQU FLT_EXPO
    flt_negmaxexpo EQU FLT_NEGMAXEXPO
    flt_negexposign EQU FLT_NEGEXPOSIGN
    flt_negexpo EQU FLT_NEGEXPO
    flt_subnormalexpo EQU FLT_SUBNORMALEXPO
    flt_minexpo EQU FLT_MINEXPO
    flt_maxdecexpo EQU FLT_MAXDECEXPO
    flt_negmaxdecexpo EQU FLT_NEGMAXDECEXPO
    flt_mindecexpo EQU FLT_MINDECEXPO
    flt_expofield EQU FLT_EXPOFIELD
    flt_mantfield EQU FLT_MANTFIELD
    flt_norm EQU FLT_NORM
    flt_radix EQU FLT_RADIX
    flt_rounds EQU FLT_ROUNDS
    flt_subdec EQU FLT_SUBDEC
    flt_sqrtmax EQU FLT_SQRTMAX
    flt_smallnormal EQU FLT_SMALLNORMAL

    flt_halfminuseps EQU FLT_HALFMINUSEPS
    flt_trueint EQU FLT_TRUEINT

    flt_byte EQU FLT_BYTE
    flt_byte_even EQU FLT_BYTE_EVEN
    flt_byte_odd EQU FLT_BYTE_ODD
    flt_4low EQU FLT_4LOW
    flt_4high EQU FLT_4HIGH
    flt_flip4 EQU FLT_FLIP4
    flt_8low EQU FLT_8LOW
    flt_8high EQU FLT_8HIGH
    flt_flip8 EQU FLT_FLIP8
    flt_12low EQU FLT_12LOW
    flt_12high EQU FLT_12HIGH
    flt_flip12 EQU FLT_FLIP12
    flt_16low EQU FLT_16LOW
    flt_16high EQU FLT_16HIGH
    flt_flip16 EQU FLT_FLIP16
    flt_20low EQU FLT_20LOW
    flt_20high EQU FLT_20HIGH
    flt_flip20 EQU FLT_FLIP20
    flt_24low EQU FLT_24LOW
    flt_24high EQU FLT_24HIGH
    flt_flip24 EQU FLT_FLIP24
    flt_28low EQU FLT_28LOW
    flt_28high EQU FLT_28HIGH
    flt_flip28 EQU FLT_FLIP28
    flt_32low EQU FLT_32LOW
    flt_32high EQU FLT_32HIGH
    flt_flip32 EQU FLT_FLIP32

    flt_0 EQU FLT_0
    flt_0d0001 EQU FLT_0D0001
    flt_0d0002 EQU FLT_0D0002
    flt_0d0003 EQU FLT_0D0003
    flt_0d0004 EQU FLT_0D0004
    flt_0d0005 EQU FLT_0D0005
    flt_0d0006 EQU FLT_0D0006
    flt_0d0007 EQU FLT_0D0007
    flt_0d0008 EQU FLT_0D0008
    flt_0d0009 EQU FLT_0D0009
    flt_0d001 EQU FLT_0D001
    flt_0d002 EQU FLT_0D002
    flt_0d003 EQU FLT_0D003
    flt_0d004 EQU FLT_0D004
    flt_0d005 EQU FLT_0D005
    flt_0d006 EQU FLT_0D006
    flt_0d007 EQU FLT_0D007
    flt_0d008 EQU FLT_0D008
    flt_0d009 EQU FLT_0D009
    flt_0d01 EQU FLT_0D01
    flt_0d02 EQU FLT_0D02
    flt_0d025 EQU FLT_0D025
    flt_0d03 EQU FLT_0D03
    flt_0d04 EQU FLT_0D04
    flt_0d05 EQU FLT_0D05
    flt_0d06 EQU FLT_0D06
    flt_0d07 EQU FLT_0D07
    flt_0d08 EQU FLT_0D08
    flt_0d09 EQU FLT_0D09
    flt_0d1 EQU FLT_0D1
    flt_0d2 EQU FLT_0D2
    flt_0d25 EQU FLT_0D25
    flt_0d3 EQU FLT_0D3
    flt_0d4 EQU FLT_0D4
    flt_0d5 EQU FLT_0D5
    flt_0d6 EQU FLT_0D6
    flt_0d7 EQU FLT_0D7
    flt_0d8 EQU FLT_0D8
    flt_0d9 EQU FLT_0D9
    flt_1 EQU FLT_1
    flt_1d25 EQU FLT_1D25
    flt_1d5 EQU FLT_1D5
    flt_2 EQU FLT_2
    flt_2d25 EQU FLT_2D25
    flt_2d5 EQU FLT_2D5
    flt_3 EQU FLT_3
    flt_3d25 EQU FLT_3D25
    flt_3d5 EQU FLT_3D5
    flt_4 EQU FLT_4
    flt_4d25 EQU FLT_4D25
    flt_4d5 EQU FLT_4D5
    flt_5 EQU FLT_5
    flt_5d25 EQU FLT_5D25
    flt_5d5 EQU FLT_5D5
    flt_6 EQU FLT_6
    flt_6d25 EQU FLT_6D25
    flt_6d5 EQU FLT_6D5
    flt_7 EQU FLT_7
    flt_7d25 EQU FLT_7D25
    flt_7d5 EQU FLT_7D5
    flt_8 EQU FLT_8
    flt_8d25 EQU FLT_8D25
    flt_8d5 EQU FLT_8D5
    flt_9 EQU FLT_9
    flt_9d25 EQU FLT_9D25
    flt_9d5 EQU FLT_9D5
    flt_10 EQU FLT_10
    flt_11 EQU FLT_11
    flt_12 EQU FLT_12
    flt_13 EQU FLT_13
    flt_14 EQU FLT_14
    flt_15 EQU FLT_15
    flt_16 EQU FLT_16
    flt_17 EQU FLT_17
    flt_18 EQU FLT_18
    flt_19 EQU FLT_19
    flt_20 EQU FLT_20
    flt_21 EQU FLT_21
    flt_22 EQU FLT_22
    flt_23 EQU FLT_23
    flt_24 EQU FLT_24
    flt_24d5 EQU FLT_24D5
    flt_25 EQU FLT_25
    flt_26 EQU FLT_26
    flt_27 EQU FLT_27
    flt_28 EQU FLT_28
    flt_29 EQU FLT_29
    flt_30 EQU FLT_30
    flt_31 EQU FLT_31
    flt_32 EQU FLT_32
    flt_33 EQU FLT_33
    flt_34 EQU FLT_34
    flt_35 EQU FLT_35
    flt_36 EQU FLT_36
    flt_37 EQU FLT_37
    flt_38 EQU FLT_38
    flt_39 EQU FLT_39
    flt_40 EQU FLT_40
    flt_41 EQU FLT_41
    flt_42 EQU FLT_42
    flt_43 EQU FLT_43
    flt_44 EQU FLT_44
    flt_45 EQU FLT_45
    flt_46 EQU FLT_46
    flt_47 EQU FLT_47
    flt_48 EQU FLT_48
    flt_49 EQU FLT_49
    flt_50 EQU FLT_50
    flt_51 EQU FLT_51
    flt_52 EQU FLT_52
    flt_53 EQU FLT_53
    flt_54 EQU FLT_54
    flt_55 EQU FLT_55
    flt_56 EQU FLT_56
    flt_57 EQU FLT_57
    flt_58 EQU FLT_58
    flt_59 EQU FLT_59
    flt_60 EQU FLT_60
    flt_61 EQU FLT_61
    flt_62 EQU FLT_62
    flt_63 EQU FLT_63
    flt_64 EQU FLT_64
    flt_65 EQU FLT_65
    flt_66 EQU FLT_66
    flt_67 EQU FLT_67
    flt_68 EQU FLT_68
    flt_69 EQU FLT_69
    flt_70 EQU FLT_70
    flt_71 EQU FLT_71
    flt_72 EQU FLT_72
    flt_73 EQU FLT_73
    flt_74 EQU FLT_74
    flt_75 EQU FLT_75
    flt_76 EQU FLT_76
    flt_77 EQU FLT_77
    flt_78 EQU FLT_78
    flt_79 EQU FLT_79
    flt_80 EQU FLT_80
    flt_81 EQU FLT_81
    flt_82 EQU FLT_82
    flt_83 EQU FLT_83
    flt_84 EQU FLT_84
    flt_85 EQU FLT_85
    flt_86 EQU FLT_86
    flt_87 EQU FLT_87
    flt_88 EQU FLT_88
    flt_89 EQU FLT_89
    flt_90 EQU FLT_90
    flt_91 EQU FLT_91
    flt_92 EQU FLT_92
    flt_93 EQU FLT_93
    flt_94 EQU FLT_94
    flt_95 EQU FLT_95
    flt_96 EQU FLT_96
    flt_97 EQU FLT_97
    flt_98 EQU FLT_98
    flt_99 EQU FLT_99
    flt_100 EQU FLT_100
    flt_125 EQU FLT_125
    flt_126 EQU FLT_126
    flt_127 EQU FLT_127
    flt_128 EQU FLT_128
    flt_140 EQU FLT_140
    flt_145 EQU FLT_145
    flt_150 EQU FLT_150
    flt_180 EQU FLT_180
    flt_253 EQU FLT_253
    flt_254 EQU FLT_254
    flt_255 EQU FLT_255
    flt_256 EQU FLT_256
    flt_360 EQU FLT_360
    flt_511 EQU FLT_511
    flt_512 EQU FLT_512
    flt_513 EQU FLT_513
    flt_1023 EQU FLT_1023
    flt_1024 EQU FLT_1024
    flt_1025 EQU FLT_1025

    flt_32767 EQU FLT_32767
    flt_32768 EQU FLT_32768
    flt_65535 EQU FLT_65535
    flt_65536 EQU FLT_65536
    flt_2147483647 EQU FLT_2147483647
    flt_2147483648 EQU FLT_2147483648
    flt_4294967295 EQU FLT_4294967295
    flt_4294967296 EQU FLT_4294967296

    flt_neg0 EQU FLT_NEG0
    flt_neg0d0001 EQU FLT_NEG0D0001
    flt_neg0d0002 EQU FLT_NEG0D0002
    flt_neg0d0003 EQU FLT_NEG0D0003
    flt_neg0d0004 EQU FLT_NEG0D0004
    flt_neg0d0005 EQU FLT_NEG0D0005
    flt_neg0d0006 EQU FLT_NEG0D0006
    flt_neg0d0007 EQU FLT_NEG0D0007
    flt_neg0d0008 EQU FLT_NEG0D0008
    flt_neg0d0009 EQU FLT_NEG0D0009
    flt_neg0d001 EQU FLT_NEG0D001
    flt_neg0d002 EQU FLT_NEG0D002
    flt_neg0d003 EQU FLT_NEG0D003
    flt_neg0d004 EQU FLT_NEG0D004
    flt_neg0d005 EQU FLT_NEG0D005
    flt_neg0d006 EQU FLT_NEG0D006
    flt_neg0d007 EQU FLT_NEG0D007
    flt_neg0d008 EQU FLT_NEG0D008
    flt_neg0d009 EQU FLT_NEG0D009
    flt_neg0d01 EQU FLT_NEG0D01
    flt_neg0d02 EQU FLT_NEG0D02
    flt_neg0d025 EQU FLT_NEG0D025
    flt_neg0d03 EQU FLT_NEG0D03
    flt_neg0d04 EQU FLT_NEG0D04
    flt_neg0d05 EQU FLT_NEG0D05
    flt_neg0d06 EQU FLT_NEG0D06
    flt_neg0d07 EQU FLT_NEG0D07
    flt_neg0d08 EQU FLT_NEG0D08
    flt_neg0d09 EQU FLT_NEG0D09
    flt_neg0d1 EQU FLT_NEG0D1
    flt_neg0d2 EQU FLT_NEG0D2
    flt_neg0d25 EQU FLT_NEG0D25
    flt_neg0d3 EQU FLT_NEG0D3
    flt_neg0d4 EQU FLT_NEG0D4
    flt_neg0d5 EQU FLT_NEG0D5
    flt_neg0d6 EQU FLT_NEG0D6
    flt_neg0d7 EQU FLT_NEG0D7
    flt_neg0d8 EQU FLT_NEG0D8
    flt_neg0d9 EQU FLT_NEG0D9
    flt_neg1 EQU FLT_NEG1
    flt_neg1d25 EQU FLT_NEG1D25
    flt_neg1d5 EQU FLT_NEG1D5
    flt_neg2 EQU FLT_NEG2
    flt_neg2d25 EQU FLT_NEG2D25
    flt_neg2d5 EQU FLT_NEG2D5
    flt_neg3 EQU FLT_NEG3
    flt_neg3d25 EQU FLT_NEG3D25
    flt_neg3d5 EQU FLT_NEG3D5
    flt_neg4 EQU FLT_NEG4
    flt_neg4d25 EQU FLT_NEG4D25
    flt_neg4d5 EQU FLT_NEG4D5
    flt_neg5 EQU FLT_NEG5
    flt_neg5d25 EQU FLT_NEG5D25
    flt_neg5d5 EQU FLT_NEG5D5
    flt_neg6 EQU FLT_NEG6
    flt_neg6d25 EQU FLT_NEG6D25
    flt_neg6d5 EQU FLT_NEG6D5
    flt_neg7 EQU FLT_NEG7
    flt_neg7d25 EQU FLT_NEG7D25
    flt_neg7d5 EQU FLT_NEG7D5
    flt_neg8 EQU FLT_NEG8
    flt_neg8d25 EQU FLT_NEG8D25
    flt_neg8d5 EQU FLT_NEG8D5
    flt_neg9 EQU FLT_NEG9
    flt_neg9d25 EQU FLT_NEG9D25
    flt_neg9d5 EQU FLT_NEG9D5
    flt_neg10 EQU FLT_NEG10
    flt_neg11 EQU FLT_NEG11
    flt_neg12 EQU FLT_NEG12
    flt_neg13 EQU FLT_NEG13
    flt_neg14 EQU FLT_NEG14
    flt_neg15 EQU FLT_NEG15
    flt_neg16 EQU FLT_NEG16
    flt_neg17 EQU FLT_NEG17
    flt_neg18 EQU FLT_NEG18
    flt_neg19 EQU FLT_NEG19
    flt_neg20 EQU FLT_NEG20
    flt_neg21 EQU FLT_NEG21
    flt_neg22 EQU FLT_NEG22
    flt_neg23 EQU FLT_NEG23
    flt_neg24 EQU FLT_NEG24
    flt_neg24d5 EQU FLT_NEG24D5
    flt_neg25 EQU FLT_NEG25
    flt_neg26 EQU FLT_NEG26
    flt_neg27 EQU FLT_NEG27
    flt_neg28 EQU FLT_NEG28
    flt_neg29 EQU FLT_NEG29
    flt_neg30 EQU FLT_NEG30
    flt_neg31 EQU FLT_NEG31
    flt_neg32 EQU FLT_NEG32
    flt_neg33 EQU FLT_NEG33
    flt_neg34 EQU FLT_NEG34
    flt_neg35 EQU FLT_NEG35
    flt_neg36 EQU FLT_NEG36
    flt_neg37 EQU FLT_NEG37
    flt_neg38 EQU FLT_NEG38
    flt_neg39 EQU FLT_NEG39
    flt_neg40 EQU FLT_NEG40
    flt_neg41 EQU FLT_NEG41
    flt_neg42 EQU FLT_NEG42
    flt_neg43 EQU FLT_NEG43
    flt_neg44 EQU FLT_NEG44
    flt_neg45 EQU FLT_NEG45
    flt_neg46 EQU FLT_NEG46
    flt_neg47 EQU FLT_NEG47
    flt_neg48 EQU FLT_NEG48
    flt_neg49 EQU FLT_NEG49
    flt_neg50 EQU FLT_NEG50
    flt_neg51 EQU FLT_NEG51
    flt_neg52 EQU FLT_NEG52
    flt_neg53 EQU FLT_NEG53
    flt_neg54 EQU FLT_NEG54
    flt_neg55 EQU FLT_NEG55
    flt_neg56 EQU FLT_NEG56
    flt_neg57 EQU FLT_NEG57
    flt_neg58 EQU FLT_NEG58
    flt_neg59 EQU FLT_NEG59
    flt_neg60 EQU FLT_NEG60
    flt_neg61 EQU FLT_NEG61
    flt_neg62 EQU FLT_NEG62
    flt_neg63 EQU FLT_NEG63
    flt_neg64 EQU FLT_NEG64
    flt_neg65 EQU FLT_NEG65
    flt_neg66 EQU FLT_NEG66
    flt_neg67 EQU FLT_NEG67
    flt_neg68 EQU FLT_NEG68
    flt_neg69 EQU FLT_NEG69
    flt_neg70 EQU FLT_NEG70
    flt_neg71 EQU FLT_NEG71
    flt_neg72 EQU FLT_NEG72
    flt_neg73 EQU FLT_NEG73
    flt_neg74 EQU FLT_NEG74
    flt_neg75 EQU FLT_NEG75
    flt_neg76 EQU FLT_NEG76
    flt_neg77 EQU FLT_NEG77
    flt_neg78 EQU FLT_NEG78
    flt_neg79 EQU FLT_NEG79
    flt_neg80 EQU FLT_NEG80
    flt_neg81 EQU FLT_NEG81
    flt_neg82 EQU FLT_NEG82
    flt_neg83 EQU FLT_NEG83
    flt_neg84 EQU FLT_NEG84
    flt_neg85 EQU FLT_NEG85
    flt_neg86 EQU FLT_NEG86
    flt_neg87 EQU FLT_NEG87
    flt_neg88 EQU FLT_NEG88
    flt_neg89 EQU FLT_NEG89
    flt_neg90 EQU FLT_NEG90
    flt_neg91 EQU FLT_NEG91
    flt_neg92 EQU FLT_NEG92
    flt_neg93 EQU FLT_NEG93
    flt_neg94 EQU FLT_NEG94
    flt_neg95 EQU FLT_NEG95
    flt_neg96 EQU FLT_NEG96
    flt_neg97 EQU FLT_NEG97
    flt_neg98 EQU FLT_NEG98
    flt_neg99 EQU FLT_NEG99
    flt_neg100 EQU FLT_NEG100
    flt_neg125 EQU FLT_NEG125
    flt_neg126 EQU FLT_NEG126
    flt_neg127 EQU FLT_NEG127
    flt_neg128 EQU FLT_NEG128
    flt_neg140 EQU FLT_NEG140
    flt_neg145 EQU FLT_NEG145
    flt_neg150 EQU FLT_NEG150
    flt_neg180 EQU FLT_NEG180
    flt_neg253 EQU FLT_NEG253
    flt_neg254 EQU FLT_NEG254
    flt_neg255 EQU FLT_NEG255
    flt_neg256 EQU FLT_NEG256
    flt_neg360 EQU FLT_NEG360
    flt_neg511 EQU FLT_NEG511
    flt_neg512 EQU FLT_NEG512
    flt_neg513 EQU FLT_NEG513
    flt_neg1023 EQU FLT_NEG1023
    flt_neg1024 EQU FLT_NEG1024
    flt_neg1025 EQU FLT_NEG1025

    flt_neg32767 EQU FLT_NEG32767
    flt_neg32768 EQU FLT_NEG32768
    flt_neg65535 EQU FLT_NEG65535
    flt_neg65536 EQU FLT_NEG65536
    flt_neg2147483647 EQU FLT_NEG2147483647
    flt_neg2147483648 EQU FLT_NEG2147483648
    flt_neg4294967295 EQU FLT_NEG4294967295
    flt_neg4294967296 EQU FLT_NEG4294967296

    flt_bin128 EQU FLT_BIN128
    flt_binneg150 EQU FLT_BINNEG150

    flt_maxrand EQU FLT_MAXRAND

    flt_maxi8 EQU FLT_MAXI8
    flt_mini8 EQU FLT_MINI8
    flt_maxu8 EQU FLT_MAXU8
    flt_minu8 EQU FLT_MINU8

    flt_maxi16 EQU FLT_MAXI16
    flt_mini16 EQU FLT_MINI16
    flt_maxu16 EQU FLT_MAXU16
    flt_minu16 EQU FLT_MINU16

    flt_maxi32 EQU FLT_MAXI32
    flt_mini32 EQU FLT_MINI32
    flt_maxu32 EQU FLT_MAXU32
    flt_minu32 EQU FLT_MINU32

    flt_maxi8xu8 EQU FLT_MAXI8XU8
    flt_mini8xu8 EQU FLT_MINI8XU8
    flt_maxi8xu16 EQU FLT_MAXI8XU16
    flt_mini8xu16 EQU FLT_MINI8XU16

    flt_maxi16xu16 EQU FLT_MAXI16XU16
    flt_mini16xu16 EQU FLT_MINI16XU16

    flt_fixunsigned EQU FLT_FIXUNSIGNED
    flt_fixunsigned32 EQU FLT_FIXUNSIGNED32
    flt_fixmaxi32 EQU FLT_FIXMAXI32
    flt_fixmaxu32 EQU FLT_FIXMAXU32

    flt_rcpi16 EQU FLT_RCPI16
    flt_rcpu16 EQU FLT_RCPU16
    flt_rcpi16xu16 EQU FLT_RCPI16XU16

    flt_fixaa8 EQU FLT_FIXAA8
    flt_fixr8 EQU FLT_FIXR8
    flt_fixg8 EQU FLT_FIXG8
    flt_fixb8 EQU FLT_FIXB8

    flt_norma8 EQU FLT_NORMA8
    flt_normr8 EQU FLT_NORMR8
    flt_normg8 EQU FLT_NORMG8
    flt_normb8 EQU FLT_NORMB8

    flt_fixaa2 EQU FLT_FIXAA2
    flt_fixb10 EQU FLT_FIXB10
    flt_fixg10 EQU FLT_FIXG10
    flt_fixr10 EQU FLT_FIXR10

    flt_norma2 EQU FLT_NORMA2
    flt_normb10 EQU FLT_NORMB10
    flt_normg10 EQU FLT_NORMG10
    flt_normr10 EQU FLT_NORMR10

    flt_mg EQU FLT_MG
    flt_negmg EQU FLT_NEGMG
    flt_halfmg EQU FLT_HALFMG
    flt_neghalfmg EQU FLT_NEGHALFMG
    flt_mgdiv4 EQU FLT_MGDIV4
    flt_negmgdiv4 EQU FLT_NEGMGDIV4
    flt_halfmgxmg EQU FLT_HALFMGXMG
    flt_halfmgxsqrmg EQU FLT_HALFMGXSQRMG
    flt_halfmgxcubemg EQU FLT_HALFMGXCUBEMG
    flt_neghalfmgxmg EQU FLT_NEGHALFMGXMG
    flt_neghalfmgxsqrmg EQU FLT_NEGHALFMGXSQRMG
    flt_neghalfmgxcubemg EQU FLT_NEGHALFMGXCUBEMG
    flt_sqrmg EQU FLT_SQRMG
    flt_cubemg EQU FLT_CUBEMG
    flt_sqrtmg EQU FLT_SQRTMG
    flt_cbrtmg EQU FLT_CBRTMG
    flt_rcpmg EQU FLT_RCPMG
    flt_rcpsqrmg EQU FLT_RCPSQRMG
    flt_rcpcubemg EQU FLT_RCPCUBEMG
    flt_rcpsqrtmg EQU FLT_RCPSQRTMG
    flt_rcpcbrtmg EQU FLT_RCPCBRTMG

    flt_2mg EQU FLT_2MG
    flt_neg2mg EQU FLT_NEG2MG
    flt_sqr2mg EQU FLT_SQR2MG
    flt_cube2mg EQU FLT_CUBE2MG
    flt_sqrt2mg EQU FLT_SQRT2MG
    flt_cbrt2mg EQU FLT_CBRT2MG
    flt_4mg EQU FLT_4MG
    flt_neg4mg EQU FLT_NEG4MG
    flt_sqr4mg EQU FLT_SQR4MG
    flt_cube4mg EQU FLT_CUBE4MG
    flt_sqrt4mg EQU FLT_SQRT4MG
    flt_cbrt4mg EQU FLT_CBRT4MG
    flt_rcp2mg EQU FLT_RCP2MG
    flt_rcp4mg EQU FLT_RCP4MG

    flt_e EQU FLT_E
    flt_exp EQU FLT_EXP
    flt_loge EQU FLT_LOGE
    flt_logehigh EQU FLT_LOGEHIGH
    flt_log2e EQU FLT_LOG2E
    flt_log2ehigh EQU FLT_LOG2EHIGH
    flt_log10e EQU FLT_LOG10E
    flt_rcplog2e EQU FLT_RCPLOG2E
    flt_rcplog10e EQU FLT_RCPLOG10E
    flt_log2t EQU FLT_LOG2T
    flt_log2 EQU FLT_LOG2
    flt_log2high EQU FLT_LOG2HIGH
    flt_ln2 EQU FLT_LN2
    flt_ln2high EQU FLT_LN2HIGH
    flt_1divln2 EQU FLT_1DIVLN2
    flt_2divln2 EQU FLT_2DIVLN2
    flt_lnt EQU FLT_LNT
    flt_lnthigh EQU FLT_LNTHIGH
    flt_ln10 EQU FLT_LN10
    flt_sqrt2 EQU FLT_SQRT2
    flt_rcpsqrt2 EQU FLT_RCPSQRT2
    flt_sqrt2div2 EQU FLT_SQRT2DIV2
    flt_sqrt2div2high EQU FLT_SQRT2DIV2HIGH
    flt_sqrt2div2low EQU FLT_SQRT2DIV2LOW
    flt_sqrthalf EQU FLT_SQRTHALF
    flt_sqrthalfhigh EQU FLT_SQRTHALFHIGH
    flt_sqrthalflow EQU FLT_SQRTHALFLOW
    flt_pow2 EQU FLT_POW2
    flt_rcppow2 EQU FLT_RCPPOW2
    flt_cbrt2 EQU FLT_CBRT2
    flt_rcpcbrt2 EQU FLT_RCPCBRT2
    flt_1div3 EQU FLT_1DIV3
    flt_1div7 EQU FLT_1DIV7
    flt_1div9 EQU FLT_1DIV9
    flt_2div3 EQU FLT_2DIV3
    flt_2div7 EQU FLT_2DIV7
    flt_2div9 EQU FLT_2DIV9
    flt_4div3 EQU FLT_4DIV3
    flt_4div7 EQU FLT_4DIV7
    flt_4div9 EQU FLT_4DIV9

    flt_pi EQU FLT_PI
    flt_pihigh EQU FLT_PIHIGH
    flt_halfpi EQU FLT_HALFPI
    flt_2pi EQU FLT_2PI
    flt_negpi EQU FLT_NEGPI
    flt_neghalfpi EQU FLT_NEGHALFPI
    flt_neg2pi EQU FLT_NEG2PI
    flt_rcppi EQU FLT_RCPPI
    flt_invpi EQU FLT_INVPI
    flt_rcp2pi EQU FLT_RCP2PI
    flt_inv2pi EQU FLT_INV2PI
    flt_pidiv2 EQU FLT_PIDIV2
    flt_pidiv2high EQU FLT_PIDIV2HIGH
    flt_pidiv4 EQU FLT_PIDIV4
    flt_pidiv4high EQU FLT_PIDIV4HIGH
    flt_pix3div4 EQU FLT_PIX3DIV4
    flt_sqrtpi EQU FLT_SQRTPI
    flt_sqrt2pi EQU FLT_SQRT2PI
    flt_sqrt2pihigh EQU FLT_SQRT2PIHIGH
    flt_rcpsqrtpi EQU FLT_RCPSQRTPI
    flt_rcpsqrt2pi EQU FLT_RCPSQRT2PI
    flt_sqrtpidiv2 EQU FLT_SQRTPIDIV2
    flt_sqrtpidiv2high EQU FLT_SQRTPIDIV2HIGH
    flt_sqrt2pidiv2 EQU FLT_SQRT2PIDIV2
    flt_sqrt2pidiv2high EQU FLT_SQRT2PIDIV2HIGH
    flt_2divpi EQU FLT_2DIVPI
    flt_2div2pi EQU FLT_2DIV2PI
    flt_2divsqrtpi EQU FLT_2DIVSQRTPI
    flt_2divsqrt2pi EQU FLT_2DIVSQRT2PI
    flt_sqrt2divpi EQU FLT_SQRT2DIVPI
    flt_logpi EQU FLT_LOGPI
    flt_log2pi EQU FLT_LOG2PI
    flt_lnpi EQU FLT_LNPI
    flt_ln2pi EQU FLT_LN2PI
    flt_powpi EQU FLT_POWPI
    flt_rcppowpi EQU FLT_RCPPOWPI
    flt_pow2pi EQU FLT_POW2PI
    flt_rcppow2pi EQU FLT_RCPPOW2PI
    flt_cbrtpi EQU FLT_CBRTPI
    flt_rcpcbrtpi EQU FLT_RCPCBRTPI
    flt_cbrt2pi EQU FLT_CBRT2PI
    flt_rcpcbrt2pi EQU FLT_RCPCBRT2PI

    flt_pow2tom126 EQU FLT_POW2TOM126
    flt_pow2to126 EQU FLT_POW2TO126
    flt_normhuge EQU FLT_NORMHUGE
    flt_pow2to23 EQU FLT_POW2TO23
    flt_pow2to24 EQU FLT_POW2TO24
    flt_maxi32pow2to23 EQU FLT_MAXI32POW2TO23
    flt_pow2to31 EQU FLT_POW2TO31
    flt_pow2to32 EQU FLT_POW2TO32

    flt_remquobits EQU FLT_REMQUOBITS
    flt_remquomask EQU FLT_REMQUOMASK

    flt_trigploss EQU FLT_TRIGPLOSS

    flt_degtorad EQU FLT_DEGTORAD
    flt_radtodeg EQU FLT_RADTODEG

    flt_degtograd EQU FLT_DEGTOGRAD
    flt_gradtodeg EQU FLT_GRADTODEG

    flt_radtograd EQU FLT_RADTOGRAD
    flt_gradtorad EQU FLT_GRADTORAD

    flt_sungravity EQU FLT_SUNGRAVITY
    flt_jupitergravity EQU FLT_JUPITERGRAVITY
    flt_neptunegravity EQU FLT_NEPTUNEGRAVITY
    flt_saturngravity EQU FLT_SATURNGRAVITY
    flt_uranusgravity EQU FLT_URANUSGRAVITY
    flt_earthgravity EQU FLT_EARTHGRAVITY
    flt_venusgravity EQU FLT_VENUSGRAVITY
    flt_marsgravity EQU FLT_MARSGRAVITY
    flt_mercurygravity EQU FLT_MERCURYGRAVITY
    flt_moongravity EQU FLT_MOONGRAVITY
    flt_plutogravity EQU FLT_PLUTOGRAVITY

    flt_kmtoinch EQU FLT_KMTOINCH
    flt_kmtofeet EQU FLT_KMTOFEET
    flt_kmtoyards EQU FLT_KMTOYARDS
    flt_kmtomiles EQU FLT_KMTOMILES

    flt_metoinch EQU FLT_METOINCH
    flt_metofeet EQU FLT_METOFEET
    flt_metoyards EQU FLT_METOYARDS
    flt_metomiles EQU FLT_METOMILES

    flt_cmtoinch EQU FLT_CMTOINCH
    flt_cmtofeet EQU FLT_CMTOFEET
    flt_cmtoyards EQU FLT_CMTOYARDS
    flt_cmtomiles EQU FLT_CMTOMILES

    flt_milltoinch EQU FLT_MILLTOINCH
    flt_milltofeet EQU FLT_MILLTOFEET
    flt_milltoyards EQU FLT_MILLTOYARDS
    flt_milltomiles EQU FLT_MILLTOMILES

    flt_inchtomill EQU FLT_INCHTOMILL
    flt_inchtocm EQU FLT_INCHTOCM
    flt_inchtome EQU FLT_INCHTOME
    flt_inchtokm EQU FLT_INCHTOKM
    flt_inchtofeet EQU FLT_INCHTOFEET
    flt_inchtoyards EQU FLT_INCHTOYARDS
    flt_inchtomiles EQU FLT_INCHTOMILES

    flt_feettomill EQU FLT_FEETTOMILL
    flt_feettocm EQU FLT_FEETTOCM
    flt_feettome EQU FLT_FEETTOME
    flt_feettokm EQU FLT_FEETTOKM
    flt_feettoinch EQU FLT_FEETTOINCH
    flt_feettoyards EQU FLT_FEETTOYARDS
    flt_feettomiles EQU FLT_FEETTOMILES

    flt_yardstomill EQU FLT_YARDSTOMILL
    flt_yardstocm EQU FLT_YARDSTOCM
    flt_yardstome EQU FLT_YARDSTOME
    flt_yardstokm EQU FLT_YARDSTOKM
    flt_yardstoinch EQU FLT_YARDSTOINCH
    flt_yardstofeet EQU FLT_YARDSTOFEET
    flt_yardstomiles EQU FLT_YARDSTOMILES

    flt_milestomill EQU FLT_MILESTOMILL
    flt_milestocm EQU FLT_MILESTOCM
    flt_milestome EQU FLT_MILESTOME
    flt_milestokm EQU FLT_MILESTOKM
    flt_milestoinch EQU FLT_MILESTOINCH
    flt_milestofeet EQU FLT_MILESTOFEET
    flt_milestoyards EQU FLT_MILESTOYARDS

    flt_kmphtomeps EQU FLT_KMPHTOMEPS
    flt_kmphtokmps EQU FLT_KMPHTOKMPS
    flt_kmphtomepm EQU FLT_KMPHTOMEPM
    flt_kmphtomilesph EQU FLT_KMPHTOMILESPH
    flt_kmphtomilesps EQU FLT_KMPHTOMILESPS
    flt_kmphtofeetps EQU FLT_KMPHTOFEETPS
    flt_kmphtofeetpm EQU FLT_KMPHTOFEETPM

    flt_kmpstomeps EQU FLT_KMPSTOMEPS
    flt_kmpstokmph EQU FLT_KMPSTOKMPH
    flt_kmpstomepm EQU FLT_KMPSTOMEPM
    flt_kmpstomilesph EQU FLT_KMPSTOMILESPH
    flt_kmpstomilesps EQU FLT_KMPSTOMILESPS
    flt_kmpstofeetps EQU FLT_KMPSTOFEETPS
    flt_kmpstofeetpm EQU FLT_KMPSTOFEETPM

    flt_mepstokmph EQU FLT_MEPSTOKMPH
    flt_mepstokmps EQU FLT_MEPSTOKMPS
    flt_mepstomepm EQU FLT_MEPSTOMEPM
    flt_mepstomilesph EQU FLT_MEPSTOMILESPH
    flt_mepstomilesps EQU FLT_MEPSTOMILESPS
    flt_mepstofeetps EQU FLT_MEPSTOFEETPS
    flt_mepstofeetpm EQU FLT_MEPSTOFEETPM

    flt_mepmtokmph EQU FLT_MEPMTOKMPH
    flt_mepmtokmps EQU FLT_MEPMTOKMPS
    flt_mepmtomeps EQU FLT_MEPMTOMEPS
    flt_mepmtomilesph EQU FLT_MEPMTOMILESPH
    flt_mepmtomilesps EQU FLT_MEPMTOMILESPS
    flt_mepmtofeetps EQU FLT_MEPMTOFEETPS
    flt_mepmtofeetpm EQU FLT_MEPMTOFEETPM

    flt_milesphtokmph EQU FLT_MILESPHTOKMPH
    flt_milesphtokmps EQU FLT_MILESPHTOKMPS
    flt_milesphtomeps EQU FLT_MILESPHTOMEPS
    flt_milesphtomepm EQU FLT_MILESPHTOMEPM
    flt_milesphtomilesps EQU FLT_MILESPHTOMILESPS
    flt_milesphtofeetps EQU FLT_MILESPHTOFEETPS
    flt_milesphtofeetpm EQU FLT_MILESPHTOFEETPM

    flt_milespstokmph EQU FLT_MILESPSTOKMPH
    flt_milespstokmps EQU FLT_MILESPSTOKMPS
    flt_milespstomeps EQU FLT_MILESPSTOMEPS
    flt_milespstomepm EQU FLT_MILESPSTOMEPM
    flt_milespstomilesph EQU FLT_MILESPSTOMILESPH
    flt_milespstofeetps EQU FLT_MILESPSTOFEETPS
    flt_milespstofeetpm EQU FLT_MILESPSTOFEETPM

    flt_feetpstokmph EQU FLT_FEETPSTOKMPH
    flt_feetpstokmps EQU FLT_FEETPSTOKMPS
    flt_feetpstomeps EQU FLT_FEETPSTOMEPS
    flt_feetpstomepm EQU FLT_FEETPSTOMEPM
    flt_feetpstomilesph EQU FLT_FEETPSTOMILESPH
    flt_feetpstomilesps EQU FLT_FEETPSTOMILESPS
    flt_feetpstofeetpm EQU FLT_FEETPSTOFEETPM

    flt_feetpmtokmph EQU FLT_FEETPMTOKMPH
    flt_feetpmtokmps EQU FLT_FEETPMTOKMPS
    flt_feetpmtomeps EQU FLT_FEETPMTOMEPS
    flt_feetpmtomepm EQU FLT_FEETPMTOMEPM
    flt_feetpmtomilesph EQU FLT_FEETPMTOMILESPH
    flt_feetpmtomilesps EQU FLT_FEETPMTOMILESPS
    flt_feetpmtofeetps EQU FLT_FEETPMTOFEETPS

    flt_soundspeedp50c EQU FLT_SOUNDSPEEDP50C
    flt_soundspeedp45c EQU FLT_SOUNDSPEEDP45C
    flt_soundspeedp40c EQU FLT_SOUNDSPEEDP40C
    flt_soundspeedp35c EQU FLT_SOUNDSPEEDP35C
    flt_soundspeedp30c EQU FLT_SOUNDSPEEDP30C
    flt_soundspeedp25c EQU FLT_SOUNDSPEEDP25C
    flt_soundspeedp20c EQU FLT_SOUNDSPEEDP20C
    flt_soundspeedp15c EQU FLT_SOUNDSPEEDP15C
    flt_soundspeedp10c EQU FLT_SOUNDSPEEDP10C
    flt_soundspeedp5c EQU FLT_SOUNDSPEEDP5C
    flt_soundspeed0c EQU FLT_SOUNDSPEED0C
    flt_soundspeedn5c EQU FLT_SOUNDSPEEDN5C
    flt_soundspeedn10c EQU FLT_SOUNDSPEEDN10C
    flt_soundspeedn15c EQU FLT_SOUNDSPEEDN15C
    flt_soundspeedn20c EQU FLT_SOUNDSPEEDN20C
    flt_soundspeedn25c EQU FLT_SOUNDSPEEDN25C
    flt_soundspeedn30c EQU FLT_SOUNDSPEEDN30C
    flt_soundspeedn35c EQU FLT_SOUNDSPEEDN35C
    flt_soundspeedn40c EQU FLT_SOUNDSPEEDN40C
    flt_soundspeedn45c EQU FLT_SOUNDSPEEDN45C
    flt_soundspeedn50c EQU FLT_SOUNDSPEEDN50C

    flt_schscale EQU FLT_SCHSCALE
    flt_thscale EQU FLT_THSCALE

    flt_expest1 EQU FLT_EXPEST1
    flt_expest2 EQU FLT_EXPEST2
    flt_expest3 EQU FLT_EXPEST3
    flt_expest4 EQU FLT_EXPEST4
    flt_expest5 EQU FLT_EXPEST5
    flt_expest6 EQU FLT_EXPEST6
    flt_expest7 EQU FLT_EXPEST7
    flt_logest0 EQU FLT_LOGEST0
    flt_logest1 EQU FLT_LOGEST1
    flt_logest2 EQU FLT_LOGEST2
    flt_logest3 EQU FLT_LOGEST3
    flt_logest4 EQU FLT_LOGEST4
    flt_logest5 EQU FLT_LOGEST5
    flt_logest6 EQU FLT_LOGEST6
    flt_logest7 EQU FLT_LOGEST7
    
    ENDIF ;CASEMAPNONE

    ENDIF ;WITHMACROLIB

    ENDIF    ;REAL4LIMITS_INC
