
; / / / / / / / / / / / / / / / / / / / / / / / / / / / / / / / / / / / / / / / / / / /
; / / / / / / / / / / / / / / / / / / / / / / / / / / / / / / / / / / / / / / / / / / /
; / /                                                                               / /
; / /                Copyright 2020 (c) UASM macro assembly library                 / /
; / /                                                                               / /
; / /    Licensed under the Apache License, Version 2.0 (the "License");            / /
; / /    you may not use this file except in compliance with the License.           / /
; / /    You may obtain a copy of the License at                                    / /
; / /                                                                               / /
; / /        http://www.apache.org/licenses/LICENSE-2.0                             / /
; / /                                                                               / /
; / /    Unless required by applicable law or agreed to in writing, software        / /
; / /    distributed under the License is distributed on an "AS IS" BASIS,          / /
; / /    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.   / /
; / /    See the License for the specific language governing permissions and        / /
; / /    limitations under the License.                                             / /
; / /                                                                               / /
; / / / / / / / / / / / / / / / / / / / / / / / / / / / / / / / / / / / / / / / / / / /
; / / / / / / / / / / / / / / / / / / / / / / / / / / / / / / / / / / / / / / / / / / /

    IFNDEF REAL8LIMITS_INC
    REAL8LIMITS_INC EQU 1
    
    IFDEF WITHMACROLIB

    IFNDEF MACROLIB_INC
    .ERR <"REAL8LIMITS_INC must be included by MACROLIB_INC">
    ENDIF
    
    IFNDEF LIMITS_INC
    .ERR <"REAL8LIMITS_INC requires LIMITS_INC">
    ENDIF
    
    IFNDEF X86ORX64
    .ERR <"REAL8LIMITS_INC requires one x86 or x64 platform type">
    ENDIF

   ;/*double mask*/
    DBL_1LSHL3_MSK EQU 0x0000000000000008
    DBL_1LSHL4_MSK EQU 0x0000000000000010
    DBL_1LSHL7_MSK EQU 0x0000000000000080
    DBL_1LSHL8_MSK EQU 0x0000000000000100
    DBL_1LSHL11_MSK EQU 0x0000000000000800
    DBL_1LSHL12_MSK EQU 0x0000000000001000
    DBL_1LSHL15_MSK EQU 0x0000000000008000
    DBL_1LSHL16_MSK EQU 0x0000000000010000
    DBL_1LSHL19_MSK EQU 0x0000000000080000
    DBL_1LSHL20_MSK EQU 0x0000000000100000
    DBL_1LSHL23_MSK EQU 0x0000000000800000
    DBL_1LSHL24_MSK EQU 0x0000000001000000
    DBL_1LSHL27_MSK EQU 0x0000000008000000
    DBL_1LSHL28_MSK EQU 0x0000000010000000
    DBL_1LSHL31_MSK EQU 0x0000000080000000
    DBL_1LSHL32_MSK EQU 0x0000000100000000
    DBL_1LSHL35_MSK EQU 0x0000000800000000
    DBL_1LSHL36_MSK EQU 0x0000001000000000
    DBL_1LSHL39_MSK EQU 0x0000008000000000
    DBL_1LSHL40_MSK EQU 0x0000010000000000
    DBL_1LSHL43_MSK EQU 0x0000080000000000
    DBL_1LSHL44_MSK EQU 0x0000100000000000
    DBL_1LSHL47_MSK EQU 0x0000800000000000
    DBL_1LSHL48_MSK EQU 0x0001000000000000
    DBL_1LSHL51_MSK EQU 0x0008000000000000
    DBL_1LSHL52_MSK EQU 0x0010000000000000
    DBL_1LSHL55_MSK EQU 0x0080000000000000
    DBL_1LSHL56_MSK EQU 0x0100000000000000
    DBL_1LSHL59_MSK EQU 0x0800000000000000
    DBL_1LSHL60_MSK EQU 0x1000000000000000
    DBL_1LSHL63_MSK EQU 0x8000000000000000

    DBL_NEG1LSHL3_MSK EQU 0xfffffffffffffff8
    DBL_NEG1LSHL4_MSK EQU 0xfffffffffffffff0
    DBL_NEG1LSHL7_MSK EQU 0xffffffffffffff80
    DBL_NEG1LSHL8_MSK EQU 0xffffffffffffff00
    DBL_NEG1LSHL11_MSK EQU 0xfffffffffffff800
    DBL_NEG1LSHL12_MSK EQU 0xfffffffffffff000
    DBL_NEG1LSHL15_MSK EQU 0xffffffffffff8000
    DBL_NEG1LSHL16_MSK EQU 0xffffffffffff0000
    DBL_NEG1LSHL19_MSK EQU 0xfffffffffff80000
    DBL_NEG1LSHL20_MSK EQU 0xfffffffffff00000
    DBL_NEG1LSHL23_MSK EQU 0xffffffffff800000
    DBL_NEG1LSHL24_MSK EQU 0xffffffffff000000
    DBL_NEG1LSHL27_MSK EQU 0xfffffffff8000000
    DBL_NEG1LSHL28_MSK EQU 0xfffffffff0000000
    DBL_NEG1LSHL31_MSK EQU 0xffffffff80000000
    DBL_NEG1LSHL32_MSK EQU 0xffffffff00000000
    DBL_NEG1LSHL35_MSK EQU 0xfffffff800000000
    DBL_NEG1LSHL36_MSK EQU 0xfffffff000000000
    DBL_NEG1LSHL39_MSK EQU 0xffffff8000000000
    DBL_NEG1LSHL40_MSK EQU 0xffffff0000000000
    DBL_NEG1LSHL43_MSK EQU 0xfffff80000000000
    DBL_NEG1LSHL44_MSK EQU 0xfffff00000000000
    DBL_NEG1LSHL47_MSK EQU 0xffff800000000000
    DBL_NEG1LSHL48_MSK EQU 0xffff000000000000
    DBL_NEG1LSHL51_MSK EQU 0xfff8000000000000
    DBL_NEG1LSHL52_MSK EQU 0xfff0000000000000
    DBL_NEG1LSHL55_MSK EQU 0xff80000000000000
    DBL_NEG1LSHL56_MSK EQU 0xff00000000000000
    DBL_NEG1LSHL59_MSK EQU 0xf800000000000000
    DBL_NEG1LSHL60_MSK EQU 0xf000000000000000
    DBL_NEG1LSHL63_MSK EQU 0x8000000000000000

    DBL_FALSE_MSK EQU 0x0000000000000000
    DBL_TRUE_MSK EQU 0xffffffffffffffff
    DBL_ERROR_MSK EQU DBL_ERROR

    DBL_MAGIC_MSK EQU 0x4330000000000000
    DBL_SIGN_MSK EQU 0x8000000000000000
    DBL_INVSIGN_MSK EQU 0x7fffffffffffffff

    DBL_INF_MSK EQU 0x7ff0000000000000
    DBL_FIN_MSK EQU 0xffe0000000000000
    DBL_INVINF_MSK EQU 0x800fffffffffffff
    DBL_NEGINF_MSK EQU 0xfff0000000000000
    DBL_NAN_MSK EQU 0x7fffffffffffffff
    DBL_QNAN_MSK EQU 0x7ff8000000000000
    DBL_NEGQNAN_MSK EQU 0xfff8000000000000
    DBL_NANTEST_MSK EQU 0x000fffffffffffff
    DBL_ABS_MSK EQU 0x7fffffffffffffff
    DBL_MAX_MSK EQU 0x7fefffffffffffff
    DBL_MIN_MSK EQU 0x0010000000000000
    DBL_NOFRACTION_MSK EQU 0x0010000000000000
    DBL_MINDENORM_MSK EQU 0x0000000000000001
    DBL_DENORMLIMIT_MSK EQU 0x0010000000000000
    DBL_MINNORMAL_MSK EQU 0x0010000000000000
    DBL_MAXNORMAL_MSK EQU 0x7fefffffffffffff

    DBL_DECDIG_MSK EQU 0x0000000000000011
    DBL_DIG_MSK EQU 0x000000000000000f
    DBL_NEGDECDIG_MSK EQU 0xffffffffffffffef
    DBL_NEGDIG_MSK EQU 0xfffffffffffffff1
    DBL_EPS_MSK EQU 0x3cb0000000000000
    DBL_EPSILON_MSK EQU 0x3cb0000000000000
    DBL_NORMEPS_MSK EQU 0x1a90991a9bfa58c8
    DBL_GUARD_MSK EQU 0x0000000000000000
    DBL_MANTPOW2_MSK EQU 0x0010000000000000
    DBL_MAXMANTPOW2_MSK EQU 0x7fefffffffffffff
    DBL_MANTDIG_MSK EQU 0x0000000000000035
    DBL_MANT_MSK EQU 0x0000000000000034
    DBL_NEGMANTDIG_MSK EQU 0xffffffffffffffcb
    DBL_NEGMANT_MSK EQU 0xffffffffffffffcc
    DBL_MAXEXPO_MSK EQU 0x0000000000000400
    DBL_EXPOSIGN_MSK EQU 0x0000000000000400
    DBL_EXPO_MSK EQU 0x00000000000003ff
    DBL_NEGMAXEXPO_MSK EQU 0xfffffffffffffc00
    DBL_NEGEXPOSIGN_MSK EQU 0xfffffffffffffc00
    DBL_NEGEXPO_MSK EQU 0xfffffffffffffc01
    DBL_SUBNORMALEXPO_MSK EQU 0xfffffffffffffc02
    DBL_MINEXPO_MSK EQU 0xfffffffffffffc03
    DBL_MAXDECEXPO_MSK EQU 0x0000000000000134
    DBL_NEGMAXDECEXPO_MSK EQU 0xfffffffffffffecc
    DBL_MINDECEXPO_MSK EQU 0xfffffffffffffecd
    DBL_EXPOFIELD_MSK EQU 0xfff0000000000000
    DBL_MANTFIELD_MSK EQU 0x000fffffffffffff
    DBL_NORM_MSK EQU 0x0000000000000000
    DBL_RADIX_MSK EQU 0x0000000000000002
    DBL_ROUNDS_MSK EQU 0x0000000000000001
    DBL_SUBDEC_MSK EQU 0x000000000000000a
    DBL_SQRTMAX_MSK EQU 0x5f22087c1aeb65dc
    DBL_SMALLNORMAL_MSK EQU 0x0010000000000000

    DBL_HALFMINUSEPS_MSK EQU 0x3fdffffffffffffc
    DBL_TRUEINT_MSK EQU 0x0000000000000001

    DBL_BYTE_MSK EQU 0x00000000000000ff
    DBL_BYTE_EVEN_MSK EQU 0x00ff00ff00ff00ff
    DBL_BYTE_ODD_MSK EQU 0xff00ff00ff00ff00
    DBL_4LOW_MSK EQU 0x0fffffffffffffff
    DBL_4HIGH_MSK EQU 0xfffffffffffffff0
    DBL_FLIP4_MSK EQU 0x0000000000000008
    DBL_8LOW_MSK EQU 0x00ffffffffffffff
    DBL_8HIGH_MSK EQU 0xffffffffffffff00
    DBL_FLIP8_MSK EQU 0x0000000000000080
    DBL_12LOW_MSK EQU 0x000fffffffffffff
    DBL_12HIGH_MSK EQU 0xfffffffffffff000
    DBL_FLIP12_MSK EQU 0x0000000000000800
    DBL_16LOW_MSK EQU 0x0000ffffffffffff
    DBL_16HIGH_MSK EQU 0xffffffffffff0000
    DBL_FLIP16_MSK EQU 0x0000000000008000
    DBL_20LOW_MSK EQU 0x00000fffffffffff
    DBL_20HIGH_MSK EQU 0xfffffffffff00000
    DBL_FLIP20_MSK EQU 0x0000000000080000
    DBL_24LOW_MSK EQU 0x000000ffffffffff
    DBL_24HIGH_MSK EQU 0xffffffffff000000
    DBL_FLIP24_MSK EQU 0x0000000000800000
    DBL_28LOW_MSK EQU 0x0000000fffffffff
    DBL_28HIGH_MSK EQU 0xfffffffff0000000
    DBL_FLIP28_MSK EQU 0x0000000008000000
    DBL_32LOW_MSK EQU 0x00000000ffffffff
    DBL_32HIGH_MSK EQU 0xffffffff00000000
    DBL_FLIP32_MSK EQU 0x0000000080000000
    DBL_36LOW_MSK EQU 0x000000000fffffff
    DBL_36HIGH_MSK EQU 0xfffffff000000000
    DBL_FLIP36_MSK EQU 0x0000000800000000
    DBL_40LOW_MSK EQU 0x0000000000ffffff
    DBL_40HIGH_MSK EQU 0xffffff0000000000
    DBL_FLIP40_MSK EQU 0x0000008000000000
    DBL_44LOW_MSK EQU 0x00000000000fffff
    DBL_44HIGH_MSK EQU 0xfffff00000000000
    DBL_FLIP44_MSK EQU 0x0000080000000000
    DBL_48LOW_MSK EQU 0x000000000000ffff
    DBL_48HIGH_MSK EQU 0xffff000000000000
    DBL_FLIP48_MSK EQU 0x0000800000000000
    DBL_52LOW_MSK EQU 0x0000000000000fff
    DBL_52HIGH_MSK EQU 0xfff0000000000000
    DBL_FLIP52_MSK EQU 0x0008000000000000
    DBL_56LOW_MSK EQU 0x00000000000000ff
    DBL_56HIGH_MSK EQU 0xff00000000000000
    DBL_FLIP56_MSK EQU 0x0080000000000000
    DBL_60LOW_MSK EQU 0x000000000000000f
    DBL_60HIGH_MSK EQU 0xf000000000000000
    DBL_FLIP60_MSK EQU 0x0800000000000000
    DBL_64LOW_MSK EQU 0x0000000000000000
    DBL_64HIGH_MSK EQU 0x0000000000000000
    DBL_FLIP64_MSK EQU 0x8000000000000000

    DBL_0_MSK EQU 0x0000000000000000
    DBL_0D5_MSK EQU 0x3fe0000000000000
    DBL_1_MSK EQU 0x3ff0000000000000
    DBL_1D5_MSK EQU 0x3ff8000000000000
    DBL_2_MSK EQU 0x4000000000000000
    DBL_2D5_MSK EQU 0x4004000000000000
    DBL_3_MSK EQU 0x4008000000000000
    DBL_4_MSK EQU 0x4010000000000000
    DBL_5_MSK EQU 0x4014000000000000
    DBL_6_MSK EQU 0x4018000000000000
    DBL_7_MSK EQU 0x401c000000000000
    DBL_8_MSK EQU 0x4020000000000000
    DBL_9_MSK EQU 0x4022000000000000
    DBL_10_MSK EQU 0x4024000000000000
    DBL_20_MSK EQU 0x4034000000000000
    DBL_23_MSK EQU 0x4037000000000000
    DBL_23D5_MSK EQU 0x4037800000000000
    DBL_24_MSK EQU 0x4038000000000000
    DBL_24D5_MSK EQU 0x4038800000000000
    DBL_25_MSK EQU 0x4039000000000000

    DBL_128_MSK EQU 0x4060000000000000

    DBL_253_MSK EQU 0x406fa00000000000

    DBL_NEG0_MSK EQU 0x8000000000000000
    DBL_NEG1_MSK EQU 0xbff0000000000000

    DBL_NEG150_MSK EQU 0xc062c00000000000

    DBL_BIN128_MSK EQU DBL_128_MSK
    DBL_BINNEG150_MSK EQU DBL_NEG150_MSK

    DBL_MAXRAND_MSK EQU 0x0000000000007fff

    DBL_MAXI8_MSK EQU 0x000000000000007f
    DBL_MINI8_MSK EQU 0xffffffffffffff80
    DBL_MAXU8_MSK EQU 0x00000000000000ff

    DBL_MAXI16_MSK EQU 0x0000000000007fff
    DBL_MINI16_MSK EQU 0xffffffffffff8000
    DBL_MAXU16_MSK EQU 0x000000000000ffff

    DBL_MAXI32_MSK EQU 0x000000007fffffff
    DBL_MINI32_MSK EQU 0xffffffff80000000
    DBL_MAXU32_MSK EQU 0x00000000ffffffff

    DBL_MAXI64_MSK EQU 0x7fffffffffffffff
    DBL_MINI64_MSK EQU 0x8000000000000000
    DBL_MAXU64_MSK EQU 0xffffffffffffffff

    DBL_MAXI8XU8_MSK EQU 0x0000000000008000
    DBL_MINI8XU8_MSK EQU 0xffffffffffff8000
    DBL_MAXI8XU16_MSK EQU 0x0000000000800000
    DBL_MINI8XU16_MSK EQU 0xffffffffff800000

    DBL_MAXI16XU16_MSK EQU 0x0000000080000000
    DBL_MINI16XU16_MSK EQU 0xffffffff80000000
    DBL_MAXI16XU32_MSK EQU 0x0000800000000000
    DBL_MINI16XU32_MSK EQU 0xffff800000000000

    DBL_MAXI32XU32_MSK EQU 0x8000000000000000
    DBL_MINI32XU32_MSK EQU 0x8000000000000000

    DBL_FIXUNSIGNED_MSK EQU 0x0000000080000000
    DBL_FIXUNSIGNED32_MSK EQU 0x0000000080000000
    DBL_FIXMAXI32_MSK EQU 0x000000007fffff80
    DBL_FIXMAXU32_MSK EQU 0x00000000ffffff00

    DBL_FIXUNSIGNED64_MSK EQU 0x8000000000000000
    DBL_FIXMAXI64_MSK EQU 0x7ffffffffffff800
    DBL_FIXMAXU64_MSK EQU 0xfffffffffffff000

   ;/*double int*/
    DBL_1LSHL3_INT EQU 8
    DBL_1LSHL4_INT EQU 16
    DBL_1LSHL7_INT EQU 128
    DBL_1LSHL8_INT EQU 256
    DBL_1LSHL11_INT EQU 2048
    DBL_1LSHL12_INT EQU 4096
    DBL_1LSHL15_INT EQU 32768
    DBL_1LSHL16_INT EQU 65536
    DBL_1LSHL19_INT EQU 524288
    DBL_1LSHL20_INT EQU 1048576
    DBL_1LSHL23_INT EQU 8388608
    DBL_1LSHL24_INT EQU 16777216
    DBL_1LSHL27_INT EQU 134217728
    DBL_1LSHL28_INT EQU 268435456
    DBL_1LSHL31_INT EQU 2147483648
    DBL_1LSHL32_INT EQU 4294967296
    DBL_1LSHL35_INT EQU 34359738368
    DBL_1LSHL36_INT EQU 68719476736
    DBL_1LSHL39_INT EQU 549755813888
    DBL_1LSHL40_INT EQU 1099511627776
    DBL_1LSHL43_INT EQU 8796093022208
    DBL_1LSHL44_INT EQU 17592186044416
    DBL_1LSHL47_INT EQU 140737488355328
    DBL_1LSHL48_INT EQU 281474976710656
    DBL_1LSHL51_INT EQU 2251799813685248
    DBL_1LSHL52_INT EQU 4503599627370496
    DBL_1LSHL55_INT EQU 36028797018963968
    DBL_1LSHL56_INT EQU 72057594037927936
    DBL_1LSHL59_INT EQU 576460752303423488
    DBL_1LSHL60_INT EQU 1152921504606846976
    DBL_1LSHL63_INT EQU (-9223372036854775808)

    DBL_NEG1LSHL3_INT EQU (-8)
    DBL_NEG1LSHL4_INT EQU (-16)
    DBL_NEG1LSHL7_INT EQU (-128)
    DBL_NEG1LSHL8_INT EQU (-256)
    DBL_NEG1LSHL11_INT EQU (-2048)
    DBL_NEG1LSHL12_INT EQU (-4096)
    DBL_NEG1LSHL15_INT EQU (-32768)
    DBL_NEG1LSHL16_INT EQU (-65536)
    DBL_NEG1LSHL19_INT EQU (-524288)
    DBL_NEG1LSHL20_INT EQU (-1048576)
    DBL_NEG1LSHL23_INT EQU (-8388608)
    DBL_NEG1LSHL24_INT EQU (-16777216)
    DBL_NEG1LSHL27_INT EQU (-134217728)
    DBL_NEG1LSHL28_INT EQU (-268435456)
    DBL_NEG1LSHL31_INT EQU (-2147483648)
    DBL_NEG1LSHL32_INT EQU (-4294967296)
    DBL_NEG1LSHL35_INT EQU (-34359738368)
    DBL_NEG1LSHL36_INT EQU (-68719476736)
    DBL_NEG1LSHL39_INT EQU (-549755813888)
    DBL_NEG1LSHL40_INT EQU (-1099511627776)
    DBL_NEG1LSHL43_INT EQU (-8796093022208)
    DBL_NEG1LSHL44_INT EQU (-17592186044416)
    DBL_NEG1LSHL47_INT EQU (-140737488355328)
    DBL_NEG1LSHL48_INT EQU (-281474976710656)
    DBL_NEG1LSHL51_INT EQU (-2251799813685248)
    DBL_NEG1LSHL52_INT EQU (-4503599627370496)
    DBL_NEG1LSHL55_INT EQU (-36028797018963968)
    DBL_NEG1LSHL56_INT EQU (-72057594037927936)
    DBL_NEG1LSHL59_INT EQU (-576460752303423488)
    DBL_NEG1LSHL60_INT EQU (-1152921504606846976)
    DBL_NEG1LSHL63_INT EQU (-9223372036854775808)

    DBL_FALSE_INT EQU 0
    DBL_TRUE_INT EQU (-1)
    DBL_ERROR_INT EQU DBL_ERROR

    DBL_MAGIC_INT EQU 4503599627370496
    DBL_SIGN_INT EQU (-9223372036854775808)
    DBL_INVSIGN_INT EQU 9223372036854775807

    DBL_INF_INT EQU 9218868437227405312
    DBL_FIN_INT EQU (-9007199254740992)
    DBL_INVINF_INT EQU (-9218868437227405313)
    DBL_NEGINF_INT EQU (-4503599627370496)
    DBL_NAN_INT EQU 9223372036854775807
    DBL_QNAN_INT EQU 9221120237041090560
    DBL_NEGQNAN_INT EQU (-2251799813685248)
    DBL_NANTEST_INT EQU 4503599627370495
    DBL_ABS_INT EQU 9223372036854775807
    DBL_MAX_INT EQU 9218868437227405311
    DBL_MIN_INT EQU 4503599627370496
    DBL_NOFRACTION_INT EQU 4503599627370496
    DBL_MINDENORM_INT EQU 1
    DBL_DENORMLIMIT_INT EQU 4503599627370496
    DBL_MINNORMAL_INT EQU 4503599627370496
    DBL_MAXNORMAL_INT EQU 9218868437227405311

    DBL_DECDIG_INT EQU 17
    DBL_DIG_INT EQU 15
    DBL_NEGDECDIG_INT EQU (-17)
    DBL_NEGDIG_INT EQU (-15)
    DBL_EPS_INT EQU 4372995238176751616
    DBL_EPSILON_INT EQU 4372995238176751616
    DBL_NORMEPS_INT EQU 1914198181197535432
    DBL_GUARD_INT EQU 0
    DBL_MANTPOW2_INT EQU 4503599627370496
    DBL_MAXMANTPOW2_INT EQU 9218868437227405311
    DBL_MANTDIG_INT EQU 53
    DBL_MANT_INT EQU 52
    DBL_NEGMANTDIG_INT EQU (-53)
    DBL_NEGMANT_INT EQU (-52)
    DBL_MAXEXPO_INT EQU 1024
    DBL_EXPOSIGN_INT EQU 1024
    DBL_EXPO_INT EQU 1023
    DBL_NEGMAXEXPO_INT EQU (-1024)
    DBL_NEGEXPOSIGN_INT EQU (-1024)
    DBL_NEGEXPO_INT EQU (-1023)
    DBL_SUBNORMALEXPO_INT EQU (-1022)
    DBL_MINEXPO_INT EQU (-1021)
    DBL_MAXDECEXPO_INT EQU 308
    DBL_NEGMAXDECEXPO_INT EQU (-308)
    DBL_MINDECEXPO_INT EQU (-307)
    DBL_EXPOFIELD_INT EQU (-4503599627370496)
    DBL_MANTFIELD_INT EQU 4503599627370495
    DBL_NORM_INT EQU 0
    DBL_RADIX_INT EQU 2
    DBL_ROUNDS_INT EQU 1
    DBL_SUBDEC_INT EQU 10
    DBL_SQRTMAX_INT EQU 6855050911931917788
    DBL_SMALLNORMAL_INT EQU 4503599627370496

    DBL_HALFMINUSEPS_INT EQU 4602678819172646908
    DBL_TRUEINT_INT EQU 1

    DBL_BYTE_INT EQU 255
    DBL_BYTE_EVEN_INT EQU 71777214294589695
    DBL_BYTE_ODD_INT EQU (-71777214294589696)
    DBL_4LOW_INT EQU 1152921504606846975
    DBL_4HIGH_INT EQU (-16)
    DBL_FLIP4_INT EQU 8
    DBL_8LOW_INT EQU 72057594037927935
    DBL_8HIGH_INT EQU (-256)
    DBL_FLIP8_INT EQU 128
    DBL_12LOW_INT EQU 4503599627370495
    DBL_12HIGH_INT EQU (-4096)
    DBL_FLIP12_INT EQU 2048
    DBL_16LOW_INT EQU 281474976710655
    DBL_16HIGH_INT EQU (-65536)
    DBL_FLIP16_INT EQU 32768
    DBL_20LOW_INT EQU 17592186044415
    DBL_20HIGH_INT EQU (-1048576)
    DBL_FLIP20_INT EQU 524288
    DBL_24LOW_INT EQU 1099511627775
    DBL_24HIGH_INT EQU (-16777216)
    DBL_FLIP24_INT EQU 8388608
    DBL_28LOW_INT EQU 68719476735
    DBL_28HIGH_INT EQU (-268435456)
    DBL_FLIP28_INT EQU 134217728
    DBL_32LOW_INT EQU 4294967295
    DBL_32HIGH_INT EQU (-4294967296)
    DBL_FLIP32_INT EQU 2147483648
    DBL_36LOW_INT EQU 268435455
    DBL_36HIGH_INT EQU (-68719476736)
    DBL_FLIP36_INT EQU 34359738368
    DBL_40LOW_INT EQU 16777215
    DBL_40HIGH_INT EQU (-1099511627776)
    DBL_FLIP40_INT EQU 549755813888
    DBL_44LOW_INT EQU 1048575
    DBL_44HIGH_INT EQU (-17592186044416)
    DBL_FLIP44_INT EQU 8796093022208
    DBL_48LOW_INT EQU 65535
    DBL_48HIGH_INT EQU (-281474976710656)
    DBL_FLIP48_INT EQU 140737488355328
    DBL_52LOW_INT EQU 4095
    DBL_52HIGH_INT EQU (-4503599627370496)
    DBL_FLIP52_INT EQU 2251799813685248
    DBL_56LOW_INT EQU 255
    DBL_56HIGH_INT EQU (-72057594037927936)
    DBL_FLIP56_INT EQU 36028797018963968
    DBL_60LOW_INT EQU 15
    DBL_60HIGH_INT EQU (-1152921504606846976)
    DBL_FLIP60_INT EQU 576460752303423488
    DBL_64LOW_INT EQU 0
    DBL_64HIGH_INT EQU 0
    DBL_FLIP64_INT EQU (-9223372036854775808)

    DBL_0_INT EQU 0
    DBL_OD5_INT EQU 4602678819172646912
    DBL_1_INT EQU 4607182418800017408
    DBL_1D5_INT EQU 4609434218613702656
    DBL_2_INT EQU 4611686018427387904
    DBL_2D5_INT EQU 4612811918334230528
    DBL_3_INT EQU 4613937818241073152
    DBL_4_INT EQU 4616189618054758400
    DBL_5_INT EQU 4617315517961601024
    DBL_6_INT EQU 4618441417868443648
    DBL_7_INT EQU 4619567317775286272
    DBL_8_INT EQU 4620693217682128896
    DBL_9_INT EQU 4621256167635550208
    DBL_10_INT EQU 4621819117588971520
    DBL_20_INT EQU 4626322717216342016
    DBL_23_INT EQU 4627167142146473984
    DBL_23D5_INT EQU 4627307879634829312
    DBL_24_INT EQU 4627448617123184640
    DBL_24D5_INT EQU 4627589354611539968
    DBL_25_INT EQU 4627730092099895296

    DBL_128_INT EQU 4638707616191610880

    DBL_253_INT EQU 4643105662702714880

    DBL_NEG0_INT EQU (-9223372036854775808)
    DBL_NEG1_INT EQU (-4616189618054758400)

    DBL_NEG150_INT EQU (-4583890364477210624)

    DBL_BIN128_INT EQU DBL_128_INT
    DBL_BINNEG150_INT EQU DBL_NEG150_INT

    DBL_MAXRAND_INT EQU 32767

    DBL_MAXI8_INT EQU 127
    DBL_MINI8_INT EQU (-128)
    DBL_MAXU8_INT EQU 255

    DBL_MAXI16_INT EQU 32767
    DBL_MINI16_INT EQU (-32768)
    DBL_MAXU16_INT EQU 65535

    DBL_MAXI32_INT EQU 2147483647
    DBL_MINI32_INT EQU (-2147483648)
    DBL_MAXU32_INT EQU 4294967295

    DBL_MAXI64_INT EQU 9223372036854775807
    DBL_MINI64_INT EQU (-9223372036854775808)
    DBL_MAXU64_INT EQU 18446744073709551615

    DBL_MAXI8XU8_INT EQU 32768
    DBL_MINI8XU8_INT EQU (-32768)
    DBL_MAXI8XU16_INT EQU 8388608
    DBL_MINI8XU16_INT EQU (-8388608)

    DBL_MAXI16XU16_INT EQU 2147483648
    DBL_MINI16XU16_INT EQU (-2147483648)
    DBL_MAXI16XU32_INT EQU 140737488355328
    DBL_MINI16XU32_INT EQU (-140737488355328)

    DBL_MAXI32XU32_INT EQU (-9223372036854775808)
    DBL_MINI32XU32_INT EQU (-9223372036854775808)

    DBL_FIXUNSIGNED_INT EQU 2147483648
    DBL_FIXUNSIGNED32_INT EQU 2147483648
    DBL_FIXMAXI32_INT EQU 2147483520
    DBL_FIXMAXU32_INT EQU 4294967040

    DBL_FIXUNSIGNED64_INT EQU (-9223372036854775808)
    DBL_FIXMAXI64_INT EQU 9223372036854773760
    DBL_FIXMAXU64_INT EQU (-4096)

   ;/*double*/
    DBL_1LSHL3 EQU 8.0
    DBL_1LSHL4 EQU 16.0
    DBL_1LSHL7 EQU 128.0
    DBL_1LSHL8 EQU 256.0
    DBL_1LSHL11 EQU 2048.0
    DBL_1LSHL12 EQU 4096.0
    DBL_1LSHL15 EQU 32768.0
    DBL_1LSHL16 EQU 65536.0
    DBL_1LSHL19 EQU 524288.0
    DBL_1LSHL20 EQU 1048576.0
    DBL_1LSHL23 EQU 8388608.0
    DBL_1LSHL24 EQU 16777216.0
    DBL_1LSHL27 EQU 134217728.0
    DBL_1LSHL28 EQU 268435456.0
    DBL_1LSHL31 EQU 2147483648.0
    DBL_1LSHL32 EQU 4294967296.0
    DBL_1LSHL35 EQU 34359738368.0
    DBL_1LSHL36 EQU 68719476736.0
    DBL_1LSHL39 EQU 549755813888.0
    DBL_1LSHL40 EQU 1099511627776.0
    DBL_1LSHL43 EQU 8796093022208.0
    DBL_1LSHL44 EQU 17592186044416.0
    DBL_1LSHL47 EQU 140737488355328.0
    DBL_1LSHL48 EQU 281474976710656.0
    DBL_1LSHL51 EQU 2251799813685248.0
    DBL_1LSHL52 EQU 4503599627370496.0
    DBL_1LSHL55 EQU 36028797018963968.0
    DBL_1LSHL56 EQU 72057594037927936.0
    DBL_1LSHL59 EQU 576460752303423488.0
    DBL_1LSHL60 EQU 1152921504606846976.0
    DBL_1LSHL63 EQU (-9223372036854775808.0)

    DBL_NEG1LSHL3 EQU (-8.0)
    DBL_NEG1LSHL4 EQU (-16.0)
    DBL_NEG1LSHL7 EQU (-128.0)
    DBL_NEG1LSHL8 EQU (-256.0)
    DBL_NEG1LSHL11 EQU (-2048.0)
    DBL_NEG1LSHL12 EQU (-4096.0)
    DBL_NEG1LSHL15 EQU (-32768.0)
    DBL_NEG1LSHL16 EQU (-65536.0)
    DBL_NEG1LSHL19 EQU (-524288.0)
    DBL_NEG1LSHL20 EQU (-1048576.0)
    DBL_NEG1LSHL23 EQU (-8388608.0)
    DBL_NEG1LSHL24 EQU (-16777216.0)
    DBL_NEG1LSHL27 EQU (-134217728.0)
    DBL_NEG1LSHL28 EQU (-268435456.0)
    DBL_NEG1LSHL31 EQU (-2147483648.0)
    DBL_NEG1LSHL32 EQU (-4294967296.0)
    DBL_NEG1LSHL35 EQU (-34359738368.0)
    DBL_NEG1LSHL36 EQU (-68719476736.0)
    DBL_NEG1LSHL39 EQU (-549755813888.0)
    DBL_NEG1LSHL40 EQU (-1099511627776.0)
    DBL_NEG1LSHL43 EQU (-8796093022208.0)
    DBL_NEG1LSHL44 EQU (-17592186044416.0)
    DBL_NEG1LSHL47 EQU (-140737488355328.0)
    DBL_NEG1LSHL48 EQU (-281474976710656.0)
    DBL_NEG1LSHL51 EQU (-2251799813685248.0)
    DBL_NEG1LSHL52 EQU (-4503599627370496.0)
    DBL_NEG1LSHL55 EQU (-36028797018963968.0)
    DBL_NEG1LSHL56 EQU (-72057594037927936.0)
    DBL_NEG1LSHL59 EQU (-576460752303423488.0)
    DBL_NEG1LSHL60 EQU (-1152921504606846976.0)
    DBL_NEG1LSHL63 EQU (-9223372036854775808.0)

    DBL_FALSE EQU DBL_FALSE_MSK
    DBL_TRUE EQU DBL_TRUE_MSK

    DBL_MAGIC EQU DBL_MAGIC_MSK
    DBL_SIGN EQU DBL_SIGN_MSK
    DBL_INVSIGN EQU DBL_INVSIGN_MSK

    DBL_INF EQU DBL_INF_MSK
    DBL_FIN EQU DBL_FIN_MSK
    DBL_INVINF EQU DBL_INVINF_MSK
    DBL_NEGINF EQU DBL_NEGINF_MSK
    DBL_NAN EQU DBL_NAN_MSK
    DBL_QNAN EQU DBL_QNAN_MSK
    DBL_NEGQNAN EQU DBL_NEGQNAN_MSK
    DBL_NANTEST EQU DBL_NANTEST_MSK
    DBL_ABS EQU DBL_ABS_MSK
    DBL_MIN EQU (2.2250738585072014e-0308)
    DBL_MAX EQU (1.7976931348623158e+0308)
    DBL_NOFRACTION EQU 4503599627370496.0
    ;//DBL_MINDENORM EQU (5.0e-0324)
    DBL_MINDENORM EQU 0x0000000000000001
    DBL_DENORMLIMIT EQU (2.2250738585072014e-0308)
    DBL_MINNORMAL EQU (2.2250738585072014e-0308)
    DBL_MAXNORMAL EQU (1.7976931348623158e+0308)

    DBL_DECDIG EQU 17.0
    DBL_DIG EQU 15.0
    DBL_NEGDECDIG EQU (-17.0)
    DBL_NEGDIG EQU (-15.0)
    DBL_EPS EQU (2.2204460492503131e-016)
    DBL_EPSILON EQU (2.2204460492503131e-016)
    DBL_NORMEPS EQU (1.0e-0180)
    DBL_GUARD EQU 0.0
    DBL_MANTPOW2 EQU (2.2250738585072014e-0308)
    DBL_MAXMANTPOW2 EQU (1.7976931348623158e+0308)
    DBL_MANTDIG EQU 53.0
    DBL_MANT EQU 52.0
    DBL_NEGMANTDIG EQU (-53.0)
    DBL_NEGMANT EQU (-52.0)
    DBL_MAXEXPO EQU 1024.0
    DBL_EXPOSIGN EQU 1024.0
    DBL_EXPO EQU 1023.0
    DBL_NEGMAXEXPO EQU (-1024.0)
    DBL_NEGEXPOSIGN EQU (-1024.0)
    DBL_NEGEXPO EQU (-1023.0)
    DBL_SUBNORMALEXPO EQU (-1022.0)
    DBL_MINEXPO EQU (-1021.0)
    DBL_MAXDECEXPO EQU 308.0
    DBL_NEGMAXDECEXPO EQU (-308.0)
    DBL_MINDECEXPO EQU (-307.0)
    DBL_EXPOFIELD EQU (-4503599627370496.0)
    DBL_MANTFIELD EQU 4503599627370495.0
    DBL_NORM EQU 0.0
    DBL_RADIX EQU 2.0
    DBL_ROUNDS EQU 1.0
    DBL_SUBDEC EQU 10.0
    DBL_SQRTMAX EQU (1.8446726e+0150)
    DBL_SMALLNORMAL EQU (2.2250738585072014e-0308)

    DBL_HALFMINUSEPS EQU 0.49999999999999977795539507496869
    DBL_TRUEINT EQU 1.0

    DBL_BYTE EQU 255.0
    DBL_BYTE_EVEN EQU 71777214294589695.0
    DBL_BYTE_ODD EQU (-71777214294589696.0)
    DBL_4LOW EQU 1152921504606846975.0
    DBL_4HIGH EQU (-16.0)
    DBL_FLIP4 EQU 8.0
    DBL_8LOW EQU 72057594037927935.0
    DBL_8HIGH EQU (-256.0)
    DBL_FLIP8 EQU 128.0
    DBL_12LOW EQU 4503599627370495.0
    DBL_12HIGH EQU (-4096.0)
    DBL_FLIP12 EQU 2048.0
    DBL_16LOW EQU 281474976710655.0
    DBL_16HIGH EQU (-65536.0)
    DBL_FLIP16 EQU 32768.0
    DBL_20LOW EQU 17592186044415.0
    DBL_20HIGH EQU (-1048576.0)
    DBL_FLIP20 EQU 524288.0
    DBL_24LOW EQU 1099511627775.0
    DBL_24HIGH EQU (-16777216.0)
    DBL_FLIP24 EQU 8388608.0
    DBL_28LOW EQU 68719476735.0
    DBL_28HIGH EQU (-268435456.0)
    DBL_FLIP28 EQU 134217728.0
    DBL_32LOW EQU 4294967295.0
    DBL_32HIGH EQU (-4294967296.0)
    DBL_FLIP32 EQU 2147483648.0
    DBL_36LOW EQU 268435455.0
    DBL_36HIGH EQU (-68719476736.0)
    DBL_FLIP36 EQU 34359738368.0
    DBL_40LOW EQU 16777215.0
    DBL_40HIGH EQU (-1099511627776.0)
    DBL_FLIP40 EQU 549755813888.0
    DBL_44LOW EQU 1048575.0
    DBL_44HIGH EQU (-17592186044416.0)
    DBL_FLIP44 EQU 8796093022208.0
    DBL_48LOW EQU 65535.0
    DBL_48HIGH EQU (-281474976710656.0)
    DBL_FLIP48 EQU 140737488355328.0
    DBL_52LOW EQU 4095.0
    DBL_52HIGH EQU (-4503599627370496.0)
    DBL_FLIP52 EQU 2251799813685248.0
    DBL_56LOW EQU 255.0
    DBL_56HIGH EQU (-72057594037927936.0)
    DBL_FLIP56 EQU 36028797018963968.0
    DBL_60LOW EQU 15.0
    DBL_60HIGH EQU (-1152921504606846976.0)
    DBL_FLIP60 EQU 576460752303423488.0
    DBL_64LOW EQU 0.0
    DBL_64HIGH EQU 0.0
    DBL_FLIP64 EQU (-9223372036854775808.0)
    
    DBL_0 EQU 0.0
    DBL_0D0001 EQU 0.0001
    DBL_0D0002 EQU 0.0002
    DBL_0D0003 EQU 0.0003
    DBL_0D0004 EQU 0.0004
    DBL_0D0005 EQU 0.0005
    DBL_0D0006 EQU 0.0006
    DBL_0D0007 EQU 0.0007
    DBL_0D0008 EQU 0.0008
    DBL_0D0009 EQU 0.0009
    DBL_0D001 EQU 0.001
    DBL_0D002 EQU 0.002
    DBL_0D003 EQU 0.003
    DBL_0D004 EQU 0.004
    DBL_0D005 EQU 0.005
    DBL_0D006 EQU 0.006
    DBL_0D007 EQU 0.007
    DBL_0D008 EQU 0.008
    DBL_0D009 EQU 0.009
    DBL_0D01 EQU 0.01
    DBL_0D02 EQU 0.02
    DBL_0D025 EQU 0.025
    DBL_0D03 EQU 0.03
    DBL_0D04 EQU 0.04
    DBL_0D05 EQU 0.05
    DBL_0D06 EQU 0.06
    DBL_0D07 EQU 0.07
    DBL_0D08 EQU 0.08
    DBL_0D09 EQU 0.09
    DBL_0D1 EQU 0.1
    DBL_0D2 EQU 0.2
    DBL_0D25 EQU 0.25
    DBL_0D3 EQU 0.3
    DBL_0D4 EQU 0.4
    DBL_0D5 EQU 0.5
    DBL_0D6 EQU 0.6
    DBL_0D7 EQU 0.7
    DBL_0D8 EQU 0.8
    DBL_0D9 EQU 0.9
    DBL_1 EQU 1.0
    DBL_1D25 EQU 1.25
    DBL_1D5 EQU 1.5
    DBL_2 EQU 2.0
    DBL_2D25 EQU 2.25
    DBL_2D5 EQU 2.5
    DBL_3 EQU 3.0
    DBL_3D25 EQU 3.25
    DBL_3D5 EQU 3.5
    DBL_4 EQU 4.0
    DBL_4D25 EQU 4.25
    DBL_4D5 EQU 4.5
    DBL_5 EQU 5.0
    DBL_5D25 EQU 5.25
    DBL_5D5 EQU 5.5
    DBL_6 EQU 6.0
    DBL_6D25 EQU 6.25
    DBL_6D5 EQU 6.5
    DBL_7 EQU 7.0
    DBL_7D25 EQU 7.25
    DBL_7D5 EQU 7.5
    DBL_8 EQU 8.0
    DBL_8D25 EQU 8.25
    DBL_8D5 EQU 8.5
    DBL_9 EQU 9.0
    DBL_9D25 EQU 9.25
    DBL_9D5 EQU 9.5
    DBL_10 EQU 10.0
    DBL_11 EQU 11.0
    DBL_12 EQU 12.0
    DBL_13 EQU 13.0
    DBL_14 EQU 14.0
    DBL_15 EQU 15.0
    DBL_16 EQU 16.0
    DBL_17 EQU 17.0
    DBL_18 EQU 18.0
    DBL_19 EQU 19.0
    DBL_20 EQU 20.0
    DBL_21 EQU 21.0
    DBL_22 EQU 22.0
    DBL_23 EQU 23.0
    DBL_24 EQU 24.0
    DBL_24D5 EQU 24.5
    DBL_25 EQU 25.0
    DBL_26 EQU 26.0
    DBL_27 EQU 27.0
    DBL_28 EQU 28.0
    DBL_29 EQU 29.0
    DBL_30 EQU 30.0
    DBL_31 EQU 31.0
    DBL_32 EQU 32.0
    DBL_33 EQU 33.0
    DBL_34 EQU 34.0
    DBL_35 EQU 35.0
    DBL_36 EQU 36.0
    DBL_37 EQU 37.0
    DBL_38 EQU 38.0
    DBL_39 EQU 39.0
    DBL_40 EQU 40.0
    DBL_41 EQU 41.0
    DBL_42 EQU 42.0
    DBL_43 EQU 43.0
    DBL_44 EQU 44.0
    DBL_45 EQU 45.0
    DBL_46 EQU 46.0
    DBL_47 EQU 47.0
    DBL_48 EQU 48.0
    DBL_49 EQU 49.0
    DBL_50 EQU 50.0
    DBL_51 EQU 51.0
    DBL_52 EQU 52.0
    DBL_53 EQU 53.0
    DBL_54 EQU 54.0
    DBL_55 EQU 55.0
    DBL_56 EQU 56.0
    DBL_57 EQU 57.0
    DBL_58 EQU 58.0
    DBL_59 EQU 59.0
    DBL_60 EQU 60.0
    DBL_61 EQU 61.0
    DBL_62 EQU 62.0
    DBL_63 EQU 63.0
    DBL_64 EQU 64.0
    DBL_65 EQU 65.0
    DBL_66 EQU 66.0
    DBL_67 EQU 67.0
    DBL_68 EQU 68.0
    DBL_69 EQU 69.0
    DBL_70 EQU 70.0
    DBL_71 EQU 71.0
    DBL_72 EQU 72.0
    DBL_73 EQU 73.0
    DBL_74 EQU 74.0
    DBL_75 EQU 75.0
    DBL_76 EQU 76.0
    DBL_77 EQU 77.0
    DBL_78 EQU 78.0
    DBL_79 EQU 79.0
    DBL_80 EQU 80.0
    DBL_81 EQU 81.0
    DBL_82 EQU 82.0
    DBL_83 EQU 83.0
    DBL_84 EQU 84.0
    DBL_85 EQU 85.0
    DBL_86 EQU 86.0
    DBL_87 EQU 87.0
    DBL_88 EQU 88.0
    DBL_89 EQU 89.0
    DBL_90 EQU 90.0
    DBL_91 EQU 91.0
    DBL_92 EQU 92.0
    DBL_93 EQU 93.0
    DBL_94 EQU 94.0
    DBL_95 EQU 95.0
    DBL_96 EQU 96.0
    DBL_97 EQU 97.0
    DBL_98 EQU 98.0
    DBL_99 EQU 99.0
    DBL_100 EQU 100.0
    DBL_125 EQU 125.0
    DBL_126 EQU 126.0
    DBL_127 EQU 127.0
    DBL_128 EQU 128.0
    DBL_140 EQU 140.0
    DBL_145 EQU 145.0
    DBL_150 EQU 150.0
    DBL_180 EQU 180.0
    DBL_253 EQU 253.0
    DBL_254 EQU 254.0
    DBL_255 EQU 255.0
    DBL_256 EQU 256.0
    DBL_360 EQU 360.0
    DBL_511 EQU 511.0
    DBL_512 EQU 512.0
    DBL_513 EQU 513.0
    DBL_1023 EQU 1023.0
    DBL_1024 EQU 1024.0
    DBL_1025 EQU 1025.0

    DBL_32767 EQU 32767.0
    DBL_32768 EQU 32768.0
    DBL_65535 EQU 65535.0
    DBL_65536 EQU 65536.0
    DBL_2147483647 EQU 2147483647.0
    DBL_2147483648 EQU 2147483648.0
    DBL_4294967295 EQU 4294967295.0
    DBL_4294967296 EQU 4294967296.0

    DBL_NEG0 EQU (-0.0)
    DBL_NEG0D0001 EQU (-0.0001)
    DBL_NEG0D0002 EQU (-0.0002)
    DBL_NEG0D0003 EQU (-0.0003)
    DBL_NEG0D0004 EQU (-0.0004)
    DBL_NEG0D0005 EQU (-0.0005)
    DBL_NEG0D0006 EQU (-0.0006)
    DBL_NEG0D0007 EQU (-0.0007)
    DBL_NEG0D0008 EQU (-0.0008)
    DBL_NEG0D0009 EQU (-0.0009)
    DBL_NEG0D001 EQU (-0.001)
    DBL_NEG0D002 EQU (-0.002)
    DBL_NEG0D003 EQU (-0.003)
    DBL_NEG0D004 EQU (-0.004)
    DBL_NEG0D005 EQU (-0.005)
    DBL_NEG0D006 EQU (-0.006)
    DBL_NEG0D007 EQU (-0.007)
    DBL_NEG0D008 EQU (-0.008)
    DBL_NEG0D009 EQU (-0.009)
    DBL_NEG0D01 EQU (-0.01)
    DBL_NEG0D02 EQU (-0.02)
    DBL_NEG0D025 EQU (-0.025)
    DBL_NEG0D03 EQU (-0.03)
    DBL_NEG0D04 EQU (-0.04)
    DBL_NEG0D05 EQU (-0.05)
    DBL_NEG0D06 EQU (-0.06)
    DBL_NEG0D07 EQU (-0.07)
    DBL_NEG0D08 EQU (-0.08)
    DBL_NEG0D09 EQU (-0.09)
    DBL_NEG0D1 EQU (-0.1)
    DBL_NEG0D2 EQU (-0.2)
    DBL_NEG0D25 EQU (-0.25)
    DBL_NEG0D3 EQU (-0.3)
    DBL_NEG0D4 EQU (-0.4)
    DBL_NEG0D5 EQU (-0.5)
    DBL_NEG0D6 EQU (-0.6)
    DBL_NEG0D7 EQU (-0.7)
    DBL_NEG0D8 EQU (-0.8)
    DBL_NEG0D9 EQU (-0.9)
    DBL_NEG1 EQU (-1.0)
    DBL_NEG1D25 EQU (-1.25)
    DBL_NEG1D5 EQU (-1.5)
    DBL_NEG2 EQU (-2.0)
    DBL_NEG2D25 EQU (-2.25)
    DBL_NEG2D5 EQU (-2.5)
    DBL_NEG3 EQU (-3.0)
    DBL_NEG3D25 EQU (-3.25)
    DBL_NEG3D5 EQU (-3.5)
    DBL_NEG4 EQU (-4.0)
    DBL_NEG4D25 EQU (-4.25)
    DBL_NEG4D5 EQU (-4.5)
    DBL_NEG5 EQU (-5.0)
    DBL_NEG5D25 EQU (-5.25)
    DBL_NEG5D5 EQU (-5.5)
    DBL_NEG6 EQU (-6.0)
    DBL_NEG6D25 EQU (-6.25)
    DBL_NEG6D5 EQU (-6.5)
    DBL_NEG7 EQU (-7.0)
    DBL_NEG7D25 EQU (-7.25)
    DBL_NEG7D5 EQU (-7.5)
    DBL_NEG8 EQU (-8.0)
    DBL_NEG8D25 EQU (-8.25)
    DBL_NEG8D5 EQU (-8.5)
    DBL_NEG9 EQU (-9.0)
    DBL_NEG9D25 EQU (-9.25)
    DBL_NEG9D5 EQU (-9.5)
    DBL_NEG10 EQU (-10.0)
    DBL_NEG11 EQU (-11.0)
    DBL_NEG12 EQU (-12.0)
    DBL_NEG13 EQU (-13.0)
    DBL_NEG14 EQU (-14.0)
    DBL_NEG15 EQU (-15.0)
    DBL_NEG16 EQU (-16.0)
    DBL_NEG17 EQU (-17.0)
    DBL_NEG18 EQU (-18.0)
    DBL_NEG19 EQU (-19.0)
    DBL_NEG20 EQU (-20.0)
    DBL_NEG21 EQU (-21.0)
    DBL_NEG22 EQU (-22.0)
    DBL_NEG23 EQU (-23.0)
    DBL_NEG24 EQU (-24.0)
    DBL_NEG24D5 EQU (-24.5)
    DBL_NEG25 EQU (-25.0)
    DBL_NEG26 EQU (-26.0)
    DBL_NEG27 EQU (-27.0)
    DBL_NEG28 EQU (-28.0)
    DBL_NEG29 EQU (-29.0)
    DBL_NEG30 EQU (-30.0)
    DBL_NEG31 EQU (-31.0)
    DBL_NEG32 EQU (-32.0)
    DBL_NEG33 EQU (-33.0)
    DBL_NEG34 EQU (-34.0)
    DBL_NEG35 EQU (-35.0)
    DBL_NEG36 EQU (-36.0)
    DBL_NEG37 EQU (-37.0)
    DBL_NEG38 EQU (-38.0)
    DBL_NEG39 EQU (-39.0)
    DBL_NEG40 EQU (-40.0)
    DBL_NEG41 EQU (-41.0)
    DBL_NEG42 EQU (-42.0)
    DBL_NEG43 EQU (-43.0)
    DBL_NEG44 EQU (-44.0)
    DBL_NEG45 EQU (-45.0)
    DBL_NEG46 EQU (-46.0)
    DBL_NEG47 EQU (-47.0)
    DBL_NEG48 EQU (-48.0)
    DBL_NEG49 EQU (-49.0)
    DBL_NEG50 EQU (-50.0)
    DBL_NEG51 EQU (-51.0)
    DBL_NEG52 EQU (-52.0)
    DBL_NEG53 EQU (-53.0)
    DBL_NEG54 EQU (-54.0)
    DBL_NEG55 EQU (-55.0)
    DBL_NEG56 EQU (-56.0)
    DBL_NEG57 EQU (-57.0)
    DBL_NEG58 EQU (-58.0)
    DBL_NEG59 EQU (-59.0)
    DBL_NEG60 EQU (-60.0)
    DBL_NEG61 EQU (-61.0)
    DBL_NEG62 EQU (-62.0)
    DBL_NEG63 EQU (-63.0)
    DBL_NEG64 EQU (-64.0)
    DBL_NEG65 EQU (-65.0)
    DBL_NEG66 EQU (-66.0)
    DBL_NEG67 EQU (-67.0)
    DBL_NEG68 EQU (-68.0)
    DBL_NEG69 EQU (-69.0)
    DBL_NEG70 EQU (-70.0)
    DBL_NEG71 EQU (-71.0)
    DBL_NEG72 EQU (-72.0)
    DBL_NEG73 EQU (-73.0)
    DBL_NEG74 EQU (-74.0)
    DBL_NEG75 EQU (-75.0)
    DBL_NEG76 EQU (-76.0)
    DBL_NEG77 EQU (-77.0)
    DBL_NEG78 EQU (-78.0)
    DBL_NEG79 EQU (-79.0)
    DBL_NEG80 EQU (-80.0)
    DBL_NEG81 EQU (-81.0)
    DBL_NEG82 EQU (-82.0)
    DBL_NEG83 EQU (-83.0)
    DBL_NEG84 EQU (-84.0)
    DBL_NEG85 EQU (-85.0)
    DBL_NEG86 EQU (-86.0)
    DBL_NEG87 EQU (-87.0)
    DBL_NEG88 EQU (-88.0)
    DBL_NEG89 EQU (-89.0)
    DBL_NEG90 EQU (-90.0)
    DBL_NEG91 EQU (-91.0)
    DBL_NEG92 EQU (-92.0)
    DBL_NEG93 EQU (-93.0)
    DBL_NEG94 EQU (-94.0)
    DBL_NEG95 EQU (-95.0)
    DBL_NEG96 EQU (-96.0)
    DBL_NEG97 EQU (-97.0)
    DBL_NEG98 EQU (-98.0)
    DBL_NEG99 EQU (-99.0)
    DBL_NEG100 EQU (-100.0)
    DBL_NEG125 EQU (-125.0)
    DBL_NEG126 EQU (-126.0)
    DBL_NEG127 EQU (-127.0)
    DBL_NEG128 EQU (-128.0)
    DBL_NEG140 EQU (-140.0)
    DBL_NEG145 EQU (-145.0)
    DBL_NEG150 EQU (-150.0)
    DBL_NEG180 EQU (-180.0)
    DBL_NEG253 EQU (-253.0)
    DBL_NEG254 EQU (-254.0)
    DBL_NEG255 EQU (-255.0)
    DBL_NEG256 EQU (-256.0)
    DBL_NEG360 EQU (-360.0)
    DBL_NEG511 EQU (-511.0)
    DBL_NEG512 EQU (-512.0)
    DBL_NEG513 EQU (-513.0)
    DBL_NEG1023 EQU (-1023.0)
    DBL_NEG1024 EQU (-1024.0)
    DBL_NEG1025 EQU (-1025.0)

    DBL_NEG32767 EQU (-32767.0)
    DBL_NEG32768 EQU (-32768.0)
    DBL_NEG65535 EQU (-65535.0)
    DBL_NEG65536 EQU (-65536.0)
    DBL_NEG2147483647 EQU (-2147483647.0)
    DBL_NEG2147483648 EQU (-2147483648.0)
    DBL_NEG4294967295 EQU (-4294967295.0)
    DBL_NEG4294967296 EQU (-4294967296.0)

    DBL_BIN128 EQU DBL_128_MSK
    DBL_BINNEG150 EQU DBL_NEG150_MSK

    DBL_MAXRAND EQU 32767.0

    DBL_MAXI8 EQU 127.0
    DBL_MINI8 EQU (-128.0)
    DBL_MAXU8 EQU 255.0

    DBL_MAXI16 EQU 32767.0
    DBL_MINI16 EQU (-32768.0)
    DBL_MAXU16 EQU 65535.0

    DBL_MAXI32 EQU 2147483647.0
    DBL_MINI32 EQU (-2147483648.0)
    DBL_MAXU32 EQU 4294967295.0

    DBL_MAXI64 EQU 9223372036854775807.0
    DBL_MINI64 EQU (-9223372036854775808.0)
    DBL_MAXU64 EQU 18446744073709551615.0

    DBL_MAXI8XU8 EQU 32768.0
    DBL_MINI8XU8 EQU (-32768.0)
    DBL_MAXI8XU16 EQU 8388608.0
    DBL_MINI8XU16 EQU (-8388608.0)

    DBL_MAXI16XU16 EQU 2147483648.0
    DBL_MINI16XU16 EQU (-2147483648.0)
    DBL_MAXI16XU32 EQU 140737488355328.0
    DBL_MINI16XU32 EQU (-140737488355328.0)

    DBL_MAXI32XU32 EQU (-9223372036854775808.0)
    DBL_MINI32XU32 EQU (-9223372036854775808.0)

    DBL_FIXUNSIGNED EQU (-2147483648.0)
    DBL_FIXUNSIGNED32 EQU (-2147483648.0)
    DBL_FIXMAXI32 EQU 2147483520.0
    DBL_FIXMAXU32 EQU (-256.0)

    DBL_FIXUNSIGNED64 EQU (-9223372036854775808.0)
    DBL_FIXMAXI64 EQU 9223372036854773760.0
    DBL_FIXMAXU64 EQU (-4096.0)

    DBL_RCPI16 EQU (3.0518509475997192297128208258309e-05)
    DBL_RCPU16 EQU 0.0000152587890625
    DBL_RCPI16XU16 EQU (4.656754985961485641041291543321e-010)

    DBL_MG EQU 1024.0
    DBL_NEGMG EQU (-1024.0)
    DBL_HALFMG EQU 512.0
    DBL_NEGHALFMG EQU (-512.0)
    DBL_MGDIV4 EQU 256.0
    DBL_NEGMGDIV4 EQU (-256.0)
    DBL_HALFMGXMG EQU 524288.0
    DBL_HALFMGXSQRMG EQU 536870912.0
    DBL_HALFMGXCUBEMG EQU 549755813888.0
    DBL_NEGHALFMGXMG EQU (-524288.0)
    DBL_NEGHALFMGXSQRMG EQU (-536870912.0)
    DBL_NEGHALFMGXCUBEMG EQU (-549755813888.0)
    DBL_SQRMG EQU 1048576.0
    DBL_CUBEMG EQU 1073741824.0
    DBL_SQRTMG EQU 32.0
    DBL_CBRTMG EQU 10.079368399158985318137684858226
    DBL_RCPMG EQU 0.0009765625
    DBL_RCPSQRMG EQU 0.00000095367431640625
    DBL_RCPCUBEMG EQU 0.000000000931322574615478515625
    DBL_RCPSQRTMG EQU 0.03125
    DBL_RCPCBRTMG EQU 0.09921256574801246717198160245452

    DBL_2MG EQU 2048.0
    DBL_NEG2MG EQU (-2048.0)
    DBL_SQR2MG EQU 4194304.0
    DBL_CUBE2MG EQU 8589934592.0
    DBL_SQRT2MG EQU 45.25483399593904156165403917471
    DBL_CBRT2MG EQU 12.699208415745595798013645114178
    DBL_4MG EQU 4096.0
    DBL_NEG4MG EQU (-4096.0)
    DBL_SQR4MG EQU 16777216.0
    DBL_CUBE4MG EQU 68719476736.0
    DBL_SQRT4MG EQU 64.0
    DBL_CBRT4MG EQU 16.0
    DBL_RCP2MG EQU 0.00048828125
    DBL_RCP4MG EQU 0.000244140625

    DBL_E EQU 2.71828182845904523536
    DBL_EXP EQU 2.71828182845904523536
    DBL_LOGE EQU 0.43429448190325182765108299019028
    DBL_LOGEHIGH EQU 0.43429448190325182765108299019028
    DBL_LOGELOW EQU (1.09831965021676510e-017)
    DBL_LOG2E EQU 1.44269504088896340736
    DBL_LOG2EHIGH EQU 1.44269504088896340736
    DBL_LOG2ELOW EQU (2.0355273740931033e-017)
    DBL_LOG10E EQU 0.43429448190325182765108299019028
    DBL_RCPLOG2E EQU 0.69314718055994530941719593421853
    DBL_RCPLOG10E EQU 2.3025850929940456840186749696447
    DBL_LOG2T EQU 3.3219280948873622
    DBL_LOG2 EQU 0.30102999566398119521373889472449
    DBL_LOG2HIGH EQU 0.30102999566398119521373889472449
    DBL_LOG2LOW EQU (-2.8037281277851704e-018)
    DBL_LN2 EQU 0.69314718055994530941723212145818
    DBL_LN2HIGH EQU 0.69314718055994530941723212145818
    DBL_LN2LOW EQU (2.3190468138462996e-017)
    DBL_1DIVLN2 EQU 1.4426950408889634073599246810019
    DBL_2DIVLN2 EQU 2.8853900817779268147198493620038
    DBL_LNT EQU 2.3025850929940459
    DBL_LNTHIGH EQU (2.3025850929940459e+0)
    DBL_LNTLOW EQU (-2.1707562233822494e-016)
    DBL_LN10 EQU 2.302585092994045684018
    DBL_SQRT2 EQU 1.414213562373095048801
    DBL_RCPSQRT2 EQU 0.707106781186547524400
    DBL_SQRT2DIV2 EQU 0.707106781186547524400
    DBL_SQRT2DIV2HIGH EQU 0.707106781186547524400
    DBL_SQRT2DIV2LOW EQU (1.210161749e-08)
    DBL_SQRTHALF EQU 0.707106781186547524401
    DBL_SQRTHALFHIGH EQU 0.707106781186547524401
    DBL_SQRTHALFLOW EQU (-4.8336466567264567e-017)
    DBL_POW2 EQU 7.389056098930650227230
    DBL_RCPPOW2 EQU 0.135335283236612691893
    DBL_CBRT2 EQU 1.259921049894873164767
    DBL_RCPCBRT2 EQU 0.793700525984099737375
    DBL_1DIV3 EQU 0.333333333333333333333
    DBL_1DIV7 EQU 0.142857142857142857142
    DBL_1DIV9 EQU 0.111111111111111111111
    DBL_2DIV3 EQU 0.666666666666666666667
    DBL_2DIV7 EQU 0.285714285714285714285
    DBL_2DIV9 EQU 0.222222222222222222222
    DBL_4DIV3 EQU 1.333333333333333333333
    DBL_4DIV7 EQU 0.571428571428571428571
    DBL_4DIV9 EQU 0.444444444444444444444

    DBL_PI EQU 3.1415926535897932384626433832795
    DBL_PIHIGH EQU 3.1415926535897932384626433832795
    DBL_PILOW EQU (1.2246467991473532e-016)
    DBL_HALFPI EQU 1.5707963267948966192313216916398
    DBL_2PI EQU 6.283185307179586476925286766559
    DBL_NEGPI EQU (-3.1415926535897932384626433832795)
    DBL_NEGHALFPI EQU (-1.5707963267948966192313216916398)
    DBL_NEG2PI EQU (-6.283185307179586476925286766559)
    DBL_RCPPI EQU 0.31830988618379067153776752674503
    DBL_INVPI EQU 0.31830988618379067153776752674503
    DBL_RCP2PI EQU 0.15915494309189533576888376337251
    DBL_INV2PI EQU 0.15915494309189533576888376337251
    DBL_PIDIV2 EQU 1.5707963267948966192313216916398
    DBL_PIDIV2HIGH EQU 1.5707963267948966192313216916398
    DBL_PIDIV2LOW EQU (6.1232339957367660e-017)
    DBL_PIDIV4 EQU 0.78539816339744830961566084581988
    DBL_PIDIV4HIGH EQU 0.78539816339744830961566084581988
    DBL_PIDIV4LOW EQU (3.0616169978683830e-017)
    DBL_PIX3DIV4 EQU 2.3561944901923449288469825374596
    DBL_SQRTPI EQU 1.7724538509055160272981674833411
    DBL_SQRT2PI EQU 2.506628274631000502415765284811
    DBL_SQRT2PIHIGH EQU 2.506628274631000502415765284811
    DBL_SQRT2PILOW EQU (-1.8328579980459167e-016)
    DBL_RCPSQRTPI EQU 0.56418958354775628694807945156077
    DBL_RCPSQRT2PI EQU 0.39894228040143267793994605993438
    DBL_SQRTPIDIV2 EQU 0.88622692545275801364908374167057
    DBL_SQRTPIDIV2HIGH EQU 0.88622692545275801364908374167057
    DBL_SQRT2PIDIV2 EQU 1.2533141373155002512078826424055
    DBL_SQRT2PIDIV2HIGH EQU 1.2533141373155002512078826424055
    DBL_SQRT2PIDIV2LOW EQU (-9.1642899902295834e-017)
    DBL_2DIVPI EQU 0.63661977236758134307553505349006
    DBL_2DIV2PI EQU 0.31830988618379067153776752674503
    DBL_2DIVSQRTPI EQU 1.1283791670955125738961589031216
    DBL_2DIVSQRT2PI EQU 0.79788456080286535587989211986878
    DBL_SQRT2DIVPI EQU 0.45015815807855303477759959550337
    DBL_LOGPI EQU 0.4971498726941338543512682882909
    DBL_LOG2PI EQU 0.4971498726941338543512682882909
    DBL_LNPI EQU 1.1447298858494001741434273513531
    DBL_LN2PI EQU 1.8378770664093454835606594728112
    DBL_POWPI EQU 23.140692632779269005729086367949
    DBL_RCPPOWPI EQU 0.04321391826377224977441773717173
    DBL_POW2PI EQU 535.49165552476473650304932958905
    DBL_RCPPOW2PI EQU 0.00186744273170798881443021293483
    DBL_CBRTPI EQU 1.4645918875615232630201425272638
    DBL_RCPCBRTPI EQU 0.68278406325529568146702083315816
    DBL_CBRT2PI EQU 1.845270148644028419096803879589
    DBL_RCPCBRT2PI EQU 0.54192607013928900874456136482964

    DBL_LN2X1024 EQU 709.78271289338399684324569237317
    DBL_LN2X1025 EQU 710.47586007394394215266292449463
    DBL_LN2X1075 EQU 745.13321910194120762352453056754
    DBL_LOG2X1024 EQU 308.25471555991674389886862819788
    DBL_LOG2X1075 EQU 323.60724533877978485476931182883

    DBL_POW2TOM126 EQU (1.175494351e-038)
    DBL_POW2TO126 EQU 8.507059173e37
    DBL_NORMHUGE EQU 3.402823466e38
    DBL_POW2TO23 EQU 8388608.0
    DBL_POW2TO24 EQU 16777216.0
    DBL_MAXI32POW2TO23 EQU 2139095039.0
    DBL_POW2TO31 EQU 2147483648.0
    DBL_POW2TO32 EQU 4294967296.0
    DBL_POW2TO52 EQU 4503599627370496.0
    DBL_POW2TO53 EQU 9007199254740992.0
    DBL_POW2TO54 EQU 18014398509481984.0
    DBL_POW2TOM54 EQU (5.5511151231257827e-017)
    DBL_POW2TO62 EQU 4611686018427387904.0
    DBL_MAXI64POW2TO52 EQU 9218868437227405311.0
    DBL_POW2TO63 EQU 9223372036854775808.0
    DBL_POW2TO64 EQU 18446744073709551616.0
    DBL_POW2TOM1022 EQU (2.22507385850720140e-0308)
    DBL_TRIGPLOSS EQU 2147483648.0

    DBL_DEGTORAD EQU 0.017453292519943295769
    DBL_RADTODEG EQU 57.29577951308232087679

    DBL_DEGTOGRAD EQU 1.111111111111111111111
    DBL_GRADTODEG EQU 0.9

    DBL_RADTOGRAD EQU 63.66197723675813430755
    DBL_GRADTORAD EQU 0.015707963267948966192

    ;/*/ Gravity 

    DBL_SUNGRAVITY EQU 274.13
    DBL_JUPITERGRAVITY EQU 25.95
    DBL_NEPTUNEGRAVITY EQU 14.07
    DBL_SATURNGRAVITY EQU 11.08
    DBL_URANUSGRAVITY EQU 10.67
    DBL_EARTHGRAVITY EQU 9.81
    DBL_VENUSGRAVITY EQU 8.87
    DBL_MARSGRAVITY EQU 3.77
    DBL_MERCURYGRAVITY EQU 3.59
    DBL_MOONGRAVITY EQU 1.62
    DBL_PLUTOGRAVITY EQU 0.42

    ;/*/ Length conversion

    DBL_KMTOINCH EQU 39370.08
    DBL_KMTOFEET EQU 3280.84
    DBL_KMTOYARDS EQU 1093.613
    DBL_KMTOMILES EQU 0.621371

    DBL_METOINCH EQU 39.37008
    DBL_METOFEET EQU 3.28084
    DBL_METOYARDS EQU 1.093613
    DBL_METOMILES EQU 0.000621371

    DBL_CMTOINCH EQU 0.3937008
    DBL_CMTOFEET EQU 0.0328084
    DBL_CMTOYARDS EQU 0.01093613
    DBL_CMTOMILES EQU 0.00000621371

    DBL_MILLTOINCH EQU 0.03937008
    DBL_MILLTOFEET EQU 0.00328084
    DBL_MILLTOYARDS EQU 0.001093613
    DBL_MILLTOMILES EQU 0.000000621371

    DBL_INCHTOMILL EQU 25.4
    DBL_INCHTOCM EQU 2.54
    DBL_INCHTOME EQU 0.0254
    DBL_INCHTOKM EQU 0.0000254
    DBL_INCHTOFEET EQU 0.083333
    DBL_INCHTOYARDS EQU 0.027778
    DBL_INCHTOMILES EQU 0.000016

    DBL_FEETTOMILL EQU 304.8
    DBL_FEETTOCM EQU 30.48
    DBL_FEETTOME EQU 0.3048
    DBL_FEETTOKM EQU 0.0003048
    DBL_FEETTOINCH EQU 12.0
    DBL_FEETTOYARDS EQU 0.333333
    DBL_FEETTOMILES EQU 0.000189

    DBL_YARDSTOMILL EQU 914.4
    DBL_YARDSTOCM EQU 91.44
    DBL_YARDSTOME EQU 0.9144
    DBL_YARDSTOKM EQU 0.0009144
    DBL_YARDSTOINCH EQU 36.0
    DBL_YARDSTOFEET EQU 3.0
    DBL_YARDSTOMILES EQU 0.000568

    DBL_MILESTOMILL EQU 1609344.0
    DBL_MILESTOCM EQU 160934.4
    DBL_MILESTOME EQU 1609.344
    DBL_MILESTOKM EQU 1.609344
    DBL_MILESTOINCH EQU 63360.0
    DBL_MILESTOFEET EQU 5280.0
    DBL_MILESTOYARDS EQU 1760.0

    ;/*/ Speed conversion

    DBL_KMPHTOMEPS EQU 0.27777777777778
    DBL_KMPHTOKMPS EQU 0.00027777777777778
    DBL_KMPHTOMEPM EQU 16.666666666667
    DBL_KMPHTOMILESPH EQU 0.62137119223733
    DBL_KMPHTOMILESPS EQU 0.00017260310895481
    DBL_KMPHTOFEETPS EQU 0.91134444444444
    DBL_KMPHTOFEETPM EQU 54.680666666667

    DBL_KMPSTOMEPS EQU 1000.0
    DBL_KMPSTOKMPH EQU 3600.0
    DBL_KMPSTOMEPM EQU 60000.0
    DBL_KMPSTOMILESPH EQU 2236.9362920544
    DBL_KMPSTOMILESPS EQU 0.62137119223733
    DBL_KMPSTOFEETPS EQU 3280.84
    DBL_KMPSTOFEETPM EQU 196850.4

    DBL_MEPSTOKMPH EQU 3.6
    DBL_MEPSTOKMPS EQU 0.001
    DBL_MEPSTOMEPM EQU 60.0
    DBL_MEPSTOMILESPH EQU 2.2369362920544
    DBL_MEPSTOMILESPS EQU 0.00062137119223733
    DBL_MEPSTOFEETPS EQU 3280.84
    DBL_MEPSTOFEETPM EQU 196850.4

    DBL_MEPMTOKMPH EQU 0.06
    DBL_MEPMTOKMPS EQU (1.6666666666667e-05)
    DBL_MEPMTOMEPS EQU 0.016666666666667
    DBL_MEPMTOMILESPH EQU 0.03728227153424
    DBL_MEPMTOMILESPS EQU (1.0356186537289e-05)
    DBL_MEPMTOFEETPS EQU 0.054680666666667
    DBL_MEPMTOFEETPM EQU 3.28084

    DBL_MILESPHTOKMPH EQU 1.609344
    DBL_MILESPHTOKMPS EQU 0.00044704
    DBL_MILESPHTOMEPS EQU 0.44704
    DBL_MILESPHTOMEPM EQU 26.8224
    DBL_MILESPHTOMILESPS EQU 0.00027777777777778
    DBL_MILESPHTOFEETPS EQU 1.4666667136
    DBL_MILESPHTOFEETPM EQU 88.000002816

    DBL_MILESPSTOKMPH EQU 5793.6384
    DBL_MILESPSTOKMPS EQU 1.609344
    DBL_MILESPSTOMEPS EQU 1609.344
    DBL_MILESPSTOMEPM EQU 96560.64
    DBL_MILESPSTOMILESPH EQU 3600.0
    DBL_MILESPSTOFEETPS EQU 5280.00016896
    DBL_MILESPSTOFEETPM EQU 316800.0101376

    DBL_FEETPSTOKMPH EQU 1.097279964887
    DBL_FEETPSTOKMPS EQU 0.0003047999902464
    DBL_FEETPSTOMEPS EQU 0.3047999902464
    DBL_FEETPSTOMEPM EQU 18.287999414784
    DBL_FEETPSTOMILESPH EQU 0.68181816
    DBL_FEETPSTOMILESPS EQU 0.00018939393333333
    DBL_FEETPSTOFEETPM EQU 60.0

    DBL_FEETPMTOKMPH EQU 0.018287999414784
    DBL_FEETPMTOKMPS EQU (5.07999983744e-06)
    DBL_FEETPMTOMEPS EQU 0.00507999983744
    DBL_FEETPMTOMEPM EQU 0.3047999902464
    DBL_FEETPMTOMILESPH EQU 0.011363636
    DBL_FEETPMTOMILESPS EQU (3.1565655555556e-06)
    DBL_FEETPMTOFEETPS EQU 0.016666666666667

    ;/*/ Sound Speed on Air

    DBL_SOUNDSPEEDP50C EQU 360.35
    DBL_SOUNDSPEEDP45C EQU 357.551
    DBL_SOUNDSPEEDP40C EQU 354.73
    DBL_SOUNDSPEEDP35C EQU 351.887
    DBL_SOUNDSPEEDP30C EQU 349.02
    DBL_SOUNDSPEEDP25C EQU 346.13
    DBL_SOUNDSPEEDP20C EQU 343.216
    DBL_SOUNDSPEEDP15C EQU 340.276
    DBL_SOUNDSPEEDP10C EQU 337.311
    DBL_SOUNDSPEEDP5C EQU 334.319
    DBL_SOUNDSPEED0C EQU 331.301
    DBL_SOUNDSPEEDN5C EQU 328.255
    DBL_SOUNDSPEEDN10C EQU 325.18
    DBL_SOUNDSPEEDN15C EQU 322.076
    DBL_SOUNDSPEEDN20C EQU 318.942
    DBL_SOUNDSPEEDN25C EQU 315.776
    DBL_SOUNDSPEEDN30C EQU 312.579
    DBL_SOUNDSPEEDN35C EQU 309.348
    DBL_SOUNDSPEEDN40C EQU 306.083
    DBL_SOUNDSPEEDN45C EQU 302.784
    DBL_SOUNDSPEEDN50C EQU 299.447

    DBL_SCHSCALE EQU DBL_1DIVLN2
    DBL_THSCALE EQU DBL_2DIVLN2

    DBL_EXPEST1 EQU (-6.93147182e-01)
    DBL_EXPEST2 EQU (+2.40226462e-01)
    DBL_EXPEST3 EQU (-5.55036440e-02)
    DBL_EXPEST4 EQU (+9.61597636e-03)
    DBL_EXPEST5 EQU (-1.32823968e-03)
    DBL_EXPEST6 EQU (+1.47491097e-04)
    DBL_EXPEST7 EQU (-1.08635004e-05)
    DBL_LOGEST0 EQU (+1.442693)
    DBL_LOGEST1 EQU (-0.721242)
    DBL_LOGEST2 EQU (+0.479384)
    DBL_LOGEST3 EQU (-0.350295)
    DBL_LOGEST4 EQU (+0.248590)
    DBL_LOGEST5 EQU (-0.145700)
    DBL_LOGEST6 EQU (+0.057148)
    DBL_LOGEST7 EQU (-0.010578)
    
    IFDEF CASEMAPNONE

   ;/*double mask*/
    dbl_1lshl3_msk EQU DBL_1LSHL3_MSK
    dbl_1lshl4_msk EQU DBL_1LSHL4_MSK
    dbl_1lshl7_msk EQU DBL_1LSHL7_MSK
    dbl_1lshl8_msk EQU DBL_1LSHL8_MSK
    dbl_1lshl11_msk EQU DBL_1LSHL11_MSK
    dbl_1lshl12_msk EQU DBL_1LSHL12_MSK
    dbl_1lshl15_msk EQU DBL_1LSHL15_MSK
    dbl_1lshl16_msk EQU DBL_1LSHL16_MSK
    dbl_1lshl19_msk EQU DBL_1LSHL19_MSK
    dbl_1lshl20_msk EQU DBL_1LSHL20_MSK
    dbl_1lshl23_msk EQU DBL_1LSHL23_MSK
    dbl_1lshl24_msk EQU DBL_1LSHL24_MSK
    dbl_1lshl27_msk EQU DBL_1LSHL27_MSK
    dbl_1lshl28_msk EQU DBL_1LSHL28_MSK
    dbl_1lshl31_msk EQU DBL_1LSHL31_MSK
    dbl_1lshl32_msk EQU DBL_1LSHL32_MSK
    dbl_1lshl35_msk EQU DBL_1LSHL35_MSK
    dbl_1lshl36_msk EQU DBL_1LSHL36_MSK
    dbl_1lshl39_msk EQU DBL_1LSHL39_MSK
    dbl_1lshl40_msk EQU DBL_1LSHL40_MSK
    dbl_1lshl43_msk EQU DBL_1LSHL43_MSK
    dbl_1lshl44_msk EQU DBL_1LSHL44_MSK
    dbl_1lshl47_msk EQU DBL_1LSHL47_MSK
    dbl_1lshl48_msk EQU DBL_1LSHL48_MSK
    dbl_1lshl51_msk EQU DBL_1LSHL51_MSK
    dbl_1lshl52_msk EQU DBL_1LSHL52_MSK
    dbl_1lshl55_msk EQU DBL_1LSHL55_MSK
    dbl_1lshl56_msk EQU DBL_1LSHL56_MSK
    dbl_1lshl59_msk EQU DBL_1LSHL59_MSK
    dbl_1lshl60_msk EQU DBL_1LSHL60_MSK
    dbl_1lshl63_msk EQU DBL_1LSHL63_MSK

    dbl_neg1lshl3_msk EQU DBL_NEG1LSHL3_MSK
    dbl_neg1lshl4_msk EQU DBL_NEG1LSHL4_MSK
    dbl_neg1lshl7_msk EQU DBL_NEG1LSHL7_MSK
    dbl_neg1lshl8_msk EQU DBL_NEG1LSHL8_MSK
    dbl_neg1lshl11_msk EQU DBL_NEG1LSHL11_MSK
    dbl_neg1lshl12_msk EQU DBL_NEG1LSHL12_MSK
    dbl_neg1lshl15_msk EQU DBL_NEG1LSHL15_MSK
    dbl_neg1lshl16_msk EQU DBL_NEG1LSHL16_MSK
    dbl_neg1lshl19_msk EQU DBL_NEG1LSHL19_MSK
    dbl_neg1lshl20_msk EQU DBL_NEG1LSHL20_MSK
    dbl_neg1lshl23_msk EQU DBL_NEG1LSHL23_MSK
    dbl_neg1lshl24_msk EQU DBL_NEG1LSHL24_MSK
    dbl_neg1lshl27_msk EQU DBL_NEG1LSHL27_MSK
    dbl_neg1lshl28_msk EQU DBL_NEG1LSHL28_MSK
    dbl_neg1lshl31_msk EQU DBL_NEG1LSHL31_MSK
    dbl_neg1lshl32_msk EQU DBL_NEG1LSHL32_MSK
    dbl_neg1lshl35_msk EQU DBL_NEG1LSHL35_MSK
    dbl_neg1lshl36_msk EQU DBL_NEG1LSHL36_MSK
    dbl_neg1lshl39_msk EQU DBL_NEG1LSHL39_MSK
    dbl_neg1lshl40_msk EQU DBL_NEG1LSHL40_MSK
    dbl_neg1lshl43_msk EQU DBL_NEG1LSHL43_MSK
    dbl_neg1lshl44_msk EQU DBL_NEG1LSHL44_MSK
    dbl_neg1lshl47_msk EQU DBL_NEG1LSHL47_MSK
    dbl_neg1lshl48_msk EQU DBL_NEG1LSHL48_MSK
    dbl_neg1lshl51_msk EQU DBL_NEG1LSHL51_MSK
    dbl_neg1lshl52_msk EQU DBL_NEG1LSHL52_MSK
    dbl_neg1lshl55_msk EQU DBL_NEG1LSHL55_MSK
    dbl_neg1lshl56_msk EQU DBL_NEG1LSHL56_MSK
    dbl_neg1lshl59_msk EQU DBL_NEG1LSHL59_MSK
    dbl_neg1lshl60_msk EQU DBL_NEG1LSHL60_MSK
    dbl_neg1lshl63_msk EQU DBL_NEG1LSHL63_MSK

    dbl_false_msk EQU DBL_FALSE_MSK
    dbl_true_msk EQU DBL_TRUE_MSK
    dbl_error_msk EQU DBL_ERROR_MSK

    dbl_magic_msk EQU DBL_MAGIC_MSK
    dbl_sign_msk EQU DBL_SIGN_MSK
    dbl_invsign_msk EQU DBL_INVSIGN_MSK

    dbl_inf_msk EQU DBL_INF_MSK
    dbl_fin_msk EQU DBL_FIN_MSK
    dbl_invinf_msk EQU DBL_INVINF_MSK
    dbl_neginf_msk EQU DBL_NEGINF_MSK
    dbl_nan_msk EQU DBL_NAN_MSK
    dbl_qnan_msk EQU DBL_QNAN_MSK
    dbl_negqnan_msk EQU DBL_NEGQNAN_MSK
    dbl_nantest_msk EQU DBL_NANTEST_MSK
    dbl_abs_msk EQU DBL_ABS_MSK
    dbl_min_msk EQU DBL_MIN_MSK
    dbl_max_msk EQU DBL_MAX_MSK
    dbl_nofraction_msk EQU DBL_NOFRACTION_MSK
    dbl_mindenorm_msk EQU DBL_MINDENORM_MSK
    dbl_denormlimit_msk EQU DBL_DENORMLIMIT_MSK
    dbl_minnormal_msk EQU DBL_MINNORMAL_MSK
    dbl_maxnormal_msk EQU DBL_MAXNORMAL_MSK

    dbl_decdig_msk EQU DBL_DECDIG_MSK
    dbl_dig_msk EQU DBL_DIG_MSK
    dbl_negdecdig_msk EQU DBL_NEGDECDIG_MSK
    dbl_negdig_msk EQU DBL_NEGDIG_MSK
    dbl_eps_msk EQU DBL_EPS_MSK
    dbl_epsilon_msk EQU DBL_EPSILON_MSK
    dbl_normeps_msk EQU DBL_NORMEPS_MSK
    dbl_guard_msk EQU DBL_GUARD_MSK
    dbl_mantpow2_msk EQU DBL_MANTPOW2_MSK
    dbl_maxmantpow2_msk EQU DBL_MAXMANTPOW2_MSK
    dbl_mantdig_msk EQU DBL_MANTDIG_MSK
    dbl_mant_msk EQU DBL_MANT_MSK
    dbl_negmantdig_msk EQU DBL_NEGMANTDIG_MSK
    dbl_negmant_msk EQU DBL_NEGMANT_MSK
    dbl_maxexpo_msk EQU DBL_MAXEXPO_MSK
    dbl_exposign_msk EQU DBL_EXPOSIGN_MSK
    dbl_expo_msk EQU DBL_EXPO_MSK
    dbl_negmaxexpo_msk EQU DBL_NEGMAXEXPO_MSK
    dbl_negexposign_msk EQU DBL_NEGEXPOSIGN_MSK
    dbl_negexpo_msk EQU DBL_NEGEXPO_MSK
    dbl_subnormalexpo_msk EQU DBL_SUBNORMALEXPO_MSK
    dbl_minexpo_msk EQU DBL_MINEXPO_MSK
    dbl_maxdecexpo_msk EQU DBL_MAXDECEXPO_MSK
    dbl_negmaxdecexpo_msk EQU DBL_NEGMAXDECEXPO_MSK
    dbl_mindecexpo_msk EQU DBL_MINDECEXPO_MSK
    dbl_expofield_msk EQU DBL_EXPOFIELD_MSK
    dbl_mantfield_msk EQU DBL_MANTFIELD_MSK
    dbl_norm_msk EQU DBL_NORM_MSK
    dbl_radix_msk EQU DBL_RADIX_MSK
    dbl_rounds_msk EQU DBL_ROUNDS_MSK
    dbl_subdec_msk EQU DBL_SUBDEC_MSK
    dbl_sqrtmax_msk EQU DBL_SQRTMAX_MSK
    dbl_smallnormal_msk EQU DBL_SMALLNORMAL_MSK

    dbl_halfminuseps_msk EQU DBL_HALFMINUSEPS_MSK
    dbl_trueint_msk EQU DBL_TRUEINT_MSK

    dbl_byte_msk EQU DBL_BYTE_MSK
    dbl_byte_even_msk EQU DBL_BYTE_EVEN_MSK
    dbl_byte_odd_msk EQU DBL_BYTE_ODD_MSK
    dbl_4low_msk EQU DBL_4LOW_MSK
    dbl_4high_msk EQU DBL_4HIGH_MSK
    dbl_flip4_msk EQU DBL_FLIP4_MSK
    dbl_8low_msk EQU DBL_8LOW_MSK
    dbl_8high_msk EQU DBL_8HIGH_MSK
    dbl_flip8_msk EQU DBL_FLIP8_MSK
    dbl_12low_msk EQU DBL_12LOW_MSK
    dbl_12high_msk EQU DBL_12HIGH_MSK
    dbl_flip12_msk EQU DBL_FLIP12_MSK
    dbl_16low_msk EQU DBL_16LOW_MSK
    dbl_16high_msk EQU DBL_16HIGH_MSK
    dbl_flip16_msk EQU DBL_FLIP16_MSK
    dbl_20low_msk EQU DBL_20LOW_MSK
    dbl_20high_msk EQU DBL_20HIGH_MSK
    dbl_flip20_msk EQU DBL_FLIP20_MSK
    dbl_24low_msk EQU DBL_24LOW_MSK
    dbl_24high_msk EQU DBL_24HIGH_MSK
    dbl_flip24_msk EQU DBL_FLIP24_MSK
    dbl_28low_msk EQU DBL_28LOW_MSK
    dbl_28high_msk EQU DBL_28HIGH_MSK
    dbl_flip28_msk EQU DBL_FLIP28_MSK
    dbl_32low_msk EQU DBL_32LOW_MSK
    dbl_32high_msk EQU DBL_32HIGH_MSK
    dbl_flip32_msk EQU DBL_FLIP32_MSK
    dbl_36low_msk EQU DBL_36LOW_MSK
    dbl_36high_msk EQU DBL_36HIGH_MSK
    dbl_flip36_msk EQU DBL_FLIP36_MSK
    dbl_40low_msk EQU DBL_40LOW_MSK
    dbl_40high_msk EQU DBL_40HIGH_MSK
    dbl_flip40_msk EQU DBL_FLIP40_MSK
    dbl_44low_msk EQU DBL_44LOW_MSK
    dbl_44high_msk EQU DBL_44HIGH_MSK
    dbl_flip44_msk EQU DBL_FLIP44_MSK
    dbl_48low_msk EQU DBL_48LOW_MSK
    dbl_48high_msk EQU DBL_48HIGH_MSK
    dbl_flip48_msk EQU DBL_FLIP48_MSK
    dbl_52low_msk EQU DBL_52LOW_MSK
    dbl_52high_msk EQU DBL_52HIGH_MSK
    dbl_flip52_msk EQU DBL_FLIP52_MSK
    dbl_56low_msk EQU DBL_56LOW_MSK
    dbl_56high_msk EQU DBL_56HIGH_MSK
    dbl_flip56_msk EQU DBL_FLIP56_MSK
    dbl_60low_msk EQU DBL_60LOW_MSK
    dbl_60high_msk EQU DBL_60HIGH_MSK
    dbl_flip60_msk EQU DBL_FLIP60_MSK
    dbl_64low_msk EQU DBL_64LOW_MSK
    dbl_64high_msk EQU DBL_64HIGH_MSK
    dbl_flip64_msk EQU DBL_FLIP64_MSK

    dbl_0_msk EQU DBL_0_MSK
    dbl_0d5_msk EQU DBL_0D5_MSK
    dbl_1_msk EQU DBL_1_MSK
    dbl_1d5_msk EQU DBL_1D5_MSK
    dbl_2_msk EQU DBL_2_MSK
    dbl_2d5_msk EQU DBL_2D5_MSK
    dbl_3_msk EQU DBL_3_MSK
    dbl_4_msk EQU DBL_4_MSK
    dbl_5_msk EQU DBL_5_MSK
    dbl_6_msk EQU DBL_6_MSK
    dbl_7_msk EQU DBL_7_MSK
    dbl_8_msk EQU DBL_8_MSK
    dbl_9_msk EQU DBL_9_MSK
    dbl_10_msk EQU DBL_10_MSK
    dbl_20_msk EQU DBL_20_MSK
    dbl_23_msk EQU DBL_23_MSK
    dbl_23d5_msk EQU DBL_23D5_MSK
    dbl_24_msk EQU DBL_24_MSK
    dbl_24d5_msk EQU DBL_24D5_MSK
    dbl_25_msk EQU DBL_25_MSK

    dbl_128_msk EQU DBL_128_MSK

    dbl_253_msk EQU DBL_253_MSK

    dbl_neg0_msk EQU DBL_NEG0_MSK
    dbl_neg1_msk EQU DBL_NEG1_MSK

    dbl_neg150_msk EQU DBL_NEG150_MSK

    dbl_bin128_msk EQU DBL_BIN128_MSK
    dbl_binneg150_msk EQU DBL_BINNEG150_MSK

    dbl_maxrand_msk EQU DBL_MAXRAND_MSK

    dbl_maxi8_msk EQU DBL_MAXI8_MSK
    dbl_mini8_msk EQU DBL_MINI8_MSK
    dbl_maxu8_msk EQU DBL_MAXU8_MSK

    dbl_maxi16_msk EQU DBL_MAXI16_MSK
    dbl_mini16_msk EQU DBL_MINI16_MSK
    dbl_maxu16_msk EQU DBL_MAXU16_MSK

    dbl_maxi32_msk EQU DBL_MAXI32_MSK
    dbl_mini32_msk EQU DBL_MINI32_MSK
    dbl_maxu32_msk EQU DBL_MAXU32_MSK

    dbl_maxi64_msk EQU DBL_MAXI64_MSK
    dbl_mini64_msk EQU DBL_MINI64_MSK
    dbl_maxu64_msk EQU DBL_MAXU64_MSK

    dbl_maxi8xu8_msk EQU DBL_MAXI8XU8_MSK
    dbl_mini8xu8_msk EQU DBL_MINI8XU8_MSK
    dbl_maxi8xu16_msk EQU DBL_MAXI8XU16_MSK
    dbl_mini8xu16_msk EQU DBL_MINI8XU16_MSK

    dbl_maxi16xu16_msk EQU DBL_MAXI16XU16_MSK
    dbl_mini16xu16_msk EQU DBL_MINI16XU16_MSK
    dbl_maxi16xu32_msk EQU DBL_MAXI16XU32_MSK
    dbl_mini16xu32_msk EQU DBL_MINI16XU32_MSK

    dbl_maxi32xu32_msk EQU DBL_MAXI32XU32_MSK
    dbl_mini32xu32_msk EQU DBL_MINI32XU32_MSK

    dbl_fixunsigned_msk EQU DBL_FIXUNSIGNED_MSK
    dbl_fixunsigned32_msk EQU DBL_FIXUNSIGNED32_MSK
    dbl_fixmaxi32_msk EQU DBL_FIXMAXI32_MSK
    dbl_fixmaxu32_msk EQU DBL_FIXMAXU32_MSK

    dbl_fixunsigned64_msk EQU DBL_FIXUNSIGNED64_MSK
    dbl_fixmaxi64_msk EQU DBL_FIXMAXI64_MSK
    dbl_fixmaxu64_msk EQU DBL_FIXMAXU64_MSK

   ;/*double int*/
    dbl_1lshl3_int EQU DBL_1LSHL3_INT
    dbl_1lshl4_int EQU DBL_1LSHL4_INT
    dbl_1lshl7_int EQU DBL_1LSHL7_INT
    dbl_1lshl8_int EQU DBL_1LSHL8_INT
    dbl_1lshl11_int EQU DBL_1LSHL11_INT
    dbl_1lshl12_int EQU DBL_1LSHL12_INT
    dbl_1lshl15_int EQU DBL_1LSHL15_INT
    dbl_1lshl16_int EQU DBL_1LSHL16_INT
    dbl_1lshl19_int EQU DBL_1LSHL19_INT
    dbl_1lshl20_int EQU DBL_1LSHL20_INT
    dbl_1lshl23_int EQU DBL_1LSHL23_INT
    dbl_1lshl24_int EQU DBL_1LSHL24_INT
    dbl_1lshl27_int EQU DBL_1LSHL27_INT
    dbl_1lshl28_int EQU DBL_1LSHL28_INT
    dbl_1lshl31_int EQU DBL_1LSHL31_INT
    dbl_1lshl32_int EQU DBL_1LSHL32_INT
    dbl_1lshl35_int EQU DBL_1LSHL35_INT
    dbl_1lshl36_int EQU DBL_1LSHL36_INT
    dbl_1lshl39_int EQU DBL_1LSHL39_INT
    dbl_1lshl40_int EQU DBL_1LSHL40_INT
    dbl_1lshl43_int EQU DBL_1LSHL43_INT
    dbl_1lshl44_int EQU DBL_1LSHL44_INT
    dbl_1lshl47_int EQU DBL_1LSHL47_INT
    dbl_1lshl48_int EQU DBL_1LSHL48_INT
    dbl_1lshl51_int EQU DBL_1LSHL51_INT
    dbl_1lshl52_int EQU DBL_1LSHL52_INT
    dbl_1lshl55_int EQU DBL_1LSHL55_INT
    dbl_1lshl56_int EQU DBL_1LSHL56_INT
    dbl_1lshl59_int EQU DBL_1LSHL59_INT
    dbl_1lshl60_int EQU DBL_1LSHL60_INT
    dbl_1lshl63_int EQU DBL_1LSHL63_INT

    dbl_neg1lshl3_int EQU DBL_NEG1LSHL3_INT
    dbl_neg1lshl4_int EQU DBL_NEG1LSHL4_INT
    dbl_neg1lshl7_int EQU DBL_NEG1LSHL7_INT
    dbl_neg1lshl8_int EQU DBL_NEG1LSHL8_INT
    dbl_neg1lshl11_int EQU DBL_NEG1LSHL11_INT
    dbl_neg1lshl12_int EQU DBL_NEG1LSHL12_INT
    dbl_neg1lshl15_int EQU DBL_NEG1LSHL15_INT
    dbl_neg1lshl16_int EQU DBL_NEG1LSHL16_INT
    dbl_neg1lshl19_int EQU DBL_NEG1LSHL19_INT
    dbl_neg1lshl20_int EQU DBL_NEG1LSHL20_INT
    dbl_neg1lshl23_int EQU DBL_NEG1LSHL23_INT
    dbl_neg1lshl24_int EQU DBL_NEG1LSHL24_INT
    dbl_neg1lshl27_int EQU DBL_NEG1LSHL27_INT
    dbl_neg1lshl28_int EQU DBL_NEG1LSHL28_INT
    dbl_neg1lshl31_int EQU DBL_NEG1LSHL31_INT
    dbl_neg1lshl32_int EQU DBL_NEG1LSHL32_INT
    dbl_neg1lshl35_int EQU DBL_NEG1LSHL35_INT
    dbl_neg1lshl36_int EQU DBL_NEG1LSHL36_INT
    dbl_neg1lshl39_int EQU DBL_NEG1LSHL39_INT
    dbl_neg1lshl40_int EQU DBL_NEG1LSHL40_INT
    dbl_neg1lshl43_int EQU DBL_NEG1LSHL43_INT
    dbl_neg1lshl44_int EQU DBL_NEG1LSHL44_INT
    dbl_neg1lshl47_int EQU DBL_NEG1LSHL47_INT
    dbl_neg1lshl48_int EQU DBL_NEG1LSHL48_INT
    dbl_neg1lshl51_int EQU DBL_NEG1LSHL51_INT
    dbl_neg1lshl52_int EQU DBL_NEG1LSHL52_INT
    dbl_neg1lshl55_int EQU DBL_NEG1LSHL55_INT
    dbl_neg1lshl56_int EQU DBL_NEG1LSHL56_INT
    dbl_neg1lshl59_int EQU DBL_NEG1LSHL59_INT
    dbl_neg1lshl60_int EQU DBL_NEG1LSHL60_INT
    dbl_neg1lshl63_int EQU DBL_NEG1LSHL63_INT

    dbl_false_int EQU DBL_FALSE_INT
    dbl_true_int EQU DBL_TRUE_INT
    dbl_error_int EQU DBL_ERROR_INT

    dbl_magic_int EQU DBL_MAGIC_INT
    dbl_sign_int EQU DBL_SIGN_INT
    dbl_invsign_int EQU DBL_INVSIGN_INT

    dbl_inf_int EQU DBL_INF_INT
    dbl_fin_int EQU DBL_FIN_INT
    dbl_invinf_int EQU DBL_INVINF_INT
    dbl_neginf_int EQU DBL_NEGINF_INT
    dbl_nan_int EQU DBL_NAN_INT
    dbl_qnan_int EQU DBL_QNAN_INT
    dbl_negqnan_int EQU DBL_NEGQNAN_INT
    dbl_nantest_int EQU DBL_NANTEST_INT
    dbl_abs_int EQU DBL_ABS_INT
    dbl_min_int EQU DBL_MIN_INT
    dbl_max_int EQU DBL_MAX_INT
    dbl_nofraction_int EQU DBL_NOFRACTION_INT
    dbl_mindenorm_int EQU DBL_MINDENORM_INT
    dbl_denormlimit_int EQU DBL_DENORMLIMIT_INT
    dbl_minnormal_int EQU DBL_MINNORMAL_INT
    dbl_maxnormal_int EQU DBL_MAXNORMAL_INT

    dbl_decdig_int EQU DBL_DECDIG_INT
    dbl_dig_int EQU DBL_DIG_INT
    dbl_negdecdig_int EQU DBL_NEGDECDIG_INT
    dbl_negdig_int EQU DBL_NEGDIG_INT
    dbl_eps_int EQU DBL_EPS_INT
    dbl_epsilon_int EQU DBL_EPSILON_INT
    dbl_normeps_int EQU DBL_NORMEPS_INT
    dbl_guard_int EQU DBL_GUARD_INT
    dbl_mantpow2_int EQU DBL_MANTPOW2_INT
    dbl_maxmantpow2_int EQU DBL_MAXMANTPOW2_INT
    dbl_mantdig_int EQU DBL_MANTDIG_INT
    dbl_mant_int EQU DBL_MANT_INT
    dbl_negmantdig_int EQU DBL_NEGMANTDIG_INT
    dbl_negmant_int EQU DBL_NEGMANT_INT
    dbl_maxexpo_int EQU DBL_MAXEXPO_INT
    dbl_exposign_int EQU DBL_EXPOSIGN_INT
    dbl_expo_int EQU DBL_EXPO_INT
    dbl_negmaxexpo_int EQU DBL_NEGMAXEXPO_INT
    dbl_negexposign_int EQU DBL_NEGEXPOSIGN_INT
    dbl_negexpo_int EQU DBL_NEGEXPO_INT
    dbl_subnormalexpo_int EQU DBL_SUBNORMALEXPO_INT
    dbl_minexpo_int EQU DBL_MINEXPO_INT
    dbl_maxdecexpo_int EQU DBL_MAXDECEXPO_INT
    dbl_negmaxdecexpo_int EQU DBL_NEGMAXDECEXPO_INT
    dbl_mindecexpo_int EQU DBL_MINDECEXPO_INT
    dbl_expofield_int EQU DBL_EXPOFIELD_INT
    dbl_mantfield_int EQU DBL_MANTFIELD_INT
    dbl_norm_int EQU DBL_NORM_INT
    dbl_radix_int EQU DBL_RADIX_INT
    dbl_rounds_int EQU DBL_ROUNDS_INT
    dbl_subdec_int EQU DBL_SUBDEC_INT
    dbl_sqrtmax_int EQU DBL_SQRTMAX_INT
    dbl_smallnormal_int EQU DBL_SMALLNORMAL_INT

    dbl_halfminuseps_int EQU DBL_HALFMINUSEPS_INT
    dbl_trueint_int EQU DBL_TRUEINT_INT

    dbl_byte_int EQU DBL_BYTE_INT
    dbl_byte_even_int EQU DBL_BYTE_EVEN_INT
    dbl_byte_odd_int EQU DBL_BYTE_ODD_INT
    dbl_4low_int EQU DBL_4LOW_INT
    dbl_4high_int EQU DBL_4HIGH_INT
    dbl_flip4_int EQU DBL_FLIP4_INT
    dbl_8low_int EQU DBL_8LOW_INT
    dbl_8high_int EQU DBL_8HIGH_INT
    dbl_flip8_int EQU DBL_FLIP8_INT
    dbl_12low_int EQU DBL_12LOW_INT
    dbl_12high_int EQU DBL_12HIGH_INT
    dbl_flip12_int EQU DBL_FLIP12_INT
    dbl_16low_int EQU DBL_16LOW_INT
    dbl_16high_int EQU DBL_16HIGH_INT
    dbl_flip16_int EQU DBL_FLIP16_INT
    dbl_20low_int EQU DBL_20LOW_INT
    dbl_20high_int EQU DBL_20HIGH_INT
    dbl_flip20_int EQU DBL_FLIP20_INT
    dbl_24low_int EQU DBL_24LOW_INT
    dbl_24high_int EQU DBL_24HIGH_INT
    dbl_flip24_int EQU DBL_FLIP24_INT
    dbl_28low_int EQU DBL_28LOW_INT
    dbl_28high_int EQU DBL_28HIGH_INT
    dbl_flip28_int EQU DBL_FLIP28_INT
    dbl_32low_int EQU DBL_32LOW_INT
    dbl_32high_int EQU DBL_32HIGH_INT
    dbl_flip32_int EQU DBL_FLIP32_INT
    dbl_36low_int EQU DBL_36LOW_INT
    dbl_36high_int EQU DBL_36HIGH_INT
    dbl_flip36_int EQU DBL_FLIP36_INT
    dbl_40low_int EQU DBL_40LOW_INT
    dbl_40high_int EQU DBL_40HIGH_INT
    dbl_flip40_int EQU DBL_FLIP40_INT
    dbl_44low_int EQU DBL_44LOW_INT
    dbl_44high_int EQU DBL_44HIGH_INT
    dbl_flip44_int EQU DBL_FLIP44_INT
    dbl_48low_int EQU DBL_48LOW_INT
    dbl_48high_int EQU DBL_48HIGH_INT
    dbl_flip48_int EQU DBL_FLIP48_INT
    dbl_52low_int EQU DBL_52LOW_INT
    dbl_52high_int EQU DBL_52HIGH_INT
    dbl_flip52_int EQU DBL_FLIP52_INT
    dbl_56low_int EQU DBL_56LOW_INT
    dbl_56high_int EQU DBL_56HIGH_INT
    dbl_flip56_int EQU DBL_FLIP56_INT
    dbl_60low_int EQU DBL_60LOW_INT
    dbl_60high_int EQU DBL_60HIGH_INT
    dbl_flip60_int EQU DBL_FLIP60_INT
    dbl_64low_int EQU DBL_64LOW_INT
    dbl_64high_int EQU DBL_64HIGH_INT
    dbl_flip64_int EQU DBL_FLIP64_INT

    dbl_0_int EQU DBL_0_INT
    dbl_0d5_int EQU DBL_0D5_INT
    dbl_1_int EQU DBL_1_INT
    dbl_1d5_int EQU DBL_1D5_INT
    dbl_2_int EQU DBL_2_INT
    dbl_2d5_int EQU DBL_2D5_INT
    dbl_3_int EQU DBL_3_INT
    dbl_4_int EQU DBL_4_INT
    dbl_5_int EQU DBL_5_INT
    dbl_6_int EQU DBL_6_INT
    dbl_7_int EQU DBL_7_INT
    dbl_8_int EQU DBL_8_INT
    dbl_9_int EQU DBL_9_INT
    dbl_10_int EQU DBL_10_INT
    dbl_20_int EQU DBL_20_INT
    dbl_23_int EQU DBL_23_INT
    dbl_23d5_int EQU DBL_23D5_INT
    dbl_24_int EQU DBL_24_INT
    dbl_24d5_int EQU DBL_24D5_INT
    dbl_25_int EQU DBL_25_INT

    dbl_128_int EQU DBL_128_INT

    dbl_253_int EQU DBL_253_INT

    dbl_neg0_int EQU DBL_NEG0_INT
    dbl_neg1_int EQU DBL_NEG1_INT

    dbl_neg150_int EQU DBL_NEG150_INT

    dbl_bin128_int EQU DBL_BIN128_INT
    dbl_binneg150_int EQU DBL_BINNEG150_INT

    dbl_maxrand_int EQU DBL_MAXRAND_INT

    dbl_maxi8_int EQU DBL_MAXI8_INT
    dbl_mini8_int EQU DBL_MINI8_INT
    dbl_maxu8_int EQU DBL_MAXU8_INT

    dbl_maxi16_int EQU DBL_MAXI16_INT
    dbl_mini16_int EQU DBL_MINI16_INT
    dbl_maxu16_int EQU DBL_MAXU16_INT

    dbl_maxi32_int EQU DBL_MAXI32_INT
    dbl_mini32_int EQU DBL_MINI32_INT
    dbl_maxu32_int EQU DBL_MAXU32_INT

    dbl_maxi64_int EQU DBL_MAXI64_INT
    dbl_mini64_int EQU DBL_MINI64_INT
    dbl_maxu64_int EQU DBL_MAXU64_INT

    dbl_maxi8xu8_int EQU DBL_MAXI8XU8_INT
    dbl_mini8xu8_int EQU DBL_MINI8XU8_INT
    dbl_maxi8xu16_int EQU DBL_MAXI8XU16_INT
    dbl_mini8xu16_int EQU DBL_MINI8XU16_INT

    dbl_maxi16xu16_int EQU DBL_MAXI16XU16_INT
    dbl_mini16xu16_int EQU DBL_MINI16XU16_INT
    dbl_maxi16xu32_int EQU DBL_MAXI16XU32_INT
    dbl_mini16xu32_int EQU DBL_MINI16XU32_INT

    dbl_maxi32xu32_int EQU DBL_MAXI32XU32_INT
    dbl_mini32xu32_int EQU DBL_MINI32XU32_INT

    dbl_fixunsigned_int EQU DBL_FIXUNSIGNED_INT
    dbl_fixunsigned32_int EQU DBL_FIXUNSIGNED32_INT
    dbl_fixmaxi32_int EQU DBL_FIXMAXI32_INT
    dbl_fixmaxu32_int EQU DBL_FIXMAXU32_INT

    dbl_fixunsigned64_int EQU DBL_FIXUNSIGNED64_INT
    dbl_fixmaxi64_int EQU DBL_FIXMAXI64_INT
    dbl_fixmaxu64_int EQU DBL_FIXMAXU64_INT

   ;/*double*/
    dbl_1lshl3 EQU DBL_1LSHL3
    dbl_1lshl4 EQU DBL_1LSHL4
    dbl_1lshl7 EQU DBL_1LSHL7
    dbl_1lshl8 EQU DBL_1LSHL8
    dbl_1lshl11 EQU DBL_1LSHL11
    dbl_1lshl12 EQU DBL_1LSHL12
    dbl_1lshl15 EQU DBL_1LSHL15
    dbl_1lshl16 EQU DBL_1LSHL16
    dbl_1lshl19 EQU DBL_1LSHL19
    dbl_1lshl20 EQU DBL_1LSHL20
    dbl_1lshl23 EQU DBL_1LSHL23
    dbl_1lshl24 EQU DBL_1LSHL24
    dbl_1lshl27 EQU DBL_1LSHL27
    dbl_1lshl28 EQU DBL_1LSHL28
    dbl_1lshl31 EQU DBL_1LSHL31
    dbl_1lshl32 EQU DBL_1LSHL32
    dbl_1lshl35 EQU DBL_1LSHL35
    dbl_1lshl36 EQU DBL_1LSHL36
    dbl_1lshl39 EQU DBL_1LSHL39
    dbl_1lshl40 EQU DBL_1LSHL40
    dbl_1lshl43 EQU DBL_1LSHL43
    dbl_1lshl44 EQU DBL_1LSHL44
    dbl_1lshl47 EQU DBL_1LSHL47
    dbl_1lshl48 EQU DBL_1LSHL48
    dbl_1lshl51 EQU DBL_1LSHL51
    dbl_1lshl52 EQU DBL_1LSHL52
    dbl_1lshl55 EQU DBL_1LSHL55
    dbl_1lshl56 EQU DBL_1LSHL56
    dbl_1lshl59 EQU DBL_1LSHL59
    dbl_1lshl60 EQU DBL_1LSHL60
    dbl_1lshl63 EQU DBL_1LSHL63

    dbl_neg1lshl3 EQU DBL_NEG1LSHL3
    dbl_neg1lshl4 EQU DBL_NEG1LSHL4
    dbl_neg1lshl7 EQU DBL_NEG1LSHL7
    dbl_neg1lshl8 EQU DBL_NEG1LSHL8
    dbl_neg1lshl11 EQU DBL_NEG1LSHL11
    dbl_neg1lshl12 EQU DBL_NEG1LSHL12
    dbl_neg1lshl15 EQU DBL_NEG1LSHL15
    dbl_neg1lshl16 EQU DBL_NEG1LSHL16
    dbl_neg1lshl19 EQU DBL_NEG1LSHL19
    dbl_neg1lshl20 EQU DBL_NEG1LSHL20
    dbl_neg1lshl23 EQU DBL_NEG1LSHL23
    dbl_neg1lshl24 EQU DBL_NEG1LSHL24
    dbl_neg1lshl27 EQU DBL_NEG1LSHL27
    dbl_neg1lshl28 EQU DBL_NEG1LSHL28
    dbl_neg1lshl31 EQU DBL_NEG1LSHL31
    dbl_neg1lshl32 EQU DBL_NEG1LSHL32
    dbl_neg1lshl35 EQU DBL_NEG1LSHL35
    dbl_neg1lshl36 EQU DBL_NEG1LSHL36
    dbl_neg1lshl39 EQU DBL_NEG1LSHL39
    dbl_neg1lshl40 EQU DBL_NEG1LSHL40
    dbl_neg1lshl43 EQU DBL_NEG1LSHL43
    dbl_neg1lshl44 EQU DBL_NEG1LSHL44
    dbl_neg1lshl47 EQU DBL_NEG1LSHL47
    dbl_neg1lshl48 EQU DBL_NEG1LSHL48
    dbl_neg1lshl51 EQU DBL_NEG1LSHL51
    dbl_neg1lshl52 EQU DBL_NEG1LSHL52
    dbl_neg1lshl55 EQU DBL_NEG1LSHL55
    dbl_neg1lshl56 EQU DBL_NEG1LSHL56
    dbl_neg1lshl59 EQU DBL_NEG1LSHL59
    dbl_neg1lshl60 EQU DBL_NEG1LSHL60
    dbl_neg1lshl63 EQU DBL_NEG1LSHL63

    dbl_false EQU DBL_FALSE
    dbl_true EQU DBL_TRUE

    dbl_magic EQU DBL_MAGIC
    dbl_sign EQU DBL_SIGN
    dbl_invsign EQU DBL_INVSIGN

    dbl_inf EQU DBL_INF
    dbl_fin EQU DBL_FIN
    dbl_invinf EQU DBL_INVINF
    dbl_neginf EQU DBL_NEGINF
    dbl_nan EQU DBL_NAN
    dbl_qnan EQU DBL_QNAN
    dbl_negqnan EQU DBL_NEGQNAN
    dbl_nantest EQU DBL_NANTEST
    dbl_abs EQU DBL_ABS
    dbl_min EQU DBL_MIN
    dbl_max EQU DBL_MAX
    dbl_nofraction EQU DBL_NOFRACTION
    dbl_mindenorm EQU DBL_MINDENORM
    dbl_denormlimit EQU DBL_DENORMLIMIT
    dbl_minnormal EQU DBL_MINNORMAL
    dbl_maxnormal EQU DBL_MAXNORMAL

    dbl_decdig EQU DBL_DECDIG
    dbl_dig EQU DBL_DIG
    dbl_negdecdig EQU DBL_NEGDECDIG
    dbl_negdig EQU DBL_NEGDIG
    dbl_eps EQU DBL_EPS
    dbl_epsilon EQU DBL_EPSILON
    dbl_normeps EQU DBL_NORMEPS
    dbl_guard EQU DBL_GUARD
    dbl_mantpow2 EQU DBL_MANTPOW2
    dbl_maxmantpow2 EQU DBL_MAXMANTPOW2
    dbl_mantdig EQU DBL_MANTDIG
    dbl_mant EQU DBL_MANT
    dbl_negmantdig EQU DBL_NEGMANTDIG
    dbl_negmant EQU DBL_NEGMANT
    dbl_maxexpo EQU DBL_MAXEXPO
    dbl_exposign EQU DBL_EXPOSIGN
    dbl_expo EQU DBL_EXPO
    dbl_negmaxexpo EQU DBL_NEGMAXEXPO
    dbl_negexposign EQU DBL_NEGEXPOSIGN
    dbl_negexpo EQU DBL_NEGEXPO
    dbl_subnormalexpo EQU DBL_SUBNORMALEXPO
    dbl_minexpo EQU DBL_MINEXPO
    dbl_maxdecexpo EQU DBL_MAXDECEXPO
    dbl_negmaxdecexpo EQU DBL_NEGMAXDECEXPO
    dbl_mindecexpo EQU DBL_MINDECEXPO
    dbl_expofield EQU DBL_EXPOFIELD
    dbl_mantfield EQU DBL_MANTFIELD
    dbl_norm EQU DBL_NORM
    dbl_radix EQU DBL_RADIX
    dbl_rounds EQU DBL_ROUNDS
    dbl_subdec EQU DBL_SUBDEC
    dbl_sqrtmax EQU DBL_SQRTMAX
    dbl_smallnormal EQU DBL_SMALLNORMAL

    dbl_halfminuseps EQU DBL_HALFMINUSEPS
    dbl_trueint EQU DBL_TRUEINT

    dbl_byte EQU DBL_BYTE
    dbl_byte_even EQU DBL_BYTE_EVEN
    dbl_byte_odd EQU DBL_BYTE_ODD
    dbl_4low EQU DBL_4LOW
    dbl_4high EQU DBL_4HIGH
    dbl_flip4 EQU DBL_FLIP4
    dbl_8low EQU DBL_8LOW
    dbl_8high EQU DBL_8HIGH
    dbl_flip8 EQU DBL_FLIP8
    dbl_12low EQU DBL_12LOW
    dbl_12high EQU DBL_12HIGH
    dbl_flip12 EQU DBL_FLIP12
    dbl_16low EQU DBL_16LOW
    dbl_16high EQU DBL_16HIGH
    dbl_flip16 EQU DBL_FLIP16
    dbl_20low EQU DBL_20LOW
    dbl_20high EQU DBL_20HIGH
    dbl_flip20 EQU DBL_FLIP20
    dbl_24low EQU DBL_24LOW
    dbl_24high EQU DBL_24HIGH
    dbl_flip24 EQU DBL_FLIP24
    dbl_28low EQU DBL_28LOW
    dbl_28high EQU DBL_28HIGH
    dbl_flip28 EQU DBL_FLIP28
    dbl_32low EQU DBL_32LOW
    dbl_32high EQU DBL_32HIGH
    dbl_flip32 EQU DBL_FLIP32
    dbl_36low EQU DBL_36LOW
    dbl_36high EQU DBL_36HIGH
    dbl_flip36 EQU DBL_FLIP36
    dbl_40low EQU DBL_40LOW
    dbl_40high EQU DBL_40HIGH
    dbl_flip40 EQU DBL_FLIP40
    dbl_44low EQU DBL_44LOW
    dbl_44high EQU DBL_44HIGH
    dbl_flip44 EQU DBL_FLIP44
    dbl_48low EQU DBL_48LOW
    dbl_48high EQU DBL_48HIGH
    dbl_flip48 EQU DBL_FLIP48
    dbl_52low EQU DBL_52LOW
    dbl_52high EQU DBL_52HIGH
    dbl_flip52 EQU DBL_FLIP52
    dbl_56low EQU DBL_56LOW
    dbl_56high EQU DBL_56HIGH
    dbl_flip56 EQU DBL_FLIP56
    dbl_60low EQU DBL_60LOW
    dbl_60high EQU DBL_60HIGH
    dbl_flip60 EQU DBL_FLIP60
    dbl_64low EQU DBL_64LOW
    dbl_64high EQU DBL_64HIGH
    dbl_flip64 EQU DBL_FLIP64

    dbl_0 EQU DBL_0
    dbl_0d0001 EQU DBL_0D0001
    dbl_0d0002 EQU DBL_0D0002
    dbl_0d0003 EQU DBL_0D0003
    dbl_0d0004 EQU DBL_0D0004
    dbl_0d0005 EQU DBL_0D0005
    dbl_0d0006 EQU DBL_0D0006
    dbl_0d0007 EQU DBL_0D0007
    dbl_0d0008 EQU DBL_0D0008
    dbl_0d0009 EQU DBL_0D0009
    dbl_0d001 EQU DBL_0D001
    dbl_0d002 EQU DBL_0D002
    dbl_0d003 EQU DBL_0D003
    dbl_0d004 EQU DBL_0D004
    dbl_0d005 EQU DBL_0D005
    dbl_0d006 EQU DBL_0D006
    dbl_0d007 EQU DBL_0D007
    dbl_0d008 EQU DBL_0D008
    dbl_0d009 EQU DBL_0D009
    dbl_0d01 EQU DBL_0D01
    dbl_0d02 EQU DBL_0D02
    dbl_0d025 EQU DBL_0D025
    dbl_0d03 EQU DBL_0D03
    dbl_0d04 EQU DBL_0D04
    dbl_0d05 EQU DBL_0D05
    dbl_0d06 EQU DBL_0D06
    dbl_0d07 EQU DBL_0D07
    dbl_0d08 EQU DBL_0D08
    dbl_0d09 EQU DBL_0D09
    dbl_0d1 EQU DBL_0D1
    dbl_0d2 EQU DBL_0D2
    dbl_0d25 EQU DBL_0D25
    dbl_0d3 EQU DBL_0D3
    dbl_0d4 EQU DBL_0D4
    dbl_0d5 EQU DBL_0D5
    dbl_0d6 EQU DBL_0D6
    dbl_0d7 EQU DBL_0D7
    dbl_0d8 EQU DBL_0D8
    dbl_0d9 EQU DBL_0D9
    dbl_1 EQU DBL_1
    dbl_1d25 EQU DBL_1D25
    dbl_1d5 EQU DBL_1D5
    dbl_2 EQU DBL_2
    dbl_2d25 EQU DBL_2D25
    dbl_2d5 EQU DBL_2D5
    dbl_3 EQU DBL_3
    dbl_3d25 EQU DBL_3D25
    dbl_3d5 EQU DBL_3D5
    dbl_4 EQU DBL_4
    dbl_4d25 EQU DBL_4D25
    dbl_4d5 EQU DBL_4D5
    dbl_5 EQU DBL_5
    dbl_5d25 EQU DBL_5D25
    dbl_5d5 EQU DBL_5D5
    dbl_6 EQU DBL_6
    dbl_6d25 EQU DBL_6D25
    dbl_6d5 EQU DBL_6D5
    dbl_7 EQU DBL_7
    dbl_7d25 EQU DBL_7D25
    dbl_7d5 EQU DBL_7D5
    dbl_8 EQU DBL_8
    dbl_8d25 EQU DBL_8D25
    dbl_8d5 EQU DBL_8D5
    dbl_9 EQU DBL_9
    dbl_9d25 EQU DBL_9D25
    dbl_9d5 EQU DBL_9D5
    dbl_10 EQU DBL_10
    dbl_11 EQU DBL_11
    dbl_12 EQU DBL_12
    dbl_13 EQU DBL_13
    dbl_14 EQU DBL_14
    dbl_15 EQU DBL_15
    dbl_16 EQU DBL_16
    dbl_17 EQU DBL_17
    dbl_18 EQU DBL_18
    dbl_19 EQU DBL_19
    dbl_20 EQU DBL_20
    dbl_21 EQU DBL_21
    dbl_22 EQU DBL_22
    dbl_23 EQU DBL_23
    dbl_24 EQU DBL_24
    dbl_24d5 EQU DBL_24D5
    dbl_25 EQU DBL_25
    dbl_26 EQU DBL_26
    dbl_27 EQU DBL_27
    dbl_28 EQU DBL_28
    dbl_29 EQU DBL_29
    dbl_30 EQU DBL_30
    dbl_31 EQU DBL_31
    dbl_32 EQU DBL_32
    dbl_33 EQU DBL_33
    dbl_34 EQU DBL_34
    dbl_35 EQU DBL_35
    dbl_36 EQU DBL_36
    dbl_37 EQU DBL_37
    dbl_38 EQU DBL_38
    dbl_39 EQU DBL_39
    dbl_40 EQU DBL_40
    dbl_41 EQU DBL_41
    dbl_42 EQU DBL_42
    dbl_43 EQU DBL_43
    dbl_44 EQU DBL_44
    dbl_45 EQU DBL_45
    dbl_46 EQU DBL_46
    dbl_47 EQU DBL_47
    dbl_48 EQU DBL_48
    dbl_49 EQU DBL_49
    dbl_50 EQU DBL_50
    dbl_51 EQU DBL_51
    dbl_52 EQU DBL_52
    dbl_53 EQU DBL_53
    dbl_54 EQU DBL_54
    dbl_55 EQU DBL_55
    dbl_56 EQU DBL_56
    dbl_57 EQU DBL_57
    dbl_58 EQU DBL_58
    dbl_59 EQU DBL_59
    dbl_60 EQU DBL_60
    dbl_61 EQU DBL_61
    dbl_62 EQU DBL_62
    dbl_63 EQU DBL_63
    dbl_64 EQU DBL_64
    dbl_65 EQU DBL_65
    dbl_66 EQU DBL_66
    dbl_67 EQU DBL_67
    dbl_68 EQU DBL_68
    dbl_69 EQU DBL_69
    dbl_70 EQU DBL_70
    dbl_71 EQU DBL_71
    dbl_72 EQU DBL_72
    dbl_73 EQU DBL_73
    dbl_74 EQU DBL_74
    dbl_75 EQU DBL_75
    dbl_76 EQU DBL_76
    dbl_77 EQU DBL_77
    dbl_78 EQU DBL_78
    dbl_79 EQU DBL_79
    dbl_80 EQU DBL_80
    dbl_81 EQU DBL_81
    dbl_82 EQU DBL_82
    dbl_83 EQU DBL_83
    dbl_84 EQU DBL_84
    dbl_85 EQU DBL_85
    dbl_86 EQU DBL_86
    dbl_87 EQU DBL_87
    dbl_88 EQU DBL_88
    dbl_89 EQU DBL_89
    dbl_90 EQU DBL_90
    dbl_91 EQU DBL_91
    dbl_92 EQU DBL_92
    dbl_93 EQU DBL_93
    dbl_94 EQU DBL_94
    dbl_95 EQU DBL_95
    dbl_96 EQU DBL_96
    dbl_97 EQU DBL_97
    dbl_98 EQU DBL_98
    dbl_99 EQU DBL_99
    dbl_100 EQU DBL_100
    dbl_125 EQU DBL_125
    dbl_126 EQU DBL_126
    dbl_127 EQU DBL_127
    dbl_128 EQU DBL_128
    dbl_140 EQU DBL_140
    dbl_145 EQU DBL_145
    dbl_150 EQU DBL_150
    dbl_180 EQU DBL_180
    dbl_253 EQU DBL_253
    dbl_254 EQU DBL_254
    dbl_255 EQU DBL_255
    dbl_256 EQU DBL_256
    dbl_360 EQU DBL_360
    dbl_511 EQU DBL_511
    dbl_512 EQU DBL_512
    dbl_513 EQU DBL_513
    dbl_1023 EQU DBL_1023
    dbl_1024 EQU DBL_1024
    dbl_1025 EQU DBL_1025

    dbl_32767 EQU DBL_32767
    dbl_32768 EQU DBL_32768
    dbl_65535 EQU DBL_65535
    dbl_65536 EQU DBL_65536
    dbl_2147483647 EQU DBL_2147483647
    dbl_2147483648 EQU DBL_2147483648
    dbl_4294967295 EQU DBL_4294967295
    dbl_4294967296 EQU DBL_4294967296

    dbl_neg0 EQU DBL_NEG0
    dbl_neg0d0001 EQU DBL_NEG0D0001
    dbl_neg0d0002 EQU DBL_NEG0D0002
    dbl_neg0d0003 EQU DBL_NEG0D0003
    dbl_neg0d0004 EQU DBL_NEG0D0004
    dbl_neg0d0005 EQU DBL_NEG0D0005
    dbl_neg0d0006 EQU DBL_NEG0D0006
    dbl_neg0d0007 EQU DBL_NEG0D0007
    dbl_neg0d0008 EQU DBL_NEG0D0008
    dbl_neg0d0009 EQU DBL_NEG0D0009
    dbl_neg0d001 EQU DBL_NEG0D001
    dbl_neg0d002 EQU DBL_NEG0D002
    dbl_neg0d003 EQU DBL_NEG0D003
    dbl_neg0d004 EQU DBL_NEG0D004
    dbl_neg0d005 EQU DBL_NEG0D005
    dbl_neg0d006 EQU DBL_NEG0D006
    dbl_neg0d007 EQU DBL_NEG0D007
    dbl_neg0d008 EQU DBL_NEG0D008
    dbl_neg0d009 EQU DBL_NEG0D009
    dbl_neg0d01 EQU DBL_NEG0D01
    dbl_neg0d02 EQU DBL_NEG0D02
    dbl_neg0d025 EQU DBL_NEG0D025
    dbl_neg0d03 EQU DBL_NEG0D03
    dbl_neg0d04 EQU DBL_NEG0D04
    dbl_neg0d05 EQU DBL_NEG0D05
    dbl_neg0d06 EQU DBL_NEG0D06
    dbl_neg0d07 EQU DBL_NEG0D07
    dbl_neg0d08 EQU DBL_NEG0D08
    dbl_neg0d09 EQU DBL_NEG0D09
    dbl_neg0d1 EQU DBL_NEG0D1
    dbl_neg0d2 EQU DBL_NEG0D2
    dbl_neg0d25 EQU DBL_NEG0D25
    dbl_neg0d3 EQU DBL_NEG0D3
    dbl_neg0d4 EQU DBL_NEG0D4
    dbl_neg0d5 EQU DBL_NEG0D5
    dbl_neg0d6 EQU DBL_NEG0D6
    dbl_neg0d7 EQU DBL_NEG0D7
    dbl_neg0d8 EQU DBL_NEG0D8
    dbl_neg0d9 EQU DBL_NEG0D9
    dbl_neg1 EQU DBL_NEG1
    dbl_neg1d25 EQU DBL_NEG1D25
    dbl_neg1d5 EQU DBL_NEG1D5
    dbl_neg2 EQU DBL_NEG2
    dbl_neg2d25 EQU DBL_NEG2D25
    dbl_neg2d5 EQU DBL_NEG2D5
    dbl_neg3 EQU DBL_NEG3
    dbl_neg3d25 EQU DBL_NEG3D25
    dbl_neg3d5 EQU DBL_NEG3D5
    dbl_neg4 EQU DBL_NEG4
    dbl_neg4d25 EQU DBL_NEG4D25
    dbl_neg4d5 EQU DBL_NEG4D5
    dbl_neg5 EQU DBL_NEG5
    dbl_neg5d25 EQU DBL_NEG5D25
    dbl_neg5d5 EQU DBL_NEG5D5
    dbl_neg6 EQU DBL_NEG6
    dbl_neg6d25 EQU DBL_NEG6D25
    dbl_neg6d5 EQU DBL_NEG6D5
    dbl_neg7 EQU DBL_NEG7
    dbl_neg7d25 EQU DBL_NEG7D25
    dbl_neg7d5 EQU DBL_NEG7D5
    dbl_neg8 EQU DBL_NEG8
    dbl_neg8d25 EQU DBL_NEG8D25
    dbl_neg8d5 EQU DBL_NEG8D5
    dbl_neg9 EQU DBL_NEG9
    dbl_neg9d25 EQU DBL_NEG9D25
    dbl_neg9d5 EQU DBL_NEG9D5
    dbl_neg10 EQU DBL_NEG10
    dbl_neg11 EQU DBL_NEG11
    dbl_neg12 EQU DBL_NEG12
    dbl_neg13 EQU DBL_NEG13
    dbl_neg14 EQU DBL_NEG14
    dbl_neg15 EQU DBL_NEG15
    dbl_neg16 EQU DBL_NEG16
    dbl_neg17 EQU DBL_NEG17
    dbl_neg18 EQU DBL_NEG18
    dbl_neg19 EQU DBL_NEG19
    dbl_neg20 EQU DBL_NEG20
    dbl_neg21 EQU DBL_NEG21
    dbl_neg22 EQU DBL_NEG22
    dbl_neg23 EQU DBL_NEG23
    dbl_neg24 EQU DBL_NEG24
    dbl_neg24d5 EQU DBL_NEG24D5
    dbl_neg25 EQU DBL_NEG25
    dbl_neg26 EQU DBL_NEG26
    dbl_neg27 EQU DBL_NEG27
    dbl_neg28 EQU DBL_NEG28
    dbl_neg29 EQU DBL_NEG29
    dbl_neg30 EQU DBL_NEG30
    dbl_neg31 EQU DBL_NEG31
    dbl_neg32 EQU DBL_NEG32
    dbl_neg33 EQU DBL_NEG33
    dbl_neg34 EQU DBL_NEG34
    dbl_neg35 EQU DBL_NEG35
    dbl_neg36 EQU DBL_NEG36
    dbl_neg37 EQU DBL_NEG37
    dbl_neg38 EQU DBL_NEG38
    dbl_neg39 EQU DBL_NEG39
    dbl_neg40 EQU DBL_NEG40
    dbl_neg41 EQU DBL_NEG41
    dbl_neg42 EQU DBL_NEG42
    dbl_neg43 EQU DBL_NEG43
    dbl_neg44 EQU DBL_NEG44
    dbl_neg45 EQU DBL_NEG45
    dbl_neg46 EQU DBL_NEG46
    dbl_neg47 EQU DBL_NEG47
    dbl_neg48 EQU DBL_NEG48
    dbl_neg49 EQU DBL_NEG49
    dbl_neg50 EQU DBL_NEG50
    dbl_neg51 EQU DBL_NEG51
    dbl_neg52 EQU DBL_NEG52
    dbl_neg53 EQU DBL_NEG53
    dbl_neg54 EQU DBL_NEG54
    dbl_neg55 EQU DBL_NEG55
    dbl_neg56 EQU DBL_NEG56
    dbl_neg57 EQU DBL_NEG57
    dbl_neg58 EQU DBL_NEG58
    dbl_neg59 EQU DBL_NEG59
    dbl_neg60 EQU DBL_NEG60
    dbl_neg61 EQU DBL_NEG61
    dbl_neg62 EQU DBL_NEG62
    dbl_neg63 EQU DBL_NEG63
    dbl_neg64 EQU DBL_NEG64
    dbl_neg65 EQU DBL_NEG65
    dbl_neg66 EQU DBL_NEG66
    dbl_neg67 EQU DBL_NEG67
    dbl_neg68 EQU DBL_NEG68
    dbl_neg69 EQU DBL_NEG69
    dbl_neg70 EQU DBL_NEG70
    dbl_neg71 EQU DBL_NEG71
    dbl_neg72 EQU DBL_NEG72
    dbl_neg73 EQU DBL_NEG73
    dbl_neg74 EQU DBL_NEG74
    dbl_neg75 EQU DBL_NEG75
    dbl_neg76 EQU DBL_NEG76
    dbl_neg77 EQU DBL_NEG77
    dbl_neg78 EQU DBL_NEG78
    dbl_neg79 EQU DBL_NEG79
    dbl_neg80 EQU DBL_NEG80
    dbl_neg81 EQU DBL_NEG81
    dbl_neg82 EQU DBL_NEG82
    dbl_neg83 EQU DBL_NEG83
    dbl_neg84 EQU DBL_NEG84
    dbl_neg85 EQU DBL_NEG85
    dbl_neg86 EQU DBL_NEG86
    dbl_neg87 EQU DBL_NEG87
    dbl_neg88 EQU DBL_NEG88
    dbl_neg89 EQU DBL_NEG89
    dbl_neg90 EQU DBL_NEG90
    dbl_neg91 EQU DBL_NEG91
    dbl_neg92 EQU DBL_NEG92
    dbl_neg93 EQU DBL_NEG93
    dbl_neg94 EQU DBL_NEG94
    dbl_neg95 EQU DBL_NEG95
    dbl_neg96 EQU DBL_NEG96
    dbl_neg97 EQU DBL_NEG97
    dbl_neg98 EQU DBL_NEG98
    dbl_neg99 EQU DBL_NEG99
    dbl_neg100 EQU DBL_NEG100
    dbl_neg125 EQU DBL_NEG125
    dbl_neg126 EQU DBL_NEG126
    dbl_neg127 EQU DBL_NEG127
    dbl_neg128 EQU DBL_NEG128
    dbl_neg140 EQU DBL_NEG140
    dbl_neg145 EQU DBL_NEG145
    dbl_neg150 EQU DBL_NEG150
    dbl_neg180 EQU DBL_NEG180
    dbl_neg253 EQU DBL_NEG253
    dbl_neg254 EQU DBL_NEG254
    dbl_neg255 EQU DBL_NEG255
    dbl_neg256 EQU DBL_NEG256
    dbl_neg360 EQU DBL_NEG360
    dbl_neg511 EQU DBL_NEG511
    dbl_neg512 EQU DBL_NEG512
    dbl_neg513 EQU DBL_NEG513
    dbl_neg1023 EQU DBL_NEG1023
    dbl_neg1024 EQU DBL_NEG1024
    dbl_neg1025 EQU DBL_NEG1025

    dbl_neg32767 EQU DBL_NEG32767
    dbl_neg32768 EQU DBL_NEG32768
    dbl_neg65535 EQU DBL_NEG65535
    dbl_neg65536 EQU DBL_NEG65536
    dbl_neg2147483647 EQU DBL_NEG2147483647
    dbl_neg2147483648 EQU DBL_NEG2147483648
    dbl_neg4294967295 EQU DBL_NEG4294967295
    dbl_neg4294967296 EQU DBL_NEG4294967296

    dbl_bin128 EQU DBL_BIN128
    dbl_binneg150 EQU DBL_BINNEG150

    dbl_maxrand EQU DBL_MAXRAND

    dbl_maxi8 EQU DBL_MAXI8
    dbl_mini8 EQU DBL_MINI8
    dbl_maxu8 EQU DBL_MAXU8

    dbl_maxi16 EQU DBL_MAXI16
    dbl_mini16 EQU DBL_MINI16
    dbl_maxu16 EQU DBL_MAXU16

    dbl_maxi32 EQU DBL_MAXI32
    dbl_mini32 EQU DBL_MINI32
    dbl_maxu32 EQU DBL_MAXU32

    dbl_maxi64 EQU DBL_MAXI64
    dbl_mini64 EQU DBL_MINI64
    dbl_maxu64 EQU DBL_MAXU64

    dbl_maxi8xu8 EQU DBL_MAXI8XU8
    dbl_mini8xu8 EQU DBL_MINI8XU8
    dbl_maxi8xu16 EQU DBL_MAXI8XU16
    dbl_mini8xu16 EQU DBL_MINI8XU16

    dbl_maxi16xu16 EQU DBL_MAXI16XU16
    dbl_mini16xu16 EQU DBL_MINI16XU16
    dbl_maxi16xu32 EQU DBL_MAXI16XU32
    dbl_mini16xu32 EQU DBL_MINI16XU32

    dbl_maxi32xu32 EQU DBL_MAXI32XU32
    dbl_mini32xu32 EQU DBL_MINI32XU32

    dbl_fixunsigned EQU DBL_FIXUNSIGNED
    dbl_fixunsigned32 EQU DBL_FIXUNSIGNED32
    dbl_fixmaxi32 EQU DBL_FIXMAXI32
    dbl_fixmaxu32 EQU DBL_FIXMAXU32

    dbl_fixunsigned64 EQU DBL_FIXUNSIGNED64
    dbl_fixmaxi64 EQU DBL_FIXMAXI64
    dbl_fixmaxu64 EQU DBL_FIXMAXU64

    dbl_rcpi16 EQU DBL_RCPI16
    dbl_rcpu16 EQU DBL_RCPU16
    dbl_rcpi16xu16 EQU DBL_RCPI16XU16

    dbl_mg EQU DBL_MG
    dbl_negmg EQU DBL_NEGMG
    dbl_halfmg EQU DBL_HALFMG
    dbl_neghalfmg EQU DBL_NEGHALFMG
    dbl_mgdiv4 EQU DBL_MGDIV4
    dbl_negmgdiv4 EQU DBL_NEGMGDIV4
    dbl_halfmgxmg EQU DBL_HALFMGXMG
    dbl_halfmgxsqrmg EQU DBL_HALFMGXSQRMG
    dbl_halfmgxcubemg EQU DBL_HALFMGXCUBEMG
    dbl_neghalfmgxmg EQU DBL_NEGHALFMGXMG
    dbl_neghalfmgxsqrmg EQU DBL_NEGHALFMGXSQRMG
    dbl_neghalfmgxcubemg EQU DBL_NEGHALFMGXCUBEMG
    dbl_sqrmg EQU DBL_SQRMG
    dbl_cubemg EQU DBL_CUBEMG
    dbl_sqrtmg EQU DBL_SQRTMG
    dbl_cbrtmg EQU DBL_CBRTMG
    dbl_rcpmg EQU DBL_RCPMG
    dbl_rcpsqrmg EQU DBL_RCPSQRMG
    dbl_rcpcubemg EQU DBL_RCPCUBEMG
    dbl_rcpsqrtmg EQU DBL_RCPSQRTMG
    dbl_rcpcbrtmg EQU DBL_RCPCBRTMG

    dbl_2mg EQU DBL_2MG
    dbl_neg2mg EQU DBL_NEG2MG
    dbl_sqr2mg EQU DBL_SQR2MG
    dbl_cube2mg EQU DBL_CUBE2MG
    dbl_sqrt2mg EQU DBL_SQRT2MG
    dbl_cbrt2mg EQU DBL_CBRT2MG
    dbl_4mg EQU DBL_4MG
    dbl_neg4mg EQU DBL_NEG4MG
    dbl_sqr4mg EQU DBL_SQR4MG
    dbl_cube4mg EQU DBL_CUBE4MG
    dbl_sqrt4mg EQU DBL_SQRT4MG
    dbl_cbrt4mg EQU DBL_CBRT4MG
    dbl_rcp2mg EQU DBL_RCP2MG
    dbl_rcp4mg EQU DBL_RCP4MG

    dbl_e EQU DBL_E
    dbl_exp EQU DBL_EXP
    dbl_loge EQU DBL_LOGE
    dbl_logehigh EQU DBL_LOGEHIGH
    dbl_logelow EQU DBL_LOGELOW
    dbl_log2e EQU DBL_LOG2E
    dbl_log2ehigh EQU DBL_LOG2EHIGH
    dbl_log2elow EQU DBL_LOG2ELOW
    dbl_log10e EQU DBL_LOG10E
    dbl_rcplog2e EQU DBL_RCPLOG2E
    dbl_rcplog10e EQU DBL_RCPLOG10E
    dbl_log2t EQU DBL_LOG2T
    dbl_log2 EQU DBL_LOG2
    dbl_log2high EQU DBL_LOG2HIGH
    dbl_log2low EQU DBL_LOG2LOW
    dbl_ln2 EQU DBL_LN2
    dbl_ln2high EQU DBL_LN2HIGH
    dbl_ln2low EQU DBL_LN2LOW
    dbl_1divln2 EQU DBL_1DIVLN2
    dbl_2divln2 EQU DBL_2DIVLN2
    dbl_lnt EQU DBL_LNT
    dbl_lnthigh EQU DBL_LNTHIGH
    dbl_lntlow EQU DBL_LNTLOW
    dbl_ln10 EQU DBL_LN10
    dbl_sqrt2 EQU DBL_SQRT2
    dbl_rcpsqrt2 EQU DBL_RCPSQRT2
    dbl_sqrt2div2 EQU DBL_SQRT2DIV2
    dbl_sqrt2div2high EQU DBL_SQRT2DIV2HIGH
    dbl_sqrt2div2low EQU DBL_SQRT2DIV2LOW
    dbl_sqrthalf EQU DBL_SQRTHALF
    dbl_sqrthalfhigh EQU DBL_SQRTHALFHIGH
    dbl_sqrthalflow EQU DBL_SQRTHALFLOW
    dbl_pow2 EQU DBL_POW2
    dbl_rcppow2 EQU DBL_RCPPOW2
    dbl_cbrt2 EQU DBL_CBRT2
    dbl_rcpcbrt2 EQU DBL_RCPCBRT2
    dbl_1div3 EQU DBL_1DIV3
    dbl_1div7 EQU DBL_1DIV7
    dbl_1div9 EQU DBL_1DIV9
    dbl_2div3 EQU DBL_2DIV3
    dbl_2div7 EQU DBL_2DIV7
    dbl_2div9 EQU DBL_2DIV9
    dbl_4div3 EQU DBL_4DIV3
    dbl_4div7 EQU DBL_4DIV7
    dbl_4div9 EQU DBL_4DIV9

    dbl_pi EQU DBL_PI
    dbl_pihigh EQU DBL_PIHIGH
    dbl_pilow EQU DBL_PILOW
    dbl_halfpi EQU DBL_HALFPI
    dbl_2pi EQU DBL_2PI
    dbl_negpi EQU DBL_NEGPI
    dbl_neghalfpi EQU DBL_NEGHALFPI
    dbl_neg2pi EQU DBL_NEG2PI
    dbl_rcppi EQU DBL_RCPPI
    dbl_invpi EQU DBL_INVPI
    dbl_rcp2pi EQU DBL_RCP2PI
    dbl_inv2pi EQU DBL_INV2PI
    dbl_pidiv2 EQU DBL_PIDIV2
    dbl_pidiv2high EQU DBL_PIDIV2HIGH
    dbl_pidiv2low EQU DBL_PIDIV2LOW
    dbl_pidiv4 EQU DBL_PIDIV4
    dbl_pidiv4high EQU DBL_PIDIV4HIGH
    dbl_pidiv4low EQU DBL_PIDIV4LOW
    dbl_pix3div4 EQU DBL_PIX3DIV4
    dbl_sqrtpi EQU DBL_SQRTPI
    dbl_sqrt2pi EQU DBL_SQRT2PI
    dbl_sqrt2pihigh EQU DBL_SQRT2PIHIGH
    dbl_sqrt2pilow EQU DBL_SQRT2PILOW
    dbl_rcpsqrtpi EQU DBL_RCPSQRTPI
    dbl_rcpsqrt2pi EQU DBL_RCPSQRT2PI
    dbl_sqrtpidiv2 EQU DBL_SQRTPIDIV2
    dbl_sqrtpidiv2high EQU DBL_SQRTPIDIV2HIGH
    dbl_sqrt2pidiv2 EQU DBL_SQRT2PIDIV2
    dbl_sqrt2pidiv2high EQU DBL_SQRT2PIDIV2HIGH
    dbl_sqrt2pidiv2low EQU DBL_SQRT2PIDIV2LOW
    dbl_2divpi EQU DBL_2DIVPI
    dbl_2div2pi EQU DBL_2DIV2PI
    dbl_2divsqrtpi EQU DBL_2DIVSQRTPI
    dbl_2divsqrt2pi EQU DBL_2DIVSQRT2PI
    dbl_sqrt2divpi EQU DBL_SQRT2DIVPI
    dbl_logpi EQU DBL_LOGPI
    dbl_log2pi EQU DBL_LOG2PI
    dbl_lnpi EQU DBL_LNPI
    dbl_ln2pi EQU DBL_LN2PI
    dbl_powpi EQU DBL_POWPI
    dbl_rcppowpi EQU DBL_RCPPOWPI
    dbl_pow2pi EQU DBL_POW2PI
    dbl_rcppow2pi EQU DBL_RCPPOW2PI
    dbl_cbrtpi EQU DBL_CBRTPI
    dbl_rcpcbrtpi EQU DBL_RCPCBRTPI
    dbl_cbrt2pi EQU DBL_CBRT2PI
    dbl_rcpcbrt2pi EQU DBL_RCPCBRT2PI

    dbl_ln2x1024 EQU DBL_LN2X1024
    dbl_ln2x1025 EQU DBL_LN2X1025
    dbl_ln2x1075 EQU DBL_LN2X1075
    dbl_log2x1024 EQU DBL_LOG2X1024
    dbl_log2x1075 EQU DBL_LOG2X1075

    dbl_pow2tom126 EQU DBL_POW2TOM126
    dbl_pow2to126 EQU DBL_POW2TO126
    dbl_normhuge EQU DBL_NORMHUGE
    dbl_pow2to23 EQU DBL_POW2TO23
    dbl_pow2to24 EQU DBL_POW2TO24
    dbl_maxi32pow2to23 EQU DBL_MAXI32POW2TO23
    dbl_pow2to31 EQU DBL_POW2TO31
    dbl_pow2to32 EQU DBL_POW2TO32
    dbl_pow2to52 EQU DBL_POW2TO52
    dbl_pow2to53 EQU DBL_POW2TO53
    dbl_pow2to54 EQU DBL_POW2TO54
    dbl_pow2tom54 EQU DBL_POW2TOM54
    dbl_pow2to62 EQU DBL_POW2TO62
    dbl_maxi64pow2to52 EQU DBL_MAXI64POW2TO52
    dbl_pow2to63 EQU DBL_POW2TO63
    dbl_pow2to64 EQU DBL_POW2TO64
    dbl_pow2tom1022 EQU DBL_POW2TOM1022
    dbl_trigploss EQU DBL_TRIGPLOSS

    dbl_degtorad EQU DBL_DEGTORAD
    dbl_radtodeg EQU DBL_RADTODEG

    dbl_degtograd EQU DBL_DEGTOGRAD
    dbl_gradtodeg EQU DBL_GRADTODEG

    dbl_radtograd EQU DBL_RADTOGRAD
    dbl_gradtorad EQU DBL_GRADTORAD

    dbl_sungravity EQU DBL_SUNGRAVITY
    dbl_jupitergravity EQU DBL_JUPITERGRAVITY
    dbl_neptunegravity EQU DBL_NEPTUNEGRAVITY
    dbl_saturngravity EQU DBL_SATURNGRAVITY
    dbl_uranusgravity EQU DBL_URANUSGRAVITY
    dbl_earthgravity EQU DBL_EARTHGRAVITY
    dbl_venusgravity EQU DBL_VENUSGRAVITY
    dbl_marsgravity EQU DBL_MARSGRAVITY
    dbl_mercurygravity EQU DBL_MERCURYGRAVITY
    dbl_moongravity EQU DBL_MOONGRAVITY
    dbl_plutogravity EQU DBL_PLUTOGRAVITY

    dbl_kmtoinch EQU DBL_KMTOINCH
    dbl_kmtofeet EQU DBL_KMTOFEET
    dbl_kmtoyards EQU DBL_KMTOYARDS
    dbl_kmtomiles EQU DBL_KMTOMILES

    dbl_metoinch EQU DBL_METOINCH
    dbl_metofeet EQU DBL_METOFEET
    dbl_metoyards EQU DBL_METOYARDS
    dbl_metomiles EQU DBL_METOMILES

    dbl_cmtoinch EQU DBL_CMTOINCH
    dbl_cmtofeet EQU DBL_CMTOFEET
    dbl_cmtoyards EQU DBL_CMTOYARDS
    dbl_cmtomiles EQU DBL_CMTOMILES

    dbl_milltoinch EQU DBL_MILLTOINCH
    dbl_milltofeet EQU DBL_MILLTOFEET
    dbl_milltoyards EQU DBL_MILLTOYARDS
    dbl_milltomiles EQU DBL_MILLTOMILES

    dbl_inchtomill EQU DBL_INCHTOMILL
    dbl_inchtocm EQU DBL_INCHTOCM
    dbl_inchtome EQU DBL_INCHTOME
    dbl_inchtokm EQU DBL_INCHTOKM
    dbl_inchtofeet EQU DBL_INCHTOFEET
    dbl_inchtoyards EQU DBL_INCHTOYARDS
    dbl_inchtomiles EQU DBL_INCHTOMILES

    dbl_feettomill EQU DBL_FEETTOMILL
    dbl_feettocm EQU DBL_FEETTOCM
    dbl_feettome EQU DBL_FEETTOME
    dbl_feettokm EQU DBL_FEETTOKM
    dbl_feettoinch EQU DBL_FEETTOINCH
    dbl_feettoyards EQU DBL_FEETTOYARDS
    dbl_feettomiles EQU DBL_FEETTOMILES

    dbl_yardstomill EQU DBL_YARDSTOMILL
    dbl_yardstocm EQU DBL_YARDSTOCM
    dbl_yardstome EQU DBL_YARDSTOME
    dbl_yardstokm EQU DBL_YARDSTOKM
    dbl_yardstoinch EQU DBL_YARDSTOINCH
    dbl_yardstofeet EQU DBL_YARDSTOFEET
    dbl_yardstomiles EQU DBL_YARDSTOMILES

    dbl_milestomill EQU DBL_MILESTOMILL
    dbl_milestocm EQU DBL_MILESTOCM
    dbl_milestome EQU DBL_MILESTOME
    dbl_milestokm EQU DBL_MILESTOKM
    dbl_milestoinch EQU DBL_MILESTOINCH
    dbl_milestofeet EQU DBL_MILESTOFEET
    dbl_milestoyards EQU DBL_MILESTOYARDS

    dbl_kmphtomeps EQU DBL_KMPHTOMEPS
    dbl_kmphtokmps EQU DBL_KMPHTOKMPS
    dbl_kmphtomepm EQU DBL_KMPHTOMEPM
    dbl_kmphtomilesph EQU DBL_KMPHTOMILESPH
    dbl_kmphtomilesps EQU DBL_KMPHTOMILESPS
    dbl_kmphtofeetps EQU DBL_KMPHTOFEETPS
    dbl_kmphtofeetpm EQU DBL_KMPHTOFEETPM

    dbl_kmpstomeps EQU DBL_KMPSTOMEPS
    dbl_kmpstokmph EQU DBL_KMPSTOKMPH
    dbl_kmpstomepm EQU DBL_KMPSTOMEPM
    dbl_kmpstomilesph EQU DBL_KMPSTOMILESPH
    dbl_kmpstomilesps EQU DBL_KMPSTOMILESPS
    dbl_kmpstofeetps EQU DBL_KMPSTOFEETPS
    dbl_kmpstofeetpm EQU DBL_KMPSTOFEETPM

    dbl_mepstokmph EQU DBL_MEPSTOKMPH
    dbl_mepstokmps EQU DBL_MEPSTOKMPS
    dbl_mepstomepm EQU DBL_MEPSTOMEPM
    dbl_mepstomilesph EQU DBL_MEPSTOMILESPH
    dbl_mepstomilesps EQU DBL_MEPSTOMILESPS
    dbl_mepstofeetps EQU DBL_MEPSTOFEETPS
    dbl_mepstofeetpm EQU DBL_MEPSTOFEETPM

    dbl_mepmtokmph EQU DBL_MEPMTOKMPH
    dbl_mepmtokmps EQU DBL_MEPMTOKMPS
    dbl_mepmtomeps EQU DBL_MEPMTOMEPS
    dbl_mepmtomilesph EQU DBL_MEPMTOMILESPH
    dbl_mepmtomilesps EQU DBL_MEPMTOMILESPS
    dbl_mepmtofeetps EQU DBL_MEPMTOFEETPS
    dbl_mepmtofeetpm EQU DBL_MEPMTOFEETPM

    dbl_milesphtokmph EQU DBL_MILESPHTOKMPH
    dbl_milesphtokmps EQU DBL_MILESPHTOKMPS
    dbl_milesphtomeps EQU DBL_MILESPHTOMEPS
    dbl_milesphtomepm EQU DBL_MILESPHTOMEPM
    dbl_milesphtomilesps EQU DBL_MILESPHTOMILESPS
    dbl_milesphtofeetps EQU DBL_MILESPHTOFEETPS
    dbl_milesphtofeetpm EQU DBL_MILESPHTOFEETPM

    dbl_milespstokmph EQU DBL_MILESPSTOKMPH
    dbl_milespstokmps EQU DBL_MILESPSTOKMPS
    dbl_milespstomeps EQU DBL_MILESPSTOMEPS
    dbl_milespstomepm EQU DBL_MILESPSTOMEPM
    dbl_milespstomilesph EQU DBL_MILESPSTOMILESPH
    dbl_milespstofeetps EQU DBL_MILESPSTOFEETPS
    dbl_milespstofeetpm EQU DBL_MILESPSTOFEETPM

    dbl_feetpstokmph EQU DBL_FEETPSTOKMPH
    dbl_feetpstokmps EQU DBL_FEETPSTOKMPS
    dbl_feetpstomeps EQU DBL_FEETPSTOMEPS
    dbl_feetpstomepm EQU DBL_FEETPSTOMEPM
    dbl_feetpstomilesph EQU DBL_FEETPSTOMILESPH
    dbl_feetpstomilesps EQU DBL_FEETPSTOMILESPS
    dbl_feetpstofeetpm EQU DBL_FEETPSTOFEETPM

    dbl_feetpmtokmph EQU DBL_FEETPMTOKMPH
    dbl_feetpmtokmps EQU DBL_FEETPMTOKMPS
    dbl_feetpmtomeps EQU DBL_FEETPMTOMEPS
    dbl_feetpmtomepm EQU DBL_FEETPMTOMEPM
    dbl_feetpmtomilesph EQU DBL_FEETPMTOMILESPH
    dbl_feetpmtomilesps EQU DBL_FEETPMTOMILESPS
    dbl_feetpmtofeetps EQU DBL_FEETPMTOFEETPS

    dbl_soundspeedp50c EQU DBL_SOUNDSPEEDP50C
    dbl_soundspeedp45c EQU DBL_SOUNDSPEEDP45C
    dbl_soundspeedp40c EQU DBL_SOUNDSPEEDP40C
    dbl_soundspeedp35c EQU DBL_SOUNDSPEEDP35C
    dbl_soundspeedp30c EQU DBL_SOUNDSPEEDP30C
    dbl_soundspeedp25c EQU DBL_SOUNDSPEEDP25C
    dbl_soundspeedp20c EQU DBL_SOUNDSPEEDP20C
    dbl_soundspeedp15c EQU DBL_SOUNDSPEEDP15C
    dbl_soundspeedp10c EQU DBL_SOUNDSPEEDP10C
    dbl_soundspeedp5c EQU DBL_SOUNDSPEEDP5C
    dbl_soundspeed0c EQU DBL_SOUNDSPEED0C
    dbl_soundspeedn5c EQU DBL_SOUNDSPEEDN5C
    dbl_soundspeedn10c EQU DBL_SOUNDSPEEDN10C
    dbl_soundspeedn15c EQU DBL_SOUNDSPEEDN15C
    dbl_soundspeedn20c EQU DBL_SOUNDSPEEDN20C
    dbl_soundspeedn25c EQU DBL_SOUNDSPEEDN25C
    dbl_soundspeedn30c EQU DBL_SOUNDSPEEDN30C
    dbl_soundspeedn35c EQU DBL_SOUNDSPEEDN35C
    dbl_soundspeedn40c EQU DBL_SOUNDSPEEDN40C
    dbl_soundspeedn45c EQU DBL_SOUNDSPEEDN45C
    dbl_soundspeedn50c EQU DBL_SOUNDSPEEDN50C

    dbl_schscale EQU DBL_SCHSCALE
    dbl_thscale EQU DBL_THSCALE

    dbl_expest1 EQU DBL_EXPEST1
    dbl_expest2 EQU DBL_EXPEST2
    dbl_expest3 EQU DBL_EXPEST3
    dbl_expest4 EQU DBL_EXPEST4
    dbl_expest5 EQU DBL_EXPEST5
    dbl_expest6 EQU DBL_EXPEST6
    dbl_expest7 EQU DBL_EXPEST7
    dbl_logest0 EQU DBL_LOGEST0
    dbl_logest1 EQU DBL_LOGEST1
    dbl_logest2 EQU DBL_LOGEST2
    dbl_logest3 EQU DBL_LOGEST3
    dbl_logest4 EQU DBL_LOGEST4
    dbl_logest5 EQU DBL_LOGEST5
    dbl_logest6 EQU DBL_LOGEST6
    dbl_logest7 EQU DBL_LOGEST7
    
    ENDIF ;CASEMAPNONE

    ENDIF ;WITHMACROLIB

    ENDIF    ;REAL8LIMITS_INC
